/* xnoise-db-reader.c generated by valac 0.16.0, the Vala compiler
 * generated from xnoise-db-reader.vala, do not modify */

/* xnoise-db-reader.vala
 *
 * Copyright (C) 2009-2012  Jörn Magens
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  The Xnoise authors hereby grant permission for non-GPL compatible
 *  GStreamer plugins to be used and distributed together with GStreamer
 *  and Xnoise. This permission is above and beyond the permissions granted
 *  by the GPL license by which Xnoise is covered. If you modify this code
 *  you may extend this exception to your version of the code, but you are not
 *  obligated to do so. If you do not wish to do so, delete this exception
 *  statement from your version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301  USA.
 *
 * Author:
 *     Jörn Magens
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <sqlite3.h>
#include <stdio.h>
#include <glib/gi18n-lib.h>
#include <gio/gio.h>
#include <gobject/gvaluecollector.h>


#define XNOISE_DATABASE_TYPE_READER (xnoise_database_reader_get_type ())
#define XNOISE_DATABASE_READER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), XNOISE_DATABASE_TYPE_READER, XnoiseDatabaseReader))
#define XNOISE_DATABASE_READER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), XNOISE_DATABASE_TYPE_READER, XnoiseDatabaseReaderClass))
#define XNOISE_DATABASE_IS_READER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), XNOISE_DATABASE_TYPE_READER))
#define XNOISE_DATABASE_IS_READER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), XNOISE_DATABASE_TYPE_READER))
#define XNOISE_DATABASE_READER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), XNOISE_DATABASE_TYPE_READER, XnoiseDatabaseReaderClass))

typedef struct _XnoiseDatabaseReader XnoiseDatabaseReader;
typedef struct _XnoiseDatabaseReaderClass XnoiseDatabaseReaderClass;
typedef struct _XnoiseDatabaseReaderPrivate XnoiseDatabaseReaderPrivate;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _sqlite3_close0(var) ((var == NULL) ? NULL : (var = (sqlite3_close (var), NULL)))
#define _sqlite3_finalize0(var) ((var == NULL) ? NULL : (var = (sqlite3_finalize (var), NULL)))
#define _xnoise_database_reader_unref0(var) ((var == NULL) ? NULL : (var = (xnoise_database_reader_unref (var), NULL)))

#define XNOISE_TYPE_ITEM_TYPE (xnoise_item_type_get_type ())

#define XNOISE_TYPE_ITEM (xnoise_item_get_type ())
typedef struct _XnoiseItem XnoiseItem;

#define XNOISE_TYPE_TRACK_DATA (xnoise_track_data_get_type ())
#define XNOISE_TRACK_DATA(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), XNOISE_TYPE_TRACK_DATA, XnoiseTrackData))
#define XNOISE_TRACK_DATA_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), XNOISE_TYPE_TRACK_DATA, XnoiseTrackDataClass))
#define XNOISE_IS_TRACK_DATA(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), XNOISE_TYPE_TRACK_DATA))
#define XNOISE_IS_TRACK_DATA_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), XNOISE_TYPE_TRACK_DATA))
#define XNOISE_TRACK_DATA_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), XNOISE_TYPE_TRACK_DATA, XnoiseTrackDataClass))

typedef struct _XnoiseTrackData XnoiseTrackData;
typedef struct _XnoiseTrackDataClass XnoiseTrackDataClass;
typedef struct _XnoiseTrackDataPrivate XnoiseTrackDataPrivate;
#define _xnoise_item_free0(var) ((var == NULL) ? NULL : (var = (xnoise_item_free (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _xnoise_track_data_unref0(var) ((var == NULL) ? NULL : (var = (xnoise_track_data_unref (var), NULL)))
typedef struct _XnoiseDatabaseParamSpecReader XnoiseDatabaseParamSpecReader;

typedef enum  {
	XNOISE_DATABASE_DB_ERROR_FAILED
} XnoiseDatabaseDbError;
#define XNOISE_DATABASE_DB_ERROR xnoise_database_db_error_quark ()
struct _XnoiseDatabaseReader {
	GTypeInstance parent_instance;
	volatile int ref_count;
	XnoiseDatabaseReaderPrivate * priv;
};

struct _XnoiseDatabaseReaderClass {
	GTypeClass parent_class;
	void (*finalize) (XnoiseDatabaseReader *self);
};

struct _XnoiseDatabaseReaderPrivate {
	gchar* DATABASE;
	gboolean abort;
	sqlite3* db;
	sqlite3_stmt* get_artists_with_search_stmt;
	sqlite3_stmt* get_artists_with_search2_stmt;
};

typedef void (*XnoiseDatabaseReaderReaderCallback) (sqlite3* database, void* user_data);
typedef enum  {
	XNOISE_ITEM_TYPE_UNKNOWN = 0,
	XNOISE_ITEM_TYPE_LOCAL_AUDIO_TRACK,
	XNOISE_ITEM_TYPE_LOCAL_VIDEO_TRACK,
	XNOISE_ITEM_TYPE_STREAM,
	XNOISE_ITEM_TYPE_CDROM_TRACK,
	XNOISE_ITEM_TYPE_PLAYLIST,
	XNOISE_ITEM_TYPE_LOCAL_FOLDER,
	XNOISE_ITEM_TYPE_COLLECTION_CONTAINER_ARTIST,
	XNOISE_ITEM_TYPE_COLLECTION_CONTAINER_ALBUM,
	XNOISE_ITEM_TYPE_COLLECTION_CONTAINER_GENRE,
	XNOISE_ITEM_TYPE_COLLECTION_CONTAINER_YEAR,
	XNOISE_ITEM_TYPE_LOADER,
	XNOISE_ITEM_TYPE_CUSTOM_DATA_COL_ID,
	XNOISE_ITEM_TYPE_MAXCOUNT
} XnoiseItemType;

struct _XnoiseItem {
	XnoiseItemType type;
	gint32 db_id;
	gchar* uri;
	gchar* text;
};

struct _XnoiseTrackData {
	GTypeInstance parent_instance;
	volatile int ref_count;
	XnoiseTrackDataPrivate * priv;
	gchar* artist;
	gchar* album;
	gchar* title;
	gchar* genre;
	gchar* name;
	gchar* mimetype;
	guint year;
	guint tracknumber;
	gint32 length;
	gint bitrate;
	XnoiseItem* item;
	gint32 dat1;
	gint32 dat2;
};

struct _XnoiseTrackDataClass {
	GTypeClass parent_class;
	void (*finalize) (XnoiseTrackData *self);
};

struct _XnoiseDatabaseParamSpecReader {
	GParamSpec parent_instance;
};


static gpointer xnoise_database_reader_parent_class = NULL;

GQuark xnoise_database_db_error_quark (void);
gpointer xnoise_database_reader_ref (gpointer instance);
void xnoise_database_reader_unref (gpointer instance);
GParamSpec* xnoise_database_param_spec_reader (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void xnoise_database_value_set_reader (GValue* value, gpointer v_object);
void xnoise_database_value_take_reader (GValue* value, gpointer v_object);
gpointer xnoise_database_value_get_reader (const GValue* value);
GType xnoise_database_reader_get_type (void) G_GNUC_CONST;
#define XNOISE_DATABASE_READER_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), XNOISE_DATABASE_TYPE_READER, XnoiseDatabaseReaderPrivate))
enum  {
	XNOISE_DATABASE_READER_DUMMY_PROPERTY
};
#define XNOISE_DATABASE_READER_DATABASE_NAME "db.sqlite"
#define XNOISE_DATABASE_READER_SETTINGS_FOLDER ".xnoise"
#define XNOISE_DATABASE_READER_STMT_GET_LASTUSED "SELECT uri FROM lastused"
#define XNOISE_DATABASE_READER_STMT_GET_RADIOS "SELECT name, uri FROM streams"
#define XNOISE_DATABASE_READER_STMT_GET_MEDIA_FOLDERS "SELECT * FROM media_folders"
#define XNOISE_DATABASE_READER_STMT_GET_MEDIA_FILES "SELECT * FROM media_files"
#define XNOISE_DATABASE_READER_STMT_GET_RADIO_DATA "SELECT DISTINCT id, name, uri FROM streams WHERE utf8_lower(name) LIKE" \
" ? ORDER BY name COLLATE CUSTOM01 DESC"
#define XNOISE_DATABASE_READER_STMT_GET_VIDEO_COUNT "SELECT COUNT (t.id) FROM items t WHERE t.mediatype=? AND (utf8_lower(t" \
".title) LIKE ?)"
#define XNOISE_DATABASE_READER_STMT_GET_LAST_PLAYED "SELECT ar.name, t.title, t.mediatype, t.id, u.name, st.lastplayTime FR" \
"OM artists ar, items t, albums al, uris u, statistics st WHERE st.last" \
"playTime > 0 AND t.artist = ar.id AND t.album = al.id AND t.uri = u.id" \
" AND st.uri = u.name AND (utf8_lower(ar.name) LIKE ? OR utf8_lower(al." \
"name) LIKE ? OR utf8_lower(t.title) LIKE ?) ORDER BY st.lastplayTime D" \
"ESC LIMIT 100"
#define XNOISE_DATABASE_READER_STMT_GET_MOST_PLAYED "SELECT ar.name, t.title, t.mediatype, t.id, u.name, st.playcount FROM " \
"artists ar, items t, albums al, uris u, statistics st WHERE st.playcou" \
"nt > 0 AND t.artist = ar.id AND t.album = al.id AND t.uri = u.id AND s" \
"t.uri = u.name AND (utf8_lower(ar.name) LIKE ? OR utf8_lower(al.name) " \
"LIKE ? OR utf8_lower(t.title) LIKE ?) ORDER BY st.playcount DESC LIMIT" \
" 100"
#define XNOISE_DATABASE_READER_STMT_ALL_TRACKDATA "SELECT ar.name, al.name, t.title, t.tracknumber, t.mediatype, u.name, " \
"t.length, t.id, g.name, t.year FROM artists ar, items t, albums al, ur" \
"is u, genres g WHERE t.artist = ar.id AND t.album = al.id AND t.uri = " \
"u.id AND t.genre = g.id AND (utf8_lower(ar.name) LIKE ? OR utf8_lower(" \
"al.name) LIKE ? OR utf8_lower(t.title) LIKE ?) and t.mediatype = ? ORD" \
"ER BY utf8_lower(ar.name) COLLATE CUSTOM01 ASC, utf8_lower(al.name) CO" \
"LLATE CUSTOM01 ASC, t.tracknumber ASC"
#define XNOISE_DATABASE_READER_STMT_GET_STREAMITEM_BY_ID "SELECT DISTINCT st.id, st.uri, st.name FROM streams st WHERE st.id = ?" \
" AND (utf8_lower(st.name) LIKE ? OR utf8_lower(st.uri) LIKE ?) ORDER B" \
"Y utf8_lower(st.name) COLLATE CUSTOM01 DESC"
#define XNOISE_DATABASE_READER_STMT_STREAM_TD_FOR_ID "SELECT name, uri FROM streams WHERE id = ?"
#define XNOISE_DATABASE_READER_STMT_TRACKDATA_FOR_URI "SELECT ar.name, al.name, t.title, t.tracknumber, t.length, t.mediatype" \
", t.id, g.name, t.year FROM artists ar, items t, albums al, uris u, ge" \
"nres g WHERE t.artist = ar.id AND t.album = al.id AND t.uri = u.id AND" \
" t.genre = g.id AND u.name = ?"
#define XNOISE_DATABASE_READER_STMT_GET_STREAM_ITEMS_WITH_SEARCH "SELECT DISTINCT s.id, s.uri, s.name FROM streams s WHERE utf8_lower(s." \
"name) LIKE ? ORDER BY utf8_lower(s.name) COLLATE CUSTOM01 DESC"
#define XNOISE_DATABASE_READER_STMT_GET_SOME_LASTUSED_ITEMS "SELECT mediatype, uri, id FROM lastused LIMIT ? OFFSET ?"
#define XNOISE_DATABASE_READER_STMT_CNT_LASTUSED "SELECT COUNT(mediatype) FROM lastused"
#define XNOISE_DATABASE_READER_STMT_GET_STREAM_DATA "SELECT DISTINCT s.id, s.uri, s.name FROM streams s WHERE utf8_lower(s." \
"name) LIKE ? ORDER BY utf8_lower(s.name) COLLATE CUSTOM01 DESC"
#define XNOISE_DATABASE_READER_STMT_GET_VIDEO_ITEMS "SELECT DISTINCT t.title, t.id, u.name FROM items t, uris u WHERE t.uri" \
" = u.id AND t.mediatype = ? AND (utf8_lower(t.title) LIKE ?) GROUP BY " \
"utf8_lower(t.title) ORDER BY utf8_lower(t.title) COLLATE CUSTOM01 DESC"
#define XNOISE_DATABASE_READER_STMT_GET_VIDEO_DATA "SELECT DISTINCT t.title, t.id, t.tracknumber, u.name, ar.name, al.name" \
", t.length, t.genre FROM artists ar, items t, albums al, uris u WHERE " \
"t.artist = ar.id AND t.album = al.id AND t.uri = u.id AND t.mediatype " \
"= ? AND (utf8_lower(t.title) LIKE ?) GROUP BY utf8_lower(t.title) ORDE" \
"R BY utf8_lower(t.title) COLLATE CUSTOM01 DESC"
#define XNOISE_DATABASE_READER_STMT_GET_TRACKDATA_FOR_VIDEO "SELECT DISTINCT t.title, t.id, t.tracknumber, u.name, ar.name, al.name" \
", t.length, g.name, t.year FROM artists ar, items t, albums al, uris u" \
", genres g WHERE t.artist = ar.id AND t.album = al.id AND t.uri = u.id" \
" AND t.genre = g.id AND t.mediatype = ? AND (utf8_lower(t.title) LIKE " \
"?) GROUP BY utf8_lower(t.title) ORDER BY utf8_lower(t.title) COLLATE C" \
"USTOM01 ASC"
#define XNOISE_DATABASE_READER_STMT_GET_TRACKDATA_FOR_STREAMS "SELECT DISTINCT s.id, s.uri, s.name FROM streams s WHERE utf8_lower(s." \
"name) LIKE ? OR utf8_lower(s.uri) LIKE ? ORDER BY utf8_lower(s.name) C" \
"OLLATE CUSTOM01 ASC"
#define XNOISE_DATABASE_READER_STMT_GET_ARTISTS_WITH_SEARCH "SELECT DISTINCT ar.id, ar.name FROM artists ar, items t, albums al WHE" \
"RE t.artist = ar.id AND t.album = al.id AND (utf8_lower(t.title) LIKE " \
"? OR utf8_lower(al.name) LIKE ? OR utf8_lower(ar.name) LIKE ?) AND t.m" \
"ediatype = ? ORDER BY utf8_lower(ar.name) COLLATE CUSTOM01 DESC"
#define XNOISE_DATABASE_READER_STMT_GET_ARTISTS "SELECT DISTINCT ar.id, ar.name FROM artists ar, items t WHERE t.artist" \
" = ar.id AND t.mediatype = ? ORDER BY utf8_lower(ar.name) COLLATE CUST" \
"OM01 DESC"
#define XNOISE_DATABASE_READER_STMT_GET_TRACKDATA_BY_ALBUMID_WITH_SEARCH "SELECT DISTINCT t.title, t.mediatype, t.id, t.tracknumber, u.name, ar." \
"name, al.name, t.length, g.name, t.year  FROM artists ar, items t, alb" \
"ums al, uris u, genres g WHERE t.artist = ar.id AND t.album = al.id AN" \
"D t.uri = u.id AND t.genre = g.id AND al.id = ? AND (utf8_lower(ar.nam" \
"e) LIKE ? OR utf8_lower(al.name) LIKE ? OR utf8_lower(t.title) LIKE ?)" \
" GROUP BY utf8_lower(t.title) ORDER BY t.tracknumber ASC, t.title COLL" \
"ATE CUSTOM01  ASC"
#define XNOISE_DATABASE_READER_STMT_GET_TRACKDATA_BY_ALBUMID "SELECT DISTINCT t.title, t.mediatype, t.id, t.tracknumber, u.name, ar." \
"name, al.name, t.length, g.name, t.year  FROM artists ar, items t, alb" \
"ums al, uris u, genres g WHERE t.artist = ar.id AND t.album = al.id AN" \
"D t.uri = u.id AND t.genre = g.id AND al.id = ? GROUP BY utf8_lower(t." \
"title) ORDER BY t.tracknumber ASC, t.title COLLATE CUSTOM01 ASC"
#define XNOISE_DATABASE_READER_STMT_GET_TRACKDATA_BY_ARTISTID_WITH_SEARCH "SELECT t.title, t.mediatype, t.id, t.tracknumber, u.name, ar.name, al." \
"name, t.length, g.name, t.year FROM artists ar, items t, albums al, ur" \
"is u, genres g  WHERE t.artist = ar.id AND t.album = al.id AND t.uri =" \
" u.id AND t.genre = g.id AND ar.id = ? AND (utf8_lower(ar.name) LIKE ?" \
" OR utf8_lower(al.name) LIKE ? OR utf8_lower(t.title) LIKE ?) GROUP BY" \
" utf8_lower(t.title), al.id ORDER BY al.name COLLATE CUSTOM01 ASC, t.t" \
"racknumber ASC, t.title COLLATE CUSTOM01 ASC"
#define XNOISE_DATABASE_READER_STMT_GET_TRACKDATA_BY_ARTISTID "SELECT t.title, t.mediatype, t.id, t.tracknumber, u.name, ar.name, al." \
"name, t.length, g.name, t.year  FROM artists ar, items t, albums al, u" \
"ris u, genres g WHERE t.artist = ar.id AND t.album = al.id AND t.uri =" \
" u.id AND t.genre = g.id AND ar.id = ? GROUP BY utf8_lower(t.title), a" \
"l.id ORDER BY al.name COLLATE CUSTOM01 ASC, t.tracknumber ASC, t.title" \
" COLLATE CUSTOM01 ASC"
#define XNOISE_DATABASE_READER_STMT_GET_VIDEOITEM_BY_ID "SELECT DISTINCT t.id, t.title, u.name, t.mediatype FROM items t, uris " \
"u WHERE t.uri = u.id AND t.id = ?"
#define XNOISE_DATABASE_READER_STMT_GET_ARTISTITEM_BY_ARTISTID_WITH_SEARCH "SELECT DISTINCT ar.name FROM artists ar, items t, albums al WHERE t.ar" \
"tist = ar.id AND t.album = al.id AND ar.id = ? AND (utf8_lower(ar.name" \
") LIKE ? OR utf8_lower(al.name) LIKE ? OR utf8_lower(t.title) LIKE ?)"
#define XNOISE_DATABASE_READER_STMT_GET_ARTISTITEM_BY_ARTISTID "SELECT DISTINCT ar.name FROM artists ar, items t, albums al WHERE t.ar" \
"tist = ar.id AND t.album = al.id AND ar.id = ?"
#define XNOISE_DATABASE_READER_STMT_GET_TRACKDATA_BY_TITLEID "SELECT DISTINCT t.title, t.mediatype, t.id, t.tracknumber, u.name, ar." \
"name, al.name, t.length, g.name, t.year FROM artists ar, items t, albu" \
"ms al, uris u, genres g WHERE t.artist = ar.id AND t.album = al.id AND" \
" t.uri = u.id AND t.genre = g.id AND t.id = ?"
#define XNOISE_DATABASE_READER_STMT_GET_ALBUMS_WITH_SEARCH "SELECT DISTINCT al.name, al.id FROM artists ar, albums al, items t WHE" \
"RE ar.id = t.artist AND al.id = t.album AND ar.id = ? AND (utf8_lower(" \
"ar.name) LIKE ? OR utf8_lower(al.name) LIKE ? OR utf8_lower(t.title) L" \
"IKE ?) ORDER BY utf8_lower(al.name) COLLATE CUSTOM01 ASC"
#define XNOISE_DATABASE_READER_STMT_GET_ALBUMS "SELECT DISTINCT al.name, al.id FROM artists ar, albums al WHERE ar.id " \
"= al.artist AND ar.id = ? ORDER BY utf8_lower(al.name) COLLATE CUSTOM0" \
"1 ASC"
XnoiseDatabaseReader* xnoise_database_reader_new (GError** error);
XnoiseDatabaseReader* xnoise_database_reader_construct (GType object_type, GError** error);
static gchar* xnoise_database_reader_dbFileName (XnoiseDatabaseReader* self);
static void xnoise_database_reader_utf8_lower (sqlite3_context* context, int values_length1, sqlite3_value** values);
static void _xnoise_database_reader_utf8_lower_sqlite_user_func_callback (sqlite3_context* context, int values_length1, sqlite3_value** values);
static gint xnoise_database_reader_compare_func (gint alen, void* a, gint blen, void* b);
static gint _xnoise_database_reader_compare_func_sqlite_compare_callback (gpointer self, gint alen, void* a, gint blen, void* b);
static gint xnoise_database_reader_progress_handler (XnoiseDatabaseReader* self);
static gint _xnoise_database_reader_progress_handler_sqlite_progress_callback (gpointer self);
void xnoise_database_reader_cancel (XnoiseDatabaseReader* self);
gchar* xnoise_services_data_folder (void);
static void xnoise_database_reader_db_error (XnoiseDatabaseReader* self);
void xnoise_database_reader_do_callback_transaction (XnoiseDatabaseReader* self, XnoiseDatabaseReaderReaderCallback cb, void* cb_target);
gint32 xnoise_database_reader_count_videos (XnoiseDatabaseReader* self, const gchar* searchtext);
GType xnoise_item_type_get_type (void) G_GNUC_CONST;
gboolean xnoise_database_reader_get_lyrics (XnoiseDatabaseReader* self, const gchar* artist, const gchar* title, gchar** txt, gchar** cred, gchar** ident);
#define XNOISE_SERVICES_EMPTYSTRING ""
gchar* xnoise_services_prepare_for_comparison (const gchar* value);
GType xnoise_item_get_type (void) G_GNUC_CONST;
XnoiseItem* xnoise_item_dup (const XnoiseItem* self);
void xnoise_item_free (XnoiseItem* self);
void xnoise_item_copy (const XnoiseItem* self, XnoiseItem* dest);
void xnoise_item_destroy (XnoiseItem* self);
XnoiseItem* xnoise_database_reader_get_last_played (XnoiseDatabaseReader* self, const gchar* searchtext, int* result_length1);
static void _vala_XnoiseItem_array_free (XnoiseItem* array, gint array_length);
void xnoise_item_init (XnoiseItem *self, XnoiseItemType _type, const gchar* _uri, gint32 _db_id);
static void _vala_array_add3 (XnoiseItem** array, int* length, int* size, const XnoiseItem* value);
XnoiseItem* xnoise_database_reader_get_most_played (XnoiseDatabaseReader* self, const gchar* searchtext, int* result_length1);
static void _vala_array_add4 (XnoiseItem** array, int* length, int* size, const XnoiseItem* value);
gpointer xnoise_track_data_ref (gpointer instance);
void xnoise_track_data_unref (gpointer instance);
GParamSpec* xnoise_param_spec_track_data (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void xnoise_value_set_track_data (GValue* value, gpointer v_object);
void xnoise_value_take_track_data (GValue* value, gpointer v_object);
gpointer xnoise_value_get_track_data (const GValue* value);
GType xnoise_track_data_get_type (void) G_GNUC_CONST;
XnoiseTrackData** xnoise_database_reader_get_all_tracks (XnoiseDatabaseReader* self, const gchar* searchtext, int* result_length1);
XnoiseTrackData* xnoise_track_data_new (void);
XnoiseTrackData* xnoise_track_data_construct (GType object_type);
#define XNOISE_SERVICES_UNKNOWN_ARTIST "unknown artist"
#define XNOISE_SERVICES_UNKNOWN_ALBUM "unknown album"
#define XNOISE_SERVICES_UNKNOWN_GENRE "unknown genre"
#define XNOISE_SERVICES_UNKNOWN_TITLE "unknown title"
static void _vala_array_add5 (XnoiseTrackData*** array, int* length, int* size, XnoiseTrackData* value);
XnoiseItem* xnoise_database_reader_get_streamitem_by_id (XnoiseDatabaseReader* self, gint32 id, const gchar* searchtext);
gboolean xnoise_database_reader_get_stream_td_for_id (XnoiseDatabaseReader* self, gint id, XnoiseTrackData** val);
gboolean xnoise_database_reader_get_trackdata_for_uri (XnoiseDatabaseReader* self, gchar** uri, XnoiseTrackData** val);
XnoiseItem* xnoise_database_reader_get_media_folders (XnoiseDatabaseReader* self, int* result_length1);
static void _vala_array_add6 (XnoiseItem** array, int* length, int* size, const XnoiseItem* value);
XnoiseItem* xnoise_database_reader_get_stream_items (XnoiseDatabaseReader* self, const gchar* searchtext, int* result_length1);
static void _vala_array_add7 (XnoiseItem** array, int* length, int* size, const XnoiseItem* value);
XnoiseItem* xnoise_database_reader_get_some_lastused_items (XnoiseDatabaseReader* self, gint limit, gint offset, int* result_length1);
static void _vala_array_add8 (XnoiseItem** array, int* length, int* size, const XnoiseItem* value);
guint xnoise_database_reader_count_lastused_items (XnoiseDatabaseReader* self);
XnoiseTrackData** xnoise_database_reader_get_stream_data (XnoiseDatabaseReader* self, const gchar* searchtext, int* result_length1);
static void _vala_array_add9 (XnoiseTrackData*** array, int* length, int* size, XnoiseTrackData* value);
XnoiseItem* xnoise_database_reader_get_video_items (XnoiseDatabaseReader* self, const gchar* searchtext, int* result_length1);
static void _vala_array_add10 (XnoiseItem** array, int* length, int* size, const XnoiseItem* value);
XnoiseTrackData** xnoise_database_reader_get_video_data (XnoiseDatabaseReader* self, const gchar* searchtext, int* result_length1);
static void _vala_array_add11 (XnoiseTrackData*** array, int* length, int* size, XnoiseTrackData* value);
XnoiseTrackData** xnoise_database_reader_get_trackdata_for_video (XnoiseDatabaseReader* self, const gchar* searchtext, int* result_length1);
static void _vala_array_add12 (XnoiseTrackData*** array, int* length, int* size, XnoiseTrackData* value);
XnoiseTrackData** xnoise_database_reader_get_trackdata_for_streams (XnoiseDatabaseReader* self, const gchar* searchtext, int* result_length1);
static void _vala_array_add13 (XnoiseTrackData*** array, int* length, int* size, XnoiseTrackData* value);
XnoiseItem* xnoise_database_reader_get_artists_with_search (XnoiseDatabaseReader* self, const gchar* searchtext, int* result_length1);
static void _vala_array_add14 (XnoiseItem** array, int* length, int* size, const XnoiseItem* value);
static void _vala_array_add15 (XnoiseItem** array, int* length, int* size, const XnoiseItem* value);
XnoiseTrackData** xnoise_database_reader_get_trackdata_by_albumid (XnoiseDatabaseReader* self, const gchar* searchtext, gint32 id, int* result_length1);
static void _vala_array_add16 (XnoiseTrackData*** array, int* length, int* size, XnoiseTrackData* value);
XnoiseTrackData** xnoise_database_reader_get_trackdata_by_artistid (XnoiseDatabaseReader* self, const gchar* searchtext, gint32 id, int* result_length1);
static void _vala_array_add17 (XnoiseTrackData*** array, int* length, int* size, XnoiseTrackData* value);
XnoiseItem* xnoise_database_reader_get_videoitem_by_id (XnoiseDatabaseReader* self, gint32 id);
XnoiseItem* xnoise_database_reader_get_artistitem_by_artistid (XnoiseDatabaseReader* self, const gchar* searchtext, gint32 id);
XnoiseTrackData* xnoise_database_reader_get_trackdata_by_titleid (XnoiseDatabaseReader* self, const gchar* searchtext, gint32 id);
XnoiseItem* xnoise_database_reader_get_albums_with_search (XnoiseDatabaseReader* self, const gchar* searchtext, gint32 id, int* result_length1);
static void _vala_array_add18 (XnoiseItem** array, int* length, int* size, const XnoiseItem* value);
static void xnoise_database_reader_finalize (XnoiseDatabaseReader* obj);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);


GQuark xnoise_database_db_error_quark (void) {
	return g_quark_from_static_string ("xnoise_database_db_error-quark");
}


static void _xnoise_database_reader_utf8_lower_sqlite_user_func_callback (sqlite3_context* context, int values_length1, sqlite3_value** values) {
	xnoise_database_reader_utf8_lower (context, values_length1, values);
}


static gint _xnoise_database_reader_compare_func_sqlite_compare_callback (gpointer self, gint alen, void* a, gint blen, void* b) {
	gint result;
	result = xnoise_database_reader_compare_func (alen, a, blen, b);
	return result;
}


static gint _xnoise_database_reader_progress_handler_sqlite_progress_callback (gpointer self) {
	gint result;
	result = xnoise_database_reader_progress_handler (self);
	return result;
}


static gint _sqlite3_exec (sqlite3* self, const gchar* sql, sqlite3_callback callback, void* callback_target, gchar** errmsg) {
	gchar* _vala_errmsg = NULL;
	gint result = 0;
	const gchar* sqlite_errmsg = NULL;
	const gchar* _tmp0_;
	sqlite3_callback _tmp1_;
	void* _tmp1__target;
	const gchar* _tmp2_ = NULL;
	gint _tmp3_ = 0;
	gint ec;
	const gchar* _tmp6_;
	g_return_val_if_fail (self != NULL, 0);
	g_return_val_if_fail (sql != NULL, 0);
	_tmp0_ = sql;
	_tmp1_ = callback;
	_tmp1__target = callback_target;
	_tmp3_ = sqlite3_exec (self, _tmp0_, _tmp1_, _tmp1__target, (char**) (&_tmp2_));
	sqlite_errmsg = _tmp2_;
	ec = _tmp3_;
	if ((&_vala_errmsg) != NULL) {
		const gchar* _tmp4_;
		gchar* _tmp5_;
		_tmp4_ = sqlite_errmsg;
		_tmp5_ = g_strdup (_tmp4_);
		_g_free0 (_vala_errmsg);
		_vala_errmsg = _tmp5_;
	}
	_tmp6_ = sqlite_errmsg;
	sqlite3_free ((void*) _tmp6_);
	result = ec;
	if (errmsg) {
		*errmsg = _vala_errmsg;
	} else {
		_g_free0 (_vala_errmsg);
	}
	return result;
}


XnoiseDatabaseReader* xnoise_database_reader_construct (GType object_type, GError** error) {
	XnoiseDatabaseReader* self = NULL;
	gchar* _tmp0_ = NULL;
	const gchar* _tmp1_;
	sqlite3* _tmp2_ = NULL;
	gint _tmp3_ = 0;
	sqlite3* _tmp6_;
	sqlite3* _tmp8_;
	sqlite3* _tmp9_;
	sqlite3* _tmp10_;
	sqlite3* _tmp11_;
	sqlite3_stmt* _tmp12_ = NULL;
	sqlite3* _tmp13_;
	sqlite3_stmt* _tmp14_ = NULL;
	gchar* errormsg = NULL;
	sqlite3* _tmp15_;
	gchar* _tmp16_ = NULL;
	gint _tmp17_ = 0;
	GError * _inner_error_ = NULL;
	self = (XnoiseDatabaseReader*) g_type_create_instance (object_type);
	_tmp0_ = xnoise_database_reader_dbFileName (self);
	_g_free0 (self->priv->DATABASE);
	self->priv->DATABASE = _tmp0_;
	_sqlite3_close0 (self->priv->db);
	self->priv->db = NULL;
	_tmp1_ = self->priv->DATABASE;
	_tmp3_ = sqlite3_open_v2 (_tmp1_, &_tmp2_, SQLITE_OPEN_READONLY, NULL);
	_sqlite3_close0 (self->priv->db);
	self->priv->db = _tmp2_;
	if (_tmp3_ != SQLITE_OK) {
		sqlite3* _tmp4_;
		GError* _tmp5_;
		_tmp4_ = self->priv->db;
		g_print ("Can't open database: %s\n", (const gchar*) sqlite3_errmsg);
		_tmp5_ = g_error_new_literal (XNOISE_DATABASE_DB_ERROR, XNOISE_DATABASE_DB_ERROR_FAILED, "failed messge");
		_inner_error_ = _tmp5_;
		if (_inner_error_->domain == XNOISE_DATABASE_DB_ERROR) {
			g_propagate_error (error, _inner_error_);
			_xnoise_database_reader_unref0 (self);
			return NULL;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
	}
	_tmp6_ = self->priv->db;
	if (_tmp6_ == NULL) {
		GError* _tmp7_;
		_tmp7_ = g_error_new_literal (XNOISE_DATABASE_DB_ERROR, XNOISE_DATABASE_DB_ERROR_FAILED, "failed messge");
		_inner_error_ = _tmp7_;
		if (_inner_error_->domain == XNOISE_DATABASE_DB_ERROR) {
			g_propagate_error (error, _inner_error_);
			_xnoise_database_reader_unref0 (self);
			return NULL;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
	}
	_tmp8_ = self->priv->db;
	sqlite3_create_function_v2 (_tmp8_, "utf8_lower", 1, SQLITE_ANY, NULL, _xnoise_database_reader_utf8_lower_sqlite_user_func_callback, NULL, NULL, NULL);
	_tmp9_ = self->priv->db;
	sqlite3_create_collation (_tmp9_, "CUSTOM01", SQLITE_UTF8, NULL, (int (*)(void *, int,  const void *, int,  const void *)) _xnoise_database_reader_compare_func_sqlite_compare_callback);
	_tmp10_ = self->priv->db;
	sqlite3_progress_handler (_tmp10_, 5, _xnoise_database_reader_progress_handler_sqlite_progress_callback, self);
	_tmp11_ = self->priv->db;
	sqlite3_prepare_v2 (_tmp11_, XNOISE_DATABASE_READER_STMT_GET_ARTISTS_WITH_SEARCH, -1, &_tmp12_, NULL);
	_sqlite3_finalize0 (self->priv->get_artists_with_search_stmt);
	self->priv->get_artists_with_search_stmt = _tmp12_;
	_tmp13_ = self->priv->db;
	sqlite3_prepare_v2 (_tmp13_, XNOISE_DATABASE_READER_STMT_GET_ARTISTS, -1, &_tmp14_, NULL);
	_sqlite3_finalize0 (self->priv->get_artists_with_search2_stmt);
	self->priv->get_artists_with_search2_stmt = _tmp14_;
	_tmp15_ = self->priv->db;
	_tmp17_ = _sqlite3_exec (_tmp15_, "PRAGMA synchronous=OFF", NULL, NULL, &_tmp16_);
	_g_free0 (errormsg);
	errormsg = _tmp16_;
	if (_tmp17_ != SQLITE_OK) {
		FILE* _tmp18_;
		const gchar* _tmp19_;
		_tmp18_ = stderr;
		_tmp19_ = errormsg;
		fprintf (_tmp18_, "exec_stmnt_string error: %s", _tmp19_);
		_g_free0 (errormsg);
		return self;
	}
	_g_free0 (errormsg);
	return self;
}


XnoiseDatabaseReader* xnoise_database_reader_new (GError** error) {
	return xnoise_database_reader_construct (XNOISE_DATABASE_TYPE_READER, error);
}


static void xnoise_database_reader_utf8_lower (sqlite3_context* context, int values_length1, sqlite3_value** values) {
	sqlite3_context* _tmp0_;
	sqlite3_value** _tmp1_;
	gint _tmp1__length1;
	sqlite3_value* _tmp2_;
	const gchar* _tmp3_ = NULL;
	gchar* _tmp4_ = NULL;
	GDestroyNotify _tmp5_;
	g_return_if_fail (context != NULL);
	_tmp0_ = context;
	_tmp1_ = values;
	_tmp1__length1 = values_length1;
	_tmp2_ = _tmp1_[0];
	_tmp3_ = sqlite3_value_text (_tmp2_);
	_tmp4_ = g_utf8_strdown (_tmp3_, (gssize) (-1));
	_tmp5_ = g_free;
	sqlite3_result_text (_tmp0_, _tmp4_, -1, _tmp5_);
}


static gint xnoise_database_reader_compare_func (gint alen, void* a, gint blen, void* b) {
	gint result = 0;
	GCompareFunc _tmp0_;
	void* _tmp1_;
	gint _tmp2_;
	gchar* _tmp3_ = NULL;
	gchar* _tmp4_;
	void* _tmp5_;
	gint _tmp6_;
	gchar* _tmp7_ = NULL;
	gchar* _tmp8_;
	gint _tmp9_ = 0;
	gint _tmp10_;
	_tmp0_ = g_strcmp0;
	_tmp1_ = a;
	_tmp2_ = alen;
	_tmp3_ = g_utf8_collate_key ((const gchar*) _tmp1_, (gssize) _tmp2_);
	_tmp4_ = _tmp3_;
	_tmp5_ = b;
	_tmp6_ = blen;
	_tmp7_ = g_utf8_collate_key ((const gchar*) _tmp5_, (gssize) _tmp6_);
	_tmp8_ = _tmp7_;
	_tmp9_ = _tmp0_ (_tmp4_, _tmp8_);
	_tmp10_ = _tmp9_;
	_g_free0 (_tmp8_);
	_g_free0 (_tmp4_);
	result = _tmp10_;
	return result;
}


void xnoise_database_reader_cancel (XnoiseDatabaseReader* self) {
	g_return_if_fail (self != NULL);
	self->priv->abort = TRUE;
}


static gint xnoise_database_reader_progress_handler (XnoiseDatabaseReader* self) {
	gint result = 0;
	gboolean _tmp0_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->abort;
	if (_tmp0_) {
		self->priv->abort = FALSE;
		result = 1;
		return result;
	}
	result = 0;
	return result;
}


static gchar* xnoise_database_reader_dbFileName (XnoiseDatabaseReader* self) {
	gchar* result = NULL;
	gchar* _tmp0_ = NULL;
	gchar* _tmp1_;
	gchar* _tmp2_ = NULL;
	gchar* _tmp3_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = xnoise_services_data_folder ();
	_tmp1_ = _tmp0_;
	_tmp2_ = g_build_filename (_tmp1_, XNOISE_DATABASE_READER_DATABASE_NAME, NULL, NULL);
	_tmp3_ = _tmp2_;
	_g_free0 (_tmp1_);
	result = _tmp3_;
	return result;
}


static void xnoise_database_reader_db_error (XnoiseDatabaseReader* self) {
	sqlite3* _tmp0_;
	gint _tmp1_ = 0;
	sqlite3* _tmp2_;
	const gchar* _tmp3_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->db;
	_tmp1_ = sqlite3_errcode (_tmp0_);
	_tmp2_ = self->priv->db;
	_tmp3_ = sqlite3_errmsg (_tmp2_);
	g_print ("Database error %d: %s \n\n", _tmp1_, _tmp3_);
}


void xnoise_database_reader_do_callback_transaction (XnoiseDatabaseReader* self, XnoiseDatabaseReaderReaderCallback cb, void* cb_target) {
	sqlite3* _tmp0_;
	XnoiseDatabaseReaderReaderCallback _tmp1_;
	void* _tmp1__target;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->db;
	if (_tmp0_ == NULL) {
		return;
	}
	_tmp1_ = cb;
	_tmp1__target = cb_target;
	if (_tmp1_ != NULL) {
		XnoiseDatabaseReaderReaderCallback _tmp2_;
		void* _tmp2__target;
		sqlite3* _tmp3_;
		_tmp2_ = cb;
		_tmp2__target = cb_target;
		_tmp3_ = self->priv->db;
		_tmp2_ (_tmp3_, _tmp2__target);
	}
}


gint32 xnoise_database_reader_count_videos (XnoiseDatabaseReader* self, const gchar* searchtext) {
	gint32 result = 0;
	sqlite3_stmt* stmt = NULL;
	gint count;
	sqlite3* _tmp0_;
	sqlite3_stmt* _tmp1_ = NULL;
	gboolean _tmp2_ = FALSE;
	sqlite3_stmt* _tmp3_;
	gint _tmp4_ = 0;
	gboolean _tmp10_;
	sqlite3_stmt* _tmp11_;
	gint _tmp12_ = 0;
	g_return_val_if_fail (self != NULL, 0);
	g_return_val_if_fail (searchtext != NULL, 0);
	count = 0;
	_tmp0_ = self->priv->db;
	sqlite3_prepare_v2 (_tmp0_, XNOISE_DATABASE_READER_STMT_GET_VIDEO_COUNT, -1, &_tmp1_, NULL);
	_sqlite3_finalize0 (stmt);
	stmt = _tmp1_;
	_tmp3_ = stmt;
	_tmp4_ = sqlite3_bind_int (_tmp3_, 1, (gint) XNOISE_ITEM_TYPE_LOCAL_VIDEO_TRACK);
	if (_tmp4_ != SQLITE_OK) {
		_tmp2_ = TRUE;
	} else {
		sqlite3_stmt* _tmp5_;
		const gchar* _tmp6_;
		gchar* _tmp7_ = NULL;
		GDestroyNotify _tmp8_;
		gint _tmp9_ = 0;
		_tmp5_ = stmt;
		_tmp6_ = searchtext;
		_tmp7_ = g_strdup_printf ("%%%s%%", _tmp6_);
		_tmp8_ = g_free;
		_tmp9_ = sqlite3_bind_text (_tmp5_, 2, _tmp7_, -1, _tmp8_);
		_tmp2_ = _tmp9_ != SQLITE_OK;
	}
	_tmp10_ = _tmp2_;
	if (_tmp10_) {
		xnoise_database_reader_db_error (self);
		result = (gint32) 0;
		_sqlite3_finalize0 (stmt);
		return result;
	}
	_tmp11_ = stmt;
	_tmp12_ = sqlite3_step (_tmp11_);
	if (_tmp12_ == SQLITE_ROW) {
		sqlite3_stmt* _tmp13_;
		gint _tmp14_ = 0;
		_tmp13_ = stmt;
		_tmp14_ = sqlite3_column_int (_tmp13_, 0);
		count = _tmp14_;
	}
	result = (gint32) count;
	_sqlite3_finalize0 (stmt);
	return result;
}


static gchar* string_strip (const gchar* self) {
	gchar* result = NULL;
	gchar* _tmp0_ = NULL;
	gchar* _result_;
	const gchar* _tmp1_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = g_strdup (self);
	_result_ = _tmp0_;
	_tmp1_ = _result_;
	g_strstrip (_tmp1_);
	result = _result_;
	return result;
}


gboolean xnoise_database_reader_get_lyrics (XnoiseDatabaseReader* self, const gchar* artist, const gchar* title, gchar** txt, gchar** cred, gchar** ident) {
	gchar* _vala_txt = NULL;
	gchar* _vala_cred = NULL;
	gchar* _vala_ident = NULL;
	gboolean result = FALSE;
	sqlite3_stmt* stmt = NULL;
	sqlite3* _tmp0_;
	sqlite3_stmt* _tmp1_ = NULL;
	sqlite3_stmt* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	sqlite3_stmt* _tmp6_;
	const gchar* _tmp7_;
	gchar* _tmp8_ = NULL;
	gchar* _tmp9_;
	gchar* _tmp10_ = NULL;
	GDestroyNotify _tmp11_;
	gint _tmp12_ = 0;
	sqlite3_stmt* _tmp13_;
	const gchar* _tmp14_;
	gchar* _tmp15_ = NULL;
	gchar* _tmp16_;
	gchar* _tmp17_ = NULL;
	GDestroyNotify _tmp18_;
	gint _tmp19_ = 0;
	gboolean _tmp20_;
	sqlite3_stmt* _tmp21_;
	gint _tmp22_ = 0;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (artist != NULL, FALSE);
	g_return_val_if_fail (title != NULL, FALSE);
	_tmp0_ = self->priv->db;
	sqlite3_prepare_v2 (_tmp0_, "SELECT txt, credits, identifier FROM lyrics WHERE LOWER(artist) = ? AN" \
"D LOWER(title) = ?", -1, &_tmp1_, NULL);
	_sqlite3_finalize0 (stmt);
	stmt = _tmp1_;
	_tmp2_ = stmt;
	sqlite3_reset (_tmp2_);
	_tmp3_ = g_strdup (XNOISE_SERVICES_EMPTYSTRING);
	_g_free0 (_vala_txt);
	_vala_txt = _tmp3_;
	_tmp4_ = g_strdup (XNOISE_SERVICES_EMPTYSTRING);
	_g_free0 (_vala_cred);
	_vala_cred = _tmp4_;
	_tmp5_ = g_strdup (XNOISE_SERVICES_EMPTYSTRING);
	_g_free0 (_vala_ident);
	_vala_ident = _tmp5_;
	_tmp6_ = stmt;
	_tmp7_ = artist;
	_tmp8_ = xnoise_services_prepare_for_comparison (_tmp7_);
	_tmp9_ = _tmp8_;
	_tmp10_ = g_strdup_printf ("%s", _tmp9_);
	_tmp11_ = g_free;
	_tmp12_ = sqlite3_bind_text (_tmp6_, 1, _tmp10_, -1, _tmp11_);
	_tmp13_ = stmt;
	_tmp14_ = title;
	_tmp15_ = xnoise_services_prepare_for_comparison (_tmp14_);
	_tmp16_ = _tmp15_;
	_tmp17_ = g_strdup_printf ("%s", _tmp16_);
	_tmp18_ = g_free;
	_tmp19_ = sqlite3_bind_text (_tmp13_, 2, _tmp17_, -1, _tmp18_);
	_tmp20_ = (_tmp12_ != SQLITE_OK) | (_tmp19_ != SQLITE_OK);
	_g_free0 (_tmp16_);
	_g_free0 (_tmp9_);
	if (_tmp20_) {
		g_print ("Error in database lyrics\n");
		result = FALSE;
		_sqlite3_finalize0 (stmt);
		if (txt) {
			*txt = _vala_txt;
		} else {
			_g_free0 (_vala_txt);
		}
		if (cred) {
			*cred = _vala_cred;
		} else {
			_g_free0 (_vala_cred);
		}
		if (ident) {
			*ident = _vala_ident;
		} else {
			_g_free0 (_vala_ident);
		}
		return result;
	}
	_tmp21_ = stmt;
	_tmp22_ = sqlite3_step (_tmp21_);
	if (_tmp22_ == SQLITE_ROW) {
		sqlite3_stmt* _tmp23_;
		const gchar* _tmp24_ = NULL;
		gchar* _tmp25_;
		sqlite3_stmt* _tmp26_;
		const gchar* _tmp27_ = NULL;
		gchar* _tmp28_;
		sqlite3_stmt* _tmp29_;
		const gchar* _tmp30_ = NULL;
		gchar* _tmp31_;
		gboolean _tmp32_ = FALSE;
		const gchar* _tmp33_;
		gchar* _tmp34_ = NULL;
		gchar* _tmp35_;
		gboolean _tmp36_;
		gboolean _tmp41_;
		_tmp23_ = stmt;
		_tmp24_ = sqlite3_column_text (_tmp23_, 0);
		_tmp25_ = g_strdup (_tmp24_);
		_g_free0 (_vala_txt);
		_vala_txt = _tmp25_;
		_tmp26_ = stmt;
		_tmp27_ = sqlite3_column_text (_tmp26_, 1);
		_tmp28_ = g_strdup (_tmp27_);
		_g_free0 (_vala_cred);
		_vala_cred = _tmp28_;
		_tmp29_ = stmt;
		_tmp30_ = sqlite3_column_text (_tmp29_, 2);
		_tmp31_ = g_strdup (_tmp30_);
		_g_free0 (_vala_ident);
		_vala_ident = _tmp31_;
		_tmp33_ = _vala_txt;
		_tmp34_ = string_strip (_tmp33_);
		_tmp35_ = _tmp34_;
		_tmp36_ = g_strcmp0 (_tmp35_, "no lyrics found...") == 0;
		_g_free0 (_tmp35_);
		if (_tmp36_) {
			_tmp32_ = TRUE;
		} else {
			const gchar* _tmp37_;
			gchar* _tmp38_ = NULL;
			gchar* _tmp39_;
			const gchar* _tmp40_ = NULL;
			_tmp37_ = _vala_txt;
			_tmp38_ = string_strip (_tmp37_);
			_tmp39_ = _tmp38_;
			_tmp40_ = _ ("no lyrics found...");
			_tmp32_ = g_strcmp0 (_tmp39_, _tmp40_) == 0;
			_g_free0 (_tmp39_);
		}
		_tmp41_ = _tmp32_;
		if (_tmp41_) {
			gchar* _tmp42_;
			const gchar* _tmp43_;
			gchar* _tmp44_;
			const gchar* _tmp45_;
			gchar* _tmp46_;
			_tmp42_ = g_strdup (XNOISE_SERVICES_EMPTYSTRING);
			_g_free0 (_vala_ident);
			_vala_ident = _tmp42_;
			_tmp43_ = _vala_ident;
			_tmp44_ = g_strdup (_tmp43_);
			_g_free0 (_vala_cred);
			_vala_cred = _tmp44_;
			_tmp45_ = _vala_cred;
			_tmp46_ = g_strdup (_tmp45_);
			_g_free0 (_vala_txt);
			_vala_txt = _tmp46_;
			result = FALSE;
			_sqlite3_finalize0 (stmt);
			if (txt) {
				*txt = _vala_txt;
			} else {
				_g_free0 (_vala_txt);
			}
			if (cred) {
				*cred = _vala_cred;
			} else {
				_g_free0 (_vala_cred);
			}
			if (ident) {
				*ident = _vala_ident;
			} else {
				_g_free0 (_vala_ident);
			}
			return result;
		}
		result = TRUE;
		_sqlite3_finalize0 (stmt);
		if (txt) {
			*txt = _vala_txt;
		} else {
			_g_free0 (_vala_txt);
		}
		if (cred) {
			*cred = _vala_cred;
		} else {
			_g_free0 (_vala_cred);
		}
		if (ident) {
			*ident = _vala_ident;
		} else {
			_g_free0 (_vala_ident);
		}
		return result;
	} else {
		result = FALSE;
		_sqlite3_finalize0 (stmt);
		if (txt) {
			*txt = _vala_txt;
		} else {
			_g_free0 (_vala_txt);
		}
		if (cred) {
			*cred = _vala_cred;
		} else {
			_g_free0 (_vala_cred);
		}
		if (ident) {
			*ident = _vala_ident;
		} else {
			_g_free0 (_vala_ident);
		}
		return result;
	}
	_sqlite3_finalize0 (stmt);
	if (txt) {
		*txt = _vala_txt;
	} else {
		_g_free0 (_vala_txt);
	}
	if (cred) {
		*cred = _vala_cred;
	} else {
		_g_free0 (_vala_cred);
	}
	if (ident) {
		*ident = _vala_ident;
	} else {
		_g_free0 (_vala_ident);
	}
}


static void _vala_XnoiseItem_array_free (XnoiseItem* array, gint array_length) {
	if (array != NULL) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			xnoise_item_destroy (&array[i]);
		}
	}
	g_free (array);
}


static void _vala_array_add3 (XnoiseItem** array, int* length, int* size, const XnoiseItem* value) {
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (XnoiseItem, *array, *size);
	}
	(*array)[(*length)++] = *value;
}


XnoiseItem* xnoise_database_reader_get_last_played (XnoiseDatabaseReader* self, const gchar* searchtext, int* result_length1) {
	XnoiseItem* result = NULL;
	sqlite3_stmt* stmt = NULL;
	XnoiseItem* _tmp0_ = NULL;
	XnoiseItem* retv;
	gint retv_length1;
	gint _retv_size_;
	const gchar* _tmp1_;
	gchar* _tmp2_ = NULL;
	gchar* st;
	sqlite3* _tmp3_;
	sqlite3_stmt* _tmp4_ = NULL;
	gboolean _tmp5_ = FALSE;
	gboolean _tmp6_ = FALSE;
	sqlite3_stmt* _tmp7_;
	const gchar* _tmp8_;
	gchar* _tmp9_;
	GDestroyNotify _tmp10_;
	gint _tmp11_ = 0;
	gboolean _tmp17_;
	gboolean _tmp23_;
	XnoiseItem* _tmp48_;
	gint _tmp48__length1;
	XnoiseItem* _tmp50_;
	gint _tmp50__length1;
	XnoiseItem* _tmp51_;
	gint _tmp51__length1;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (searchtext != NULL, NULL);
	_tmp0_ = g_new0 (XnoiseItem, 0);
	retv = _tmp0_;
	retv_length1 = 0;
	_retv_size_ = retv_length1;
	_tmp1_ = searchtext;
	_tmp2_ = g_strdup_printf ("%%%s%%", _tmp1_);
	st = _tmp2_;
	_tmp3_ = self->priv->db;
	sqlite3_prepare_v2 (_tmp3_, XNOISE_DATABASE_READER_STMT_GET_LAST_PLAYED, -1, &_tmp4_, NULL);
	_sqlite3_finalize0 (stmt);
	stmt = _tmp4_;
	_tmp7_ = stmt;
	_tmp8_ = st;
	_tmp9_ = g_strdup (_tmp8_);
	_tmp10_ = g_free;
	_tmp11_ = sqlite3_bind_text (_tmp7_, 1, _tmp9_, -1, _tmp10_);
	if (_tmp11_ != SQLITE_OK) {
		_tmp6_ = TRUE;
	} else {
		sqlite3_stmt* _tmp12_;
		const gchar* _tmp13_;
		gchar* _tmp14_;
		GDestroyNotify _tmp15_;
		gint _tmp16_ = 0;
		_tmp12_ = stmt;
		_tmp13_ = st;
		_tmp14_ = g_strdup (_tmp13_);
		_tmp15_ = g_free;
		_tmp16_ = sqlite3_bind_text (_tmp12_, 2, _tmp14_, -1, _tmp15_);
		_tmp6_ = _tmp16_ != SQLITE_OK;
	}
	_tmp17_ = _tmp6_;
	if (_tmp17_) {
		_tmp5_ = TRUE;
	} else {
		sqlite3_stmt* _tmp18_;
		const gchar* _tmp19_;
		gchar* _tmp20_;
		GDestroyNotify _tmp21_;
		gint _tmp22_ = 0;
		_tmp18_ = stmt;
		_tmp19_ = st;
		_tmp20_ = g_strdup (_tmp19_);
		_tmp21_ = g_free;
		_tmp22_ = sqlite3_bind_text (_tmp18_, 3, _tmp20_, -1, _tmp21_);
		_tmp5_ = _tmp22_ != SQLITE_OK;
	}
	_tmp23_ = _tmp5_;
	if (_tmp23_) {
		XnoiseItem* _tmp24_;
		gint _tmp24__length1;
		xnoise_database_reader_db_error (self);
		_tmp24_ = NULL;
		_tmp24__length1 = 0;
		if (result_length1) {
			*result_length1 = _tmp24__length1;
		}
		result = _tmp24_;
		_g_free0 (st);
		retv = (_vala_XnoiseItem_array_free (retv, retv_length1), NULL);
		_sqlite3_finalize0 (stmt);
		return result;
	}
	while (TRUE) {
		sqlite3_stmt* _tmp25_;
		gint _tmp26_ = 0;
		sqlite3_stmt* _tmp27_;
		gint _tmp28_ = 0;
		sqlite3_stmt* _tmp29_;
		const gchar* _tmp30_ = NULL;
		sqlite3_stmt* _tmp31_;
		gint _tmp32_ = 0;
		XnoiseItem i = {0};
		XnoiseItem _tmp33_;
		XnoiseItemType _tmp34_;
		XnoiseItem* _tmp45_;
		gint _tmp45__length1;
		XnoiseItem _tmp46_;
		XnoiseItem _tmp47_ = {0};
		_tmp25_ = stmt;
		_tmp26_ = sqlite3_step (_tmp25_);
		if (!(_tmp26_ == SQLITE_ROW)) {
			break;
		}
		_tmp27_ = stmt;
		_tmp28_ = sqlite3_column_int (_tmp27_, 2);
		_tmp29_ = stmt;
		_tmp30_ = sqlite3_column_text (_tmp29_, 4);
		_tmp31_ = stmt;
		_tmp32_ = sqlite3_column_int (_tmp31_, 3);
		xnoise_item_init (&i, (XnoiseItemType) _tmp28_, _tmp30_, (gint32) _tmp32_);
		_tmp33_ = i;
		_tmp34_ = _tmp33_.type;
		if (_tmp34_ == XNOISE_ITEM_TYPE_LOCAL_AUDIO_TRACK) {
			sqlite3_stmt* _tmp35_;
			const gchar* _tmp36_ = NULL;
			gchar* _tmp37_;
			gchar* _tmp38_;
			sqlite3_stmt* _tmp39_;
			const gchar* _tmp40_ = NULL;
			gchar* _tmp41_;
			_tmp35_ = stmt;
			_tmp36_ = sqlite3_column_text (_tmp35_, 0);
			_tmp37_ = g_strconcat (_tmp36_, " - ", NULL);
			_tmp38_ = _tmp37_;
			_tmp39_ = stmt;
			_tmp40_ = sqlite3_column_text (_tmp39_, 1);
			_tmp41_ = g_strconcat (_tmp38_, _tmp40_, NULL);
			_g_free0 (i.text);
			i.text = _tmp41_;
			_g_free0 (_tmp38_);
		} else {
			sqlite3_stmt* _tmp42_;
			const gchar* _tmp43_ = NULL;
			gchar* _tmp44_;
			_tmp42_ = stmt;
			_tmp43_ = sqlite3_column_text (_tmp42_, 1);
			_tmp44_ = g_strdup (_tmp43_);
			_g_free0 (i.text);
			i.text = _tmp44_;
		}
		_tmp45_ = retv;
		_tmp45__length1 = retv_length1;
		_tmp46_ = i;
		xnoise_item_copy (&_tmp46_, &_tmp47_);
		_vala_array_add3 (&retv, &retv_length1, &_retv_size_, &_tmp47_);
		xnoise_item_destroy (&i);
	}
	_tmp48_ = retv;
	_tmp48__length1 = retv_length1;
	if (_tmp48__length1 == 0) {
		XnoiseItem* _tmp49_;
		gint _tmp49__length1;
		_tmp49_ = NULL;
		_tmp49__length1 = 0;
		if (result_length1) {
			*result_length1 = _tmp49__length1;
		}
		result = _tmp49_;
		_g_free0 (st);
		retv = (_vala_XnoiseItem_array_free (retv, retv_length1), NULL);
		_sqlite3_finalize0 (stmt);
		return result;
	}
	_tmp50_ = retv;
	_tmp50__length1 = retv_length1;
	retv = NULL;
	_tmp51_ = _tmp50_;
	_tmp51__length1 = _tmp50__length1;
	if (result_length1) {
		*result_length1 = _tmp51__length1;
	}
	result = _tmp51_;
	_g_free0 (st);
	retv = (_vala_XnoiseItem_array_free (retv, retv_length1), NULL);
	_sqlite3_finalize0 (stmt);
	return result;
}


static void _vala_array_add4 (XnoiseItem** array, int* length, int* size, const XnoiseItem* value) {
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (XnoiseItem, *array, *size);
	}
	(*array)[(*length)++] = *value;
}


XnoiseItem* xnoise_database_reader_get_most_played (XnoiseDatabaseReader* self, const gchar* searchtext, int* result_length1) {
	XnoiseItem* result = NULL;
	sqlite3_stmt* stmt = NULL;
	XnoiseItem* _tmp0_ = NULL;
	XnoiseItem* retv;
	gint retv_length1;
	gint _retv_size_;
	const gchar* _tmp1_;
	gchar* _tmp2_ = NULL;
	gchar* st;
	sqlite3* _tmp3_;
	sqlite3_stmt* _tmp4_ = NULL;
	gboolean _tmp5_ = FALSE;
	gboolean _tmp6_ = FALSE;
	sqlite3_stmt* _tmp7_;
	const gchar* _tmp8_;
	gchar* _tmp9_;
	GDestroyNotify _tmp10_;
	gint _tmp11_ = 0;
	gboolean _tmp17_;
	gboolean _tmp23_;
	XnoiseItem* _tmp48_;
	gint _tmp48__length1;
	XnoiseItem* _tmp50_;
	gint _tmp50__length1;
	XnoiseItem* _tmp51_;
	gint _tmp51__length1;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (searchtext != NULL, NULL);
	_tmp0_ = g_new0 (XnoiseItem, 0);
	retv = _tmp0_;
	retv_length1 = 0;
	_retv_size_ = retv_length1;
	_tmp1_ = searchtext;
	_tmp2_ = g_strdup_printf ("%%%s%%", _tmp1_);
	st = _tmp2_;
	_tmp3_ = self->priv->db;
	sqlite3_prepare_v2 (_tmp3_, XNOISE_DATABASE_READER_STMT_GET_MOST_PLAYED, -1, &_tmp4_, NULL);
	_sqlite3_finalize0 (stmt);
	stmt = _tmp4_;
	_tmp7_ = stmt;
	_tmp8_ = st;
	_tmp9_ = g_strdup (_tmp8_);
	_tmp10_ = g_free;
	_tmp11_ = sqlite3_bind_text (_tmp7_, 1, _tmp9_, -1, _tmp10_);
	if (_tmp11_ != SQLITE_OK) {
		_tmp6_ = TRUE;
	} else {
		sqlite3_stmt* _tmp12_;
		const gchar* _tmp13_;
		gchar* _tmp14_;
		GDestroyNotify _tmp15_;
		gint _tmp16_ = 0;
		_tmp12_ = stmt;
		_tmp13_ = st;
		_tmp14_ = g_strdup (_tmp13_);
		_tmp15_ = g_free;
		_tmp16_ = sqlite3_bind_text (_tmp12_, 2, _tmp14_, -1, _tmp15_);
		_tmp6_ = _tmp16_ != SQLITE_OK;
	}
	_tmp17_ = _tmp6_;
	if (_tmp17_) {
		_tmp5_ = TRUE;
	} else {
		sqlite3_stmt* _tmp18_;
		const gchar* _tmp19_;
		gchar* _tmp20_;
		GDestroyNotify _tmp21_;
		gint _tmp22_ = 0;
		_tmp18_ = stmt;
		_tmp19_ = st;
		_tmp20_ = g_strdup (_tmp19_);
		_tmp21_ = g_free;
		_tmp22_ = sqlite3_bind_text (_tmp18_, 3, _tmp20_, -1, _tmp21_);
		_tmp5_ = _tmp22_ != SQLITE_OK;
	}
	_tmp23_ = _tmp5_;
	if (_tmp23_) {
		XnoiseItem* _tmp24_;
		gint _tmp24__length1;
		xnoise_database_reader_db_error (self);
		_tmp24_ = NULL;
		_tmp24__length1 = 0;
		if (result_length1) {
			*result_length1 = _tmp24__length1;
		}
		result = _tmp24_;
		_g_free0 (st);
		retv = (_vala_XnoiseItem_array_free (retv, retv_length1), NULL);
		_sqlite3_finalize0 (stmt);
		return result;
	}
	while (TRUE) {
		sqlite3_stmt* _tmp25_;
		gint _tmp26_ = 0;
		sqlite3_stmt* _tmp27_;
		gint _tmp28_ = 0;
		sqlite3_stmt* _tmp29_;
		const gchar* _tmp30_ = NULL;
		sqlite3_stmt* _tmp31_;
		gint _tmp32_ = 0;
		XnoiseItem i = {0};
		XnoiseItem _tmp33_;
		XnoiseItemType _tmp34_;
		XnoiseItem* _tmp45_;
		gint _tmp45__length1;
		XnoiseItem _tmp46_;
		XnoiseItem _tmp47_ = {0};
		_tmp25_ = stmt;
		_tmp26_ = sqlite3_step (_tmp25_);
		if (!(_tmp26_ == SQLITE_ROW)) {
			break;
		}
		_tmp27_ = stmt;
		_tmp28_ = sqlite3_column_int (_tmp27_, 2);
		_tmp29_ = stmt;
		_tmp30_ = sqlite3_column_text (_tmp29_, 4);
		_tmp31_ = stmt;
		_tmp32_ = sqlite3_column_int (_tmp31_, 3);
		xnoise_item_init (&i, (XnoiseItemType) _tmp28_, _tmp30_, (gint32) _tmp32_);
		_tmp33_ = i;
		_tmp34_ = _tmp33_.type;
		if (_tmp34_ == XNOISE_ITEM_TYPE_LOCAL_AUDIO_TRACK) {
			sqlite3_stmt* _tmp35_;
			const gchar* _tmp36_ = NULL;
			gchar* _tmp37_;
			gchar* _tmp38_;
			sqlite3_stmt* _tmp39_;
			const gchar* _tmp40_ = NULL;
			gchar* _tmp41_;
			_tmp35_ = stmt;
			_tmp36_ = sqlite3_column_text (_tmp35_, 0);
			_tmp37_ = g_strconcat (_tmp36_, " - ", NULL);
			_tmp38_ = _tmp37_;
			_tmp39_ = stmt;
			_tmp40_ = sqlite3_column_text (_tmp39_, 1);
			_tmp41_ = g_strconcat (_tmp38_, _tmp40_, NULL);
			_g_free0 (i.text);
			i.text = _tmp41_;
			_g_free0 (_tmp38_);
		} else {
			sqlite3_stmt* _tmp42_;
			const gchar* _tmp43_ = NULL;
			gchar* _tmp44_;
			_tmp42_ = stmt;
			_tmp43_ = sqlite3_column_text (_tmp42_, 1);
			_tmp44_ = g_strdup (_tmp43_);
			_g_free0 (i.text);
			i.text = _tmp44_;
		}
		_tmp45_ = retv;
		_tmp45__length1 = retv_length1;
		_tmp46_ = i;
		xnoise_item_copy (&_tmp46_, &_tmp47_);
		_vala_array_add4 (&retv, &retv_length1, &_retv_size_, &_tmp47_);
		xnoise_item_destroy (&i);
	}
	_tmp48_ = retv;
	_tmp48__length1 = retv_length1;
	if (_tmp48__length1 == 0) {
		XnoiseItem* _tmp49_;
		gint _tmp49__length1;
		_tmp49_ = NULL;
		_tmp49__length1 = 0;
		if (result_length1) {
			*result_length1 = _tmp49__length1;
		}
		result = _tmp49_;
		_g_free0 (st);
		retv = (_vala_XnoiseItem_array_free (retv, retv_length1), NULL);
		_sqlite3_finalize0 (stmt);
		return result;
	}
	_tmp50_ = retv;
	_tmp50__length1 = retv_length1;
	retv = NULL;
	_tmp51_ = _tmp50_;
	_tmp51__length1 = _tmp50__length1;
	if (result_length1) {
		*result_length1 = _tmp51__length1;
	}
	result = _tmp51_;
	_g_free0 (st);
	retv = (_vala_XnoiseItem_array_free (retv, retv_length1), NULL);
	_sqlite3_finalize0 (stmt);
	return result;
}


static gpointer _xnoise_item_dup0 (gpointer self) {
	return self ? xnoise_item_dup (self) : NULL;
}


static gpointer _xnoise_track_data_ref0 (gpointer self) {
	return self ? xnoise_track_data_ref (self) : NULL;
}


static void _vala_array_add5 (XnoiseTrackData*** array, int* length, int* size, XnoiseTrackData* value) {
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (XnoiseTrackData*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}


XnoiseTrackData** xnoise_database_reader_get_all_tracks (XnoiseDatabaseReader* self, const gchar* searchtext, int* result_length1) {
	XnoiseTrackData** result = NULL;
	sqlite3_stmt* stmt = NULL;
	XnoiseTrackData** _tmp0_ = NULL;
	XnoiseTrackData** retv;
	gint retv_length1;
	gint _retv_size_;
	const gchar* _tmp1_;
	gchar* _tmp2_ = NULL;
	gchar* st;
	sqlite3* _tmp3_;
	sqlite3_stmt* _tmp4_ = NULL;
	gboolean _tmp5_ = FALSE;
	gboolean _tmp6_ = FALSE;
	gboolean _tmp7_ = FALSE;
	sqlite3_stmt* _tmp8_;
	const gchar* _tmp9_;
	gchar* _tmp10_;
	GDestroyNotify _tmp11_;
	gint _tmp12_ = 0;
	gboolean _tmp18_;
	gboolean _tmp24_;
	gboolean _tmp27_;
	XnoiseTrackData** _tmp118_;
	gint _tmp118__length1;
	XnoiseTrackData** _tmp119_;
	gint _tmp119__length1;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (searchtext != NULL, NULL);
	_tmp0_ = g_new0 (XnoiseTrackData*, 0 + 1);
	retv = _tmp0_;
	retv_length1 = 0;
	_retv_size_ = retv_length1;
	_tmp1_ = searchtext;
	_tmp2_ = g_strdup_printf ("%%%s%%", _tmp1_);
	st = _tmp2_;
	_tmp3_ = self->priv->db;
	sqlite3_prepare_v2 (_tmp3_, XNOISE_DATABASE_READER_STMT_ALL_TRACKDATA, -1, &_tmp4_, NULL);
	_sqlite3_finalize0 (stmt);
	stmt = _tmp4_;
	_tmp8_ = stmt;
	_tmp9_ = st;
	_tmp10_ = g_strdup (_tmp9_);
	_tmp11_ = g_free;
	_tmp12_ = sqlite3_bind_text (_tmp8_, 1, _tmp10_, -1, _tmp11_);
	if (_tmp12_ != SQLITE_OK) {
		_tmp7_ = TRUE;
	} else {
		sqlite3_stmt* _tmp13_;
		const gchar* _tmp14_;
		gchar* _tmp15_;
		GDestroyNotify _tmp16_;
		gint _tmp17_ = 0;
		_tmp13_ = stmt;
		_tmp14_ = st;
		_tmp15_ = g_strdup (_tmp14_);
		_tmp16_ = g_free;
		_tmp17_ = sqlite3_bind_text (_tmp13_, 2, _tmp15_, -1, _tmp16_);
		_tmp7_ = _tmp17_ != SQLITE_OK;
	}
	_tmp18_ = _tmp7_;
	if (_tmp18_) {
		_tmp6_ = TRUE;
	} else {
		sqlite3_stmt* _tmp19_;
		const gchar* _tmp20_;
		gchar* _tmp21_;
		GDestroyNotify _tmp22_;
		gint _tmp23_ = 0;
		_tmp19_ = stmt;
		_tmp20_ = st;
		_tmp21_ = g_strdup (_tmp20_);
		_tmp22_ = g_free;
		_tmp23_ = sqlite3_bind_text (_tmp19_, 3, _tmp21_, -1, _tmp22_);
		_tmp6_ = _tmp23_ != SQLITE_OK;
	}
	_tmp24_ = _tmp6_;
	if (_tmp24_) {
		_tmp5_ = TRUE;
	} else {
		sqlite3_stmt* _tmp25_;
		gint _tmp26_ = 0;
		_tmp25_ = stmt;
		_tmp26_ = sqlite3_bind_int (_tmp25_, 4, (gint) XNOISE_ITEM_TYPE_LOCAL_AUDIO_TRACK);
		_tmp5_ = _tmp26_ != SQLITE_OK;
	}
	_tmp27_ = _tmp5_;
	if (_tmp27_) {
		XnoiseTrackData** _tmp28_;
		gint _tmp28__length1;
		xnoise_database_reader_db_error (self);
		_tmp28_ = NULL;
		_tmp28__length1 = 0;
		if (result_length1) {
			*result_length1 = _tmp28__length1;
		}
		result = _tmp28_;
		_g_free0 (st);
		retv = (_vala_array_free (retv, retv_length1, (GDestroyNotify) xnoise_track_data_unref), NULL);
		_sqlite3_finalize0 (stmt);
		return result;
	}
	while (TRUE) {
		sqlite3_stmt* _tmp29_;
		gint _tmp30_ = 0;
		XnoiseTrackData* _tmp31_;
		XnoiseTrackData* val;
		XnoiseTrackData* _tmp32_;
		sqlite3_stmt* _tmp33_;
		const gchar* _tmp34_ = NULL;
		gchar* _tmp35_;
		XnoiseTrackData* _tmp36_;
		sqlite3_stmt* _tmp37_;
		const gchar* _tmp38_ = NULL;
		gchar* _tmp39_;
		XnoiseTrackData* _tmp40_;
		sqlite3_stmt* _tmp41_;
		const gchar* _tmp42_ = NULL;
		gchar* _tmp43_;
		XnoiseTrackData* _tmp44_;
		sqlite3_stmt* _tmp45_;
		gint _tmp46_ = 0;
		XnoiseTrackData* _tmp47_;
		sqlite3_stmt* _tmp48_;
		gint _tmp49_ = 0;
		XnoiseTrackData* _tmp50_;
		sqlite3_stmt* _tmp51_;
		gint _tmp52_ = 0;
		sqlite3_stmt* _tmp53_;
		const gchar* _tmp54_ = NULL;
		sqlite3_stmt* _tmp55_;
		gint _tmp56_ = 0;
		XnoiseItem _tmp57_ = {0};
		XnoiseItem _tmp58_;
		XnoiseItem* _tmp59_;
		XnoiseTrackData* _tmp60_;
		sqlite3_stmt* _tmp61_;
		const gchar* _tmp62_ = NULL;
		gchar* _tmp63_;
		XnoiseTrackData* _tmp64_;
		sqlite3_stmt* _tmp65_;
		gint _tmp66_ = 0;
		gboolean _tmp67_ = FALSE;
		XnoiseTrackData* _tmp68_;
		const gchar* _tmp69_;
		gboolean _tmp72_;
		gboolean _tmp75_ = FALSE;
		XnoiseTrackData* _tmp76_;
		const gchar* _tmp77_;
		gboolean _tmp80_;
		gboolean _tmp83_ = FALSE;
		XnoiseTrackData* _tmp84_;
		const gchar* _tmp85_;
		gboolean _tmp88_;
		gboolean _tmp91_ = FALSE;
		XnoiseTrackData* _tmp92_;
		const gchar* _tmp93_;
		gboolean _tmp96_;
		XnoiseTrackData** _tmp115_;
		gint _tmp115__length1;
		XnoiseTrackData* _tmp116_;
		XnoiseTrackData* _tmp117_;
		_tmp29_ = stmt;
		_tmp30_ = sqlite3_step (_tmp29_);
		if (!(_tmp30_ == SQLITE_ROW)) {
			break;
		}
		_tmp31_ = xnoise_track_data_new ();
		val = _tmp31_;
		_tmp32_ = val;
		_tmp33_ = stmt;
		_tmp34_ = sqlite3_column_text (_tmp33_, 0);
		_tmp35_ = g_strdup (_tmp34_);
		_g_free0 (_tmp32_->artist);
		_tmp32_->artist = _tmp35_;
		_tmp36_ = val;
		_tmp37_ = stmt;
		_tmp38_ = sqlite3_column_text (_tmp37_, 1);
		_tmp39_ = g_strdup (_tmp38_);
		_g_free0 (_tmp36_->album);
		_tmp36_->album = _tmp39_;
		_tmp40_ = val;
		_tmp41_ = stmt;
		_tmp42_ = sqlite3_column_text (_tmp41_, 2);
		_tmp43_ = g_strdup (_tmp42_);
		_g_free0 (_tmp40_->title);
		_tmp40_->title = _tmp43_;
		_tmp44_ = val;
		_tmp45_ = stmt;
		_tmp46_ = sqlite3_column_int (_tmp45_, 3);
		_tmp44_->tracknumber = (guint) _tmp46_;
		_tmp47_ = val;
		_tmp48_ = stmt;
		_tmp49_ = sqlite3_column_int (_tmp48_, 6);
		_tmp47_->length = (gint32) _tmp49_;
		_tmp50_ = val;
		_tmp51_ = stmt;
		_tmp52_ = sqlite3_column_int (_tmp51_, 4);
		_tmp53_ = stmt;
		_tmp54_ = sqlite3_column_text (_tmp53_, 5);
		_tmp55_ = stmt;
		_tmp56_ = sqlite3_column_int (_tmp55_, 7);
		xnoise_item_init (&_tmp57_, (XnoiseItemType) _tmp52_, _tmp54_, (gint32) _tmp56_);
		_tmp58_ = _tmp57_;
		_tmp59_ = _xnoise_item_dup0 (&_tmp58_);
		_xnoise_item_free0 (_tmp50_->item);
		_tmp50_->item = _tmp59_;
		xnoise_item_destroy (&_tmp58_);
		_tmp60_ = val;
		_tmp61_ = stmt;
		_tmp62_ = sqlite3_column_text (_tmp61_, 8);
		_tmp63_ = g_strdup (_tmp62_);
		_g_free0 (_tmp60_->genre);
		_tmp60_->genre = _tmp63_;
		_tmp64_ = val;
		_tmp65_ = stmt;
		_tmp66_ = sqlite3_column_int (_tmp65_, 9);
		_tmp64_->year = (guint) _tmp66_;
		_tmp68_ = val;
		_tmp69_ = _tmp68_->artist;
		if (g_strcmp0 (_tmp69_, XNOISE_SERVICES_EMPTYSTRING) == 0) {
			_tmp67_ = TRUE;
		} else {
			XnoiseTrackData* _tmp70_;
			const gchar* _tmp71_;
			_tmp70_ = val;
			_tmp71_ = _tmp70_->artist;
			_tmp67_ = _tmp71_ == NULL;
		}
		_tmp72_ = _tmp67_;
		if (_tmp72_) {
			XnoiseTrackData* _tmp73_;
			gchar* _tmp74_;
			_tmp73_ = val;
			_tmp74_ = g_strdup (XNOISE_SERVICES_UNKNOWN_ARTIST);
			_g_free0 (_tmp73_->artist);
			_tmp73_->artist = _tmp74_;
		}
		_tmp76_ = val;
		_tmp77_ = _tmp76_->album;
		if (g_strcmp0 (_tmp77_, XNOISE_SERVICES_EMPTYSTRING) == 0) {
			_tmp75_ = TRUE;
		} else {
			XnoiseTrackData* _tmp78_;
			const gchar* _tmp79_;
			_tmp78_ = val;
			_tmp79_ = _tmp78_->album;
			_tmp75_ = _tmp79_ == NULL;
		}
		_tmp80_ = _tmp75_;
		if (_tmp80_) {
			XnoiseTrackData* _tmp81_;
			gchar* _tmp82_;
			_tmp81_ = val;
			_tmp82_ = g_strdup (XNOISE_SERVICES_UNKNOWN_ALBUM);
			_g_free0 (_tmp81_->album);
			_tmp81_->album = _tmp82_;
		}
		_tmp84_ = val;
		_tmp85_ = _tmp84_->genre;
		if (g_strcmp0 (_tmp85_, XNOISE_SERVICES_EMPTYSTRING) == 0) {
			_tmp83_ = TRUE;
		} else {
			XnoiseTrackData* _tmp86_;
			const gchar* _tmp87_;
			_tmp86_ = val;
			_tmp87_ = _tmp86_->genre;
			_tmp83_ = _tmp87_ == NULL;
		}
		_tmp88_ = _tmp83_;
		if (_tmp88_) {
			XnoiseTrackData* _tmp89_;
			gchar* _tmp90_;
			_tmp89_ = val;
			_tmp90_ = g_strdup (XNOISE_SERVICES_UNKNOWN_GENRE);
			_g_free0 (_tmp89_->genre);
			_tmp89_->genre = _tmp90_;
		}
		_tmp92_ = val;
		_tmp93_ = _tmp92_->title;
		if (g_strcmp0 (_tmp93_, XNOISE_SERVICES_EMPTYSTRING) == 0) {
			_tmp91_ = TRUE;
		} else {
			XnoiseTrackData* _tmp94_;
			const gchar* _tmp95_;
			_tmp94_ = val;
			_tmp95_ = _tmp94_->title;
			_tmp91_ = _tmp95_ == NULL;
		}
		_tmp96_ = _tmp91_;
		if (_tmp96_) {
			XnoiseTrackData* _tmp97_;
			gchar* _tmp98_;
			XnoiseTrackData* _tmp99_;
			XnoiseItem* _tmp100_;
			const gchar* _tmp101_;
			GFile* _tmp102_ = NULL;
			GFile* file;
			gchar* fileBasename = NULL;
			GFile* _tmp103_;
			XnoiseTrackData* _tmp112_;
			const gchar* _tmp113_;
			gchar* _tmp114_;
			_tmp97_ = val;
			_tmp98_ = g_strdup (XNOISE_SERVICES_UNKNOWN_TITLE);
			_g_free0 (_tmp97_->title);
			_tmp97_->title = _tmp98_;
			_tmp99_ = val;
			_tmp100_ = _tmp99_->item;
			_tmp101_ = (*_tmp100_).uri;
			_tmp102_ = g_file_new_for_uri (_tmp101_);
			file = _tmp102_;
			_tmp103_ = file;
			if (_tmp103_ != NULL) {
				GFile* _tmp104_;
				gchar* _tmp105_ = NULL;
				gchar* _tmp106_;
				gchar* _tmp107_ = NULL;
				_tmp104_ = file;
				_tmp105_ = g_file_get_path (_tmp104_);
				_tmp106_ = _tmp105_;
				_tmp107_ = g_filename_display_basename (_tmp106_);
				_g_free0 (fileBasename);
				fileBasename = _tmp107_;
				_g_free0 (_tmp106_);
			} else {
				XnoiseTrackData* _tmp108_;
				XnoiseItem* _tmp109_;
				const gchar* _tmp110_;
				gchar* _tmp111_;
				_tmp108_ = val;
				_tmp109_ = _tmp108_->item;
				_tmp110_ = (*_tmp109_).uri;
				_tmp111_ = g_strdup (_tmp110_);
				_g_free0 (fileBasename);
				fileBasename = _tmp111_;
			}
			_tmp112_ = val;
			_tmp113_ = fileBasename;
			_tmp114_ = g_strdup (_tmp113_);
			_g_free0 (_tmp112_->title);
			_tmp112_->title = _tmp114_;
			_g_free0 (fileBasename);
			_g_object_unref0 (file);
		}
		_tmp115_ = retv;
		_tmp115__length1 = retv_length1;
		_tmp116_ = val;
		_tmp117_ = _xnoise_track_data_ref0 (_tmp116_);
		_vala_array_add5 (&retv, &retv_length1, &_retv_size_, _tmp117_);
		_xnoise_track_data_unref0 (val);
	}
	_tmp118_ = retv;
	_tmp118__length1 = retv_length1;
	retv = NULL;
	_tmp119_ = _tmp118_;
	_tmp119__length1 = _tmp118__length1;
	if (result_length1) {
		*result_length1 = _tmp119__length1;
	}
	result = _tmp119_;
	_g_free0 (st);
	retv = (_vala_array_free (retv, retv_length1, (GDestroyNotify) xnoise_track_data_unref), NULL);
	_sqlite3_finalize0 (stmt);
	return result;
}


XnoiseItem* xnoise_database_reader_get_streamitem_by_id (XnoiseDatabaseReader* self, gint32 id, const gchar* searchtext) {
	XnoiseItem* result = NULL;
	sqlite3_stmt* stmt = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_ = NULL;
	gchar* st;
	XnoiseItem _tmp2_ = {0};
	XnoiseItem _tmp3_;
	XnoiseItem* _tmp4_;
	XnoiseItem* _tmp5_;
	XnoiseItem* i;
	sqlite3* _tmp6_;
	sqlite3_stmt* _tmp7_ = NULL;
	gboolean _tmp8_ = FALSE;
	gboolean _tmp9_ = FALSE;
	sqlite3_stmt* _tmp10_;
	gint32 _tmp11_;
	gint _tmp12_ = 0;
	gboolean _tmp18_;
	gboolean _tmp24_;
	sqlite3_stmt* _tmp26_;
	gint _tmp27_ = 0;
	XnoiseItem* _tmp39_;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (searchtext != NULL, NULL);
	_tmp0_ = searchtext;
	_tmp1_ = g_strdup_printf ("%%%s%%", _tmp0_);
	st = _tmp1_;
	xnoise_item_init (&_tmp2_, XNOISE_ITEM_TYPE_UNKNOWN, NULL, (gint32) (-1));
	_tmp3_ = _tmp2_;
	_tmp4_ = _xnoise_item_dup0 (&_tmp3_);
	_tmp5_ = _tmp4_;
	xnoise_item_destroy (&_tmp3_);
	i = _tmp5_;
	_tmp6_ = self->priv->db;
	sqlite3_prepare_v2 (_tmp6_, XNOISE_DATABASE_READER_STMT_GET_STREAMITEM_BY_ID, -1, &_tmp7_, NULL);
	_sqlite3_finalize0 (stmt);
	stmt = _tmp7_;
	_tmp10_ = stmt;
	_tmp11_ = id;
	_tmp12_ = sqlite3_bind_int (_tmp10_, 1, (gint) _tmp11_);
	if (_tmp12_ != SQLITE_OK) {
		_tmp9_ = TRUE;
	} else {
		sqlite3_stmt* _tmp13_;
		const gchar* _tmp14_;
		gchar* _tmp15_;
		GDestroyNotify _tmp16_;
		gint _tmp17_ = 0;
		_tmp13_ = stmt;
		_tmp14_ = st;
		_tmp15_ = g_strdup (_tmp14_);
		_tmp16_ = g_free;
		_tmp17_ = sqlite3_bind_text (_tmp13_, 2, _tmp15_, -1, _tmp16_);
		_tmp9_ = _tmp17_ != SQLITE_OK;
	}
	_tmp18_ = _tmp9_;
	if (_tmp18_) {
		_tmp8_ = TRUE;
	} else {
		sqlite3_stmt* _tmp19_;
		const gchar* _tmp20_;
		gchar* _tmp21_;
		GDestroyNotify _tmp22_;
		gint _tmp23_ = 0;
		_tmp19_ = stmt;
		_tmp20_ = st;
		_tmp21_ = g_strdup (_tmp20_);
		_tmp22_ = g_free;
		_tmp23_ = sqlite3_bind_text (_tmp19_, 3, _tmp21_, -1, _tmp22_);
		_tmp8_ = _tmp23_ != SQLITE_OK;
	}
	_tmp24_ = _tmp8_;
	if (_tmp24_) {
		XnoiseItem* _tmp25_;
		xnoise_database_reader_db_error (self);
		_tmp25_ = i;
		i = NULL;
		result = _tmp25_;
		_xnoise_item_free0 (i);
		_g_free0 (st);
		_sqlite3_finalize0 (stmt);
		return result;
	}
	_tmp26_ = stmt;
	_tmp27_ = sqlite3_step (_tmp26_);
	if (_tmp27_ == SQLITE_ROW) {
		sqlite3_stmt* _tmp28_;
		const gchar* _tmp29_ = NULL;
		sqlite3_stmt* _tmp30_;
		gint _tmp31_ = 0;
		XnoiseItem _tmp32_ = {0};
		XnoiseItem _tmp33_;
		XnoiseItem* _tmp34_;
		XnoiseItem* _tmp35_;
		sqlite3_stmt* _tmp36_;
		const gchar* _tmp37_ = NULL;
		gchar* _tmp38_;
		_tmp28_ = stmt;
		_tmp29_ = sqlite3_column_text (_tmp28_, 1);
		_tmp30_ = stmt;
		_tmp31_ = sqlite3_column_int (_tmp30_, 0);
		xnoise_item_init (&_tmp32_, XNOISE_ITEM_TYPE_STREAM, _tmp29_, (gint32) _tmp31_);
		_tmp33_ = _tmp32_;
		_tmp34_ = _xnoise_item_dup0 (&_tmp33_);
		_xnoise_item_free0 (i);
		i = _tmp34_;
		xnoise_item_destroy (&_tmp33_);
		_tmp35_ = i;
		_tmp36_ = stmt;
		_tmp37_ = sqlite3_column_text (_tmp36_, 2);
		_tmp38_ = g_strdup (_tmp37_);
		_g_free0 ((*_tmp35_).text);
		(*_tmp35_).text = _tmp38_;
	}
	_tmp39_ = i;
	i = NULL;
	result = _tmp39_;
	_xnoise_item_free0 (i);
	_g_free0 (st);
	_sqlite3_finalize0 (stmt);
	return result;
}


gboolean xnoise_database_reader_get_stream_td_for_id (XnoiseDatabaseReader* self, gint id, XnoiseTrackData** val) {
	XnoiseTrackData* _vala_val = NULL;
	gboolean result = FALSE;
	sqlite3_stmt* stmt = NULL;
	XnoiseTrackData* _tmp0_;
	sqlite3* _tmp1_;
	sqlite3_stmt* _tmp2_ = NULL;
	sqlite3_stmt* _tmp3_;
	sqlite3_stmt* _tmp4_;
	gint _tmp5_;
	gint _tmp6_ = 0;
	sqlite3_stmt* _tmp7_;
	gint _tmp8_ = 0;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = xnoise_track_data_new ();
	_xnoise_track_data_unref0 (_vala_val);
	_vala_val = _tmp0_;
	_tmp1_ = self->priv->db;
	sqlite3_prepare_v2 (_tmp1_, XNOISE_DATABASE_READER_STMT_STREAM_TD_FOR_ID, -1, &_tmp2_, NULL);
	_sqlite3_finalize0 (stmt);
	stmt = _tmp2_;
	_tmp3_ = stmt;
	sqlite3_reset (_tmp3_);
	_tmp4_ = stmt;
	_tmp5_ = id;
	_tmp6_ = sqlite3_bind_int (_tmp4_, 1, _tmp5_);
	if (_tmp6_ != SQLITE_OK) {
		xnoise_database_reader_db_error (self);
		result = FALSE;
		_sqlite3_finalize0 (stmt);
		if (val) {
			*val = _vala_val;
		} else {
			_xnoise_track_data_unref0 (_vala_val);
		}
		return result;
	}
	_tmp7_ = stmt;
	_tmp8_ = sqlite3_step (_tmp7_);
	if (_tmp8_ == SQLITE_ROW) {
		XnoiseTrackData* _tmp9_;
		gchar* _tmp10_;
		XnoiseTrackData* _tmp11_;
		gchar* _tmp12_;
		XnoiseTrackData* _tmp13_;
		sqlite3_stmt* _tmp14_;
		const gchar* _tmp15_ = NULL;
		gchar* _tmp16_;
		XnoiseTrackData* _tmp17_;
		sqlite3_stmt* _tmp18_;
		const gchar* _tmp19_ = NULL;
		gint _tmp20_;
		XnoiseItem _tmp21_ = {0};
		XnoiseItem _tmp22_;
		XnoiseItem* _tmp23_;
		XnoiseTrackData* _tmp24_;
		XnoiseItem* _tmp25_;
		sqlite3_stmt* _tmp26_;
		const gchar* _tmp27_ = NULL;
		gchar* _tmp28_;
		_tmp9_ = _vala_val;
		_tmp10_ = g_strdup (XNOISE_SERVICES_EMPTYSTRING);
		_g_free0 (_tmp9_->artist);
		_tmp9_->artist = _tmp10_;
		_tmp11_ = _vala_val;
		_tmp12_ = g_strdup (XNOISE_SERVICES_EMPTYSTRING);
		_g_free0 (_tmp11_->album);
		_tmp11_->album = _tmp12_;
		_tmp13_ = _vala_val;
		_tmp14_ = stmt;
		_tmp15_ = sqlite3_column_text (_tmp14_, 0);
		_tmp16_ = g_strdup (_tmp15_);
		_g_free0 (_tmp13_->title);
		_tmp13_->title = _tmp16_;
		_tmp17_ = _vala_val;
		_tmp18_ = stmt;
		_tmp19_ = sqlite3_column_text (_tmp18_, 1);
		_tmp20_ = id;
		xnoise_item_init (&_tmp21_, XNOISE_ITEM_TYPE_STREAM, _tmp19_, (gint32) _tmp20_);
		_tmp22_ = _tmp21_;
		_tmp23_ = _xnoise_item_dup0 (&_tmp22_);
		_xnoise_item_free0 (_tmp17_->item);
		_tmp17_->item = _tmp23_;
		xnoise_item_destroy (&_tmp22_);
		_tmp24_ = _vala_val;
		_tmp25_ = _tmp24_->item;
		_tmp26_ = stmt;
		_tmp27_ = sqlite3_column_text (_tmp26_, 0);
		_tmp28_ = g_strdup (_tmp27_);
		_g_free0 ((*_tmp25_).text);
		(*_tmp25_).text = _tmp28_;
	} else {
		gint _tmp29_;
		_tmp29_ = id;
		g_print ("get_stream_td_for_id: track is not in db. ID: %d\n", _tmp29_);
		result = FALSE;
		_sqlite3_finalize0 (stmt);
		if (val) {
			*val = _vala_val;
		} else {
			_xnoise_track_data_unref0 (_vala_val);
		}
		return result;
	}
	result = TRUE;
	_sqlite3_finalize0 (stmt);
	if (val) {
		*val = _vala_val;
	} else {
		_xnoise_track_data_unref0 (_vala_val);
	}
	return result;
}


gboolean xnoise_database_reader_get_trackdata_for_uri (XnoiseDatabaseReader* self, gchar** uri, XnoiseTrackData** val) {
	XnoiseTrackData* _vala_val = NULL;
	gboolean result = FALSE;
	gboolean retval;
	XnoiseTrackData* _tmp0_;
	const gchar* _tmp1_;
	sqlite3_stmt* stmt = NULL;
	sqlite3* _tmp2_;
	sqlite3_stmt* _tmp3_ = NULL;
	sqlite3_stmt* _tmp4_;
	sqlite3_stmt* _tmp5_;
	const gchar* _tmp6_;
	gchar* _tmp7_;
	GDestroyNotify _tmp8_;
	sqlite3_stmt* _tmp9_;
	gint _tmp10_ = 0;
	XnoiseTrackData* _tmp45_;
	const gchar* _tmp46_;
	XnoiseTrackData* _tmp47_;
	const gchar* _tmp48_;
	XnoiseTrackData* _tmp51_;
	const gchar* _tmp52_;
	XnoiseTrackData* _tmp53_;
	const gchar* _tmp54_;
	XnoiseTrackData* _tmp57_;
	const gchar* _tmp58_;
	XnoiseTrackData* _tmp59_;
	const gchar* _tmp60_;
	XnoiseTrackData* _tmp63_;
	const gchar* _tmp64_;
	XnoiseTrackData* _tmp65_;
	const gchar* _tmp66_;
	g_return_val_if_fail (self != NULL, FALSE);
	retval = FALSE;
	_tmp0_ = xnoise_track_data_new ();
	_xnoise_track_data_unref0 (_vala_val);
	_vala_val = _tmp0_;
	_tmp1_ = *uri;
	if (_tmp1_ == NULL) {
		result = retval;
		if (val) {
			*val = _vala_val;
		} else {
			_xnoise_track_data_unref0 (_vala_val);
		}
		return result;
	}
	_tmp2_ = self->priv->db;
	sqlite3_prepare_v2 (_tmp2_, XNOISE_DATABASE_READER_STMT_TRACKDATA_FOR_URI, -1, &_tmp3_, NULL);
	_sqlite3_finalize0 (stmt);
	stmt = _tmp3_;
	_tmp4_ = stmt;
	sqlite3_reset (_tmp4_);
	_tmp5_ = stmt;
	_tmp6_ = *uri;
	_tmp7_ = g_strdup (_tmp6_);
	_tmp8_ = g_free;
	sqlite3_bind_text (_tmp5_, 1, _tmp7_, -1, _tmp8_);
	_tmp9_ = stmt;
	_tmp10_ = sqlite3_step (_tmp9_);
	if (_tmp10_ == SQLITE_ROW) {
		XnoiseTrackData* _tmp11_;
		sqlite3_stmt* _tmp12_;
		const gchar* _tmp13_ = NULL;
		gchar* _tmp14_;
		XnoiseTrackData* _tmp15_;
		sqlite3_stmt* _tmp16_;
		const gchar* _tmp17_ = NULL;
		gchar* _tmp18_;
		XnoiseTrackData* _tmp19_;
		sqlite3_stmt* _tmp20_;
		const gchar* _tmp21_ = NULL;
		gchar* _tmp22_;
		XnoiseTrackData* _tmp23_;
		sqlite3_stmt* _tmp24_;
		gint _tmp25_ = 0;
		XnoiseTrackData* _tmp26_;
		sqlite3_stmt* _tmp27_;
		gint _tmp28_ = 0;
		XnoiseTrackData* _tmp29_;
		sqlite3_stmt* _tmp30_;
		gint _tmp31_ = 0;
		const gchar* _tmp32_;
		sqlite3_stmt* _tmp33_;
		gint _tmp34_ = 0;
		XnoiseItem _tmp35_ = {0};
		XnoiseItem _tmp36_;
		XnoiseItem* _tmp37_;
		XnoiseTrackData* _tmp38_;
		sqlite3_stmt* _tmp39_;
		const gchar* _tmp40_ = NULL;
		gchar* _tmp41_;
		XnoiseTrackData* _tmp42_;
		sqlite3_stmt* _tmp43_;
		gint _tmp44_ = 0;
		_tmp11_ = _vala_val;
		_tmp12_ = stmt;
		_tmp13_ = sqlite3_column_text (_tmp12_, 0);
		_tmp14_ = g_strdup (_tmp13_);
		_g_free0 (_tmp11_->artist);
		_tmp11_->artist = _tmp14_;
		_tmp15_ = _vala_val;
		_tmp16_ = stmt;
		_tmp17_ = sqlite3_column_text (_tmp16_, 1);
		_tmp18_ = g_strdup (_tmp17_);
		_g_free0 (_tmp15_->album);
		_tmp15_->album = _tmp18_;
		_tmp19_ = _vala_val;
		_tmp20_ = stmt;
		_tmp21_ = sqlite3_column_text (_tmp20_, 2);
		_tmp22_ = g_strdup (_tmp21_);
		_g_free0 (_tmp19_->title);
		_tmp19_->title = _tmp22_;
		_tmp23_ = _vala_val;
		_tmp24_ = stmt;
		_tmp25_ = sqlite3_column_int (_tmp24_, 3);
		_tmp23_->tracknumber = (guint) _tmp25_;
		_tmp26_ = _vala_val;
		_tmp27_ = stmt;
		_tmp28_ = sqlite3_column_int (_tmp27_, 4);
		_tmp26_->length = (gint32) _tmp28_;
		_tmp29_ = _vala_val;
		_tmp30_ = stmt;
		_tmp31_ = sqlite3_column_int (_tmp30_, 5);
		_tmp32_ = *uri;
		_tmp33_ = stmt;
		_tmp34_ = sqlite3_column_int (_tmp33_, 6);
		xnoise_item_init (&_tmp35_, (XnoiseItemType) _tmp31_, _tmp32_, (gint32) _tmp34_);
		_tmp36_ = _tmp35_;
		_tmp37_ = _xnoise_item_dup0 (&_tmp36_);
		_xnoise_item_free0 (_tmp29_->item);
		_tmp29_->item = _tmp37_;
		xnoise_item_destroy (&_tmp36_);
		_tmp38_ = _vala_val;
		_tmp39_ = stmt;
		_tmp40_ = sqlite3_column_text (_tmp39_, 7);
		_tmp41_ = g_strdup (_tmp40_);
		_g_free0 (_tmp38_->genre);
		_tmp38_->genre = _tmp41_;
		_tmp42_ = _vala_val;
		_tmp43_ = stmt;
		_tmp44_ = sqlite3_column_int (_tmp43_, 8);
		_tmp42_->year = (guint) _tmp44_;
		retval = TRUE;
	}
	_tmp45_ = _vala_val;
	_tmp46_ = _tmp45_->artist;
	_tmp47_ = _vala_val;
	_tmp48_ = _tmp47_->artist;
	if ((g_strcmp0 (_tmp46_, XNOISE_SERVICES_EMPTYSTRING) == 0) | (_tmp48_ == NULL)) {
		XnoiseTrackData* _tmp49_;
		gchar* _tmp50_;
		_tmp49_ = _vala_val;
		_tmp50_ = g_strdup (XNOISE_SERVICES_UNKNOWN_ARTIST);
		_g_free0 (_tmp49_->artist);
		_tmp49_->artist = _tmp50_;
	}
	_tmp51_ = _vala_val;
	_tmp52_ = _tmp51_->album;
	_tmp53_ = _vala_val;
	_tmp54_ = _tmp53_->album;
	if ((g_strcmp0 (_tmp52_, XNOISE_SERVICES_EMPTYSTRING) == 0) | (_tmp54_ == NULL)) {
		XnoiseTrackData* _tmp55_;
		gchar* _tmp56_;
		_tmp55_ = _vala_val;
		_tmp56_ = g_strdup (XNOISE_SERVICES_UNKNOWN_ALBUM);
		_g_free0 (_tmp55_->album);
		_tmp55_->album = _tmp56_;
	}
	_tmp57_ = _vala_val;
	_tmp58_ = _tmp57_->genre;
	_tmp59_ = _vala_val;
	_tmp60_ = _tmp59_->genre;
	if ((g_strcmp0 (_tmp58_, XNOISE_SERVICES_EMPTYSTRING) == 0) | (_tmp60_ == NULL)) {
		XnoiseTrackData* _tmp61_;
		gchar* _tmp62_;
		_tmp61_ = _vala_val;
		_tmp62_ = g_strdup (XNOISE_SERVICES_UNKNOWN_GENRE);
		_g_free0 (_tmp61_->genre);
		_tmp61_->genre = _tmp62_;
	}
	_tmp63_ = _vala_val;
	_tmp64_ = _tmp63_->title;
	_tmp65_ = _vala_val;
	_tmp66_ = _tmp65_->title;
	if ((g_strcmp0 (_tmp64_, XNOISE_SERVICES_EMPTYSTRING) == 0) | (_tmp66_ == NULL)) {
		XnoiseTrackData* _tmp67_;
		gchar* _tmp68_;
		const gchar* _tmp69_;
		GFile* _tmp70_ = NULL;
		GFile* file;
		GFile* _tmp71_;
		gchar* _tmp72_ = NULL;
		gchar* fpath;
		gchar* _tmp73_;
		gchar* fileBasename;
		const gchar* _tmp74_;
		XnoiseTrackData* _tmp77_;
		const gchar* _tmp78_;
		gchar* _tmp79_;
		_tmp67_ = _vala_val;
		_tmp68_ = g_strdup (XNOISE_SERVICES_UNKNOWN_TITLE);
		_g_free0 (_tmp67_->title);
		_tmp67_->title = _tmp68_;
		_tmp69_ = *uri;
		_tmp70_ = g_file_new_for_uri (_tmp69_);
		file = _tmp70_;
		_tmp71_ = file;
		_tmp72_ = g_file_get_path (_tmp71_);
		fpath = _tmp72_;
		_tmp73_ = g_strdup (XNOISE_SERVICES_EMPTYSTRING);
		fileBasename = _tmp73_;
		_tmp74_ = fpath;
		if (_tmp74_ != NULL) {
			const gchar* _tmp75_;
			gchar* _tmp76_ = NULL;
			_tmp75_ = fpath;
			_tmp76_ = g_filename_display_basename (_tmp75_);
			_g_free0 (fileBasename);
			fileBasename = _tmp76_;
		}
		_tmp77_ = _vala_val;
		_tmp78_ = fileBasename;
		_tmp79_ = g_strdup (_tmp78_);
		_g_free0 (_tmp77_->title);
		_tmp77_->title = _tmp79_;
		_g_free0 (fileBasename);
		_g_free0 (fpath);
		_g_object_unref0 (file);
	}
	result = retval;
	_sqlite3_finalize0 (stmt);
	if (val) {
		*val = _vala_val;
	} else {
		_xnoise_track_data_unref0 (_vala_val);
	}
	return result;
}


static void _vala_array_add6 (XnoiseItem** array, int* length, int* size, const XnoiseItem* value) {
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (XnoiseItem, *array, *size);
	}
	(*array)[(*length)++] = *value;
}


XnoiseItem* xnoise_database_reader_get_media_folders (XnoiseDatabaseReader* self, int* result_length1) {
	XnoiseItem* result = NULL;
	sqlite3_stmt* stmt = NULL;
	XnoiseItem* _tmp0_ = NULL;
	XnoiseItem* mfolders;
	gint mfolders_length1;
	gint _mfolders_size_;
	sqlite3* _tmp1_;
	sqlite3_stmt* _tmp2_ = NULL;
	XnoiseItem* _tmp23_;
	gint _tmp23__length1;
	XnoiseItem* _tmp24_;
	gint _tmp24__length1;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = g_new0 (XnoiseItem, 0);
	mfolders = _tmp0_;
	mfolders_length1 = 0;
	_mfolders_size_ = mfolders_length1;
	_tmp1_ = self->priv->db;
	sqlite3_prepare_v2 (_tmp1_, XNOISE_DATABASE_READER_STMT_GET_MEDIA_FOLDERS, -1, &_tmp2_, NULL);
	_sqlite3_finalize0 (stmt);
	stmt = _tmp2_;
	while (TRUE) {
		sqlite3_stmt* _tmp3_;
		gint _tmp4_ = 0;
		sqlite3_stmt* _tmp5_;
		const gchar* _tmp6_ = NULL;
		GFile* _tmp7_ = NULL;
		GFile* f;
		GFile* _tmp8_;
		GFile* _tmp9_;
		gchar* _tmp10_ = NULL;
		gchar* _tmp11_;
		XnoiseItem _tmp12_ = {0};
		XnoiseItem _tmp13_;
		XnoiseItem* _tmp14_;
		XnoiseItem* _tmp15_;
		XnoiseItem* i;
		XnoiseItem* _tmp16_;
		sqlite3_stmt* _tmp17_;
		const gchar* _tmp18_ = NULL;
		gchar* _tmp19_;
		XnoiseItem* _tmp20_;
		gint _tmp20__length1;
		XnoiseItem* _tmp21_;
		XnoiseItem _tmp22_ = {0};
		_tmp3_ = stmt;
		_tmp4_ = sqlite3_step (_tmp3_);
		if (!(_tmp4_ == SQLITE_ROW)) {
			break;
		}
		_tmp5_ = stmt;
		_tmp6_ = sqlite3_column_text (_tmp5_, 0);
		_tmp7_ = g_file_new_for_path (_tmp6_);
		f = _tmp7_;
		_tmp8_ = f;
		if (_tmp8_ == NULL) {
			_g_object_unref0 (f);
			continue;
		}
		_tmp9_ = f;
		_tmp10_ = g_file_get_uri (_tmp9_);
		_tmp11_ = _tmp10_;
		xnoise_item_init (&_tmp12_, XNOISE_ITEM_TYPE_LOCAL_FOLDER, _tmp11_, (gint32) (-1));
		_tmp13_ = _tmp12_;
		_tmp14_ = _xnoise_item_dup0 (&_tmp13_);
		_tmp15_ = _tmp14_;
		xnoise_item_destroy (&_tmp13_);
		_g_free0 (_tmp11_);
		i = _tmp15_;
		_tmp16_ = i;
		_tmp17_ = stmt;
		_tmp18_ = sqlite3_column_text (_tmp17_, 0);
		_tmp19_ = g_strdup (_tmp18_);
		_g_free0 ((*_tmp16_).text);
		(*_tmp16_).text = _tmp19_;
		_tmp20_ = mfolders;
		_tmp20__length1 = mfolders_length1;
		_tmp21_ = i;
		xnoise_item_copy (_tmp21_, &_tmp22_);
		_vala_array_add6 (&mfolders, &mfolders_length1, &_mfolders_size_, &_tmp22_);
		_xnoise_item_free0 (i);
		_g_object_unref0 (f);
	}
	_tmp23_ = mfolders;
	_tmp23__length1 = mfolders_length1;
	mfolders = NULL;
	_tmp24_ = _tmp23_;
	_tmp24__length1 = _tmp23__length1;
	if (result_length1) {
		*result_length1 = _tmp24__length1;
	}
	result = _tmp24_;
	mfolders = (_vala_XnoiseItem_array_free (mfolders, mfolders_length1), NULL);
	_sqlite3_finalize0 (stmt);
	return result;
}


static void _vala_array_add7 (XnoiseItem** array, int* length, int* size, const XnoiseItem* value) {
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (XnoiseItem, *array, *size);
	}
	(*array)[(*length)++] = *value;
}


XnoiseItem* xnoise_database_reader_get_stream_items (XnoiseDatabaseReader* self, const gchar* searchtext, int* result_length1) {
	XnoiseItem* result = NULL;
	XnoiseItem* _tmp0_ = NULL;
	XnoiseItem* vals;
	gint vals_length1;
	gint _vals_size_;
	sqlite3_stmt* stmt = NULL;
	sqlite3* _tmp1_;
	sqlite3_stmt* _tmp2_ = NULL;
	sqlite3_stmt* _tmp3_;
	const gchar* _tmp4_;
	gchar* _tmp5_ = NULL;
	GDestroyNotify _tmp6_;
	gint _tmp7_ = 0;
	XnoiseItem* _tmp26_;
	gint _tmp26__length1;
	XnoiseItem* _tmp28_;
	gint _tmp28__length1;
	XnoiseItem* _tmp29_;
	gint _tmp29__length1;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (searchtext != NULL, NULL);
	_tmp0_ = g_new0 (XnoiseItem, 0);
	vals = _tmp0_;
	vals_length1 = 0;
	_vals_size_ = vals_length1;
	_tmp1_ = self->priv->db;
	sqlite3_prepare_v2 (_tmp1_, XNOISE_DATABASE_READER_STMT_GET_STREAM_ITEMS_WITH_SEARCH, -1, &_tmp2_, NULL);
	_sqlite3_finalize0 (stmt);
	stmt = _tmp2_;
	_tmp3_ = stmt;
	_tmp4_ = searchtext;
	_tmp5_ = g_strdup_printf ("%%%s%%", _tmp4_);
	_tmp6_ = g_free;
	_tmp7_ = sqlite3_bind_text (_tmp3_, 1, _tmp5_, -1, _tmp6_);
	if (_tmp7_ != SQLITE_OK) {
		XnoiseItem* _tmp8_;
		gint _tmp8__length1;
		xnoise_database_reader_db_error (self);
		_tmp8_ = NULL;
		_tmp8__length1 = 0;
		if (result_length1) {
			*result_length1 = _tmp8__length1;
		}
		result = _tmp8_;
		_sqlite3_finalize0 (stmt);
		vals = (_vala_XnoiseItem_array_free (vals, vals_length1), NULL);
		return result;
	}
	while (TRUE) {
		sqlite3_stmt* _tmp9_;
		gint _tmp10_ = 0;
		sqlite3_stmt* _tmp11_;
		const gchar* _tmp12_ = NULL;
		sqlite3_stmt* _tmp13_;
		gint _tmp14_ = 0;
		XnoiseItem _tmp15_ = {0};
		XnoiseItem _tmp16_;
		XnoiseItem* _tmp17_;
		XnoiseItem* _tmp18_;
		XnoiseItem* item;
		XnoiseItem* _tmp19_;
		sqlite3_stmt* _tmp20_;
		const gchar* _tmp21_ = NULL;
		gchar* _tmp22_;
		XnoiseItem* _tmp23_;
		gint _tmp23__length1;
		XnoiseItem* _tmp24_;
		XnoiseItem _tmp25_ = {0};
		_tmp9_ = stmt;
		_tmp10_ = sqlite3_step (_tmp9_);
		if (!(_tmp10_ == SQLITE_ROW)) {
			break;
		}
		_tmp11_ = stmt;
		_tmp12_ = sqlite3_column_text (_tmp11_, 1);
		_tmp13_ = stmt;
		_tmp14_ = sqlite3_column_int (_tmp13_, 0);
		xnoise_item_init (&_tmp15_, XNOISE_ITEM_TYPE_STREAM, _tmp12_, (gint32) _tmp14_);
		_tmp16_ = _tmp15_;
		_tmp17_ = _xnoise_item_dup0 (&_tmp16_);
		_tmp18_ = _tmp17_;
		xnoise_item_destroy (&_tmp16_);
		item = _tmp18_;
		_tmp19_ = item;
		_tmp20_ = stmt;
		_tmp21_ = sqlite3_column_text (_tmp20_, 2);
		_tmp22_ = g_strdup (_tmp21_);
		_g_free0 ((*_tmp19_).text);
		(*_tmp19_).text = _tmp22_;
		_tmp23_ = vals;
		_tmp23__length1 = vals_length1;
		_tmp24_ = item;
		xnoise_item_copy (_tmp24_, &_tmp25_);
		_vala_array_add7 (&vals, &vals_length1, &_vals_size_, &_tmp25_);
		_xnoise_item_free0 (item);
	}
	_tmp26_ = vals;
	_tmp26__length1 = vals_length1;
	if (_tmp26__length1 == 0) {
		XnoiseItem* _tmp27_;
		gint _tmp27__length1;
		_tmp27_ = NULL;
		_tmp27__length1 = 0;
		if (result_length1) {
			*result_length1 = _tmp27__length1;
		}
		result = _tmp27_;
		_sqlite3_finalize0 (stmt);
		vals = (_vala_XnoiseItem_array_free (vals, vals_length1), NULL);
		return result;
	}
	_tmp28_ = vals;
	_tmp28__length1 = vals_length1;
	vals = NULL;
	_tmp29_ = _tmp28_;
	_tmp29__length1 = _tmp28__length1;
	if (result_length1) {
		*result_length1 = _tmp29__length1;
	}
	result = _tmp29_;
	_sqlite3_finalize0 (stmt);
	vals = (_vala_XnoiseItem_array_free (vals, vals_length1), NULL);
	return result;
}


static void _vala_array_add8 (XnoiseItem** array, int* length, int* size, const XnoiseItem* value) {
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (XnoiseItem, *array, *size);
	}
	(*array)[(*length)++] = *value;
}


XnoiseItem* xnoise_database_reader_get_some_lastused_items (XnoiseDatabaseReader* self, gint limit, gint offset, int* result_length1) {
	XnoiseItem* result = NULL;
	XnoiseItem* _tmp0_ = NULL;
	XnoiseItem* val;
	gint val_length1;
	gint _val_size_;
	sqlite3_stmt* stmt = NULL;
	sqlite3* _tmp1_;
	sqlite3_stmt* _tmp2_ = NULL;
	gboolean _tmp3_ = FALSE;
	sqlite3_stmt* _tmp4_;
	gint _tmp5_;
	gint _tmp6_ = 0;
	gboolean _tmp10_;
	XnoiseItem* _tmp28_;
	gint _tmp28__length1;
	XnoiseItem* _tmp29_;
	gint _tmp29__length1;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = g_new0 (XnoiseItem, 0);
	val = _tmp0_;
	val_length1 = 0;
	_val_size_ = val_length1;
	_tmp1_ = self->priv->db;
	sqlite3_prepare_v2 (_tmp1_, XNOISE_DATABASE_READER_STMT_GET_SOME_LASTUSED_ITEMS, -1, &_tmp2_, NULL);
	_sqlite3_finalize0 (stmt);
	stmt = _tmp2_;
	_tmp4_ = stmt;
	_tmp5_ = limit;
	_tmp6_ = sqlite3_bind_int (_tmp4_, 1, _tmp5_);
	if (_tmp6_ != SQLITE_OK) {
		_tmp3_ = TRUE;
	} else {
		sqlite3_stmt* _tmp7_;
		gint _tmp8_;
		gint _tmp9_ = 0;
		_tmp7_ = stmt;
		_tmp8_ = offset;
		_tmp9_ = sqlite3_bind_int (_tmp7_, 2, _tmp8_);
		_tmp3_ = _tmp9_ != SQLITE_OK;
	}
	_tmp10_ = _tmp3_;
	if (_tmp10_) {
		XnoiseItem* _tmp11_;
		gint _tmp11__length1;
		XnoiseItem* _tmp12_;
		gint _tmp12__length1;
		xnoise_database_reader_db_error (self);
		_tmp11_ = val;
		_tmp11__length1 = val_length1;
		val = NULL;
		_tmp12_ = _tmp11_;
		_tmp12__length1 = _tmp11__length1;
		if (result_length1) {
			*result_length1 = _tmp12__length1;
		}
		result = _tmp12_;
		_sqlite3_finalize0 (stmt);
		val = (_vala_XnoiseItem_array_free (val, val_length1), NULL);
		return result;
	}
	while (TRUE) {
		sqlite3_stmt* _tmp13_;
		gint _tmp14_ = 0;
		sqlite3_stmt* _tmp15_;
		gint _tmp16_ = 0;
		sqlite3_stmt* _tmp17_;
		const gchar* _tmp18_ = NULL;
		sqlite3_stmt* _tmp19_;
		gint _tmp20_ = 0;
		XnoiseItem _tmp21_ = {0};
		XnoiseItem _tmp22_;
		XnoiseItem* _tmp23_;
		XnoiseItem* _tmp24_;
		XnoiseItem* item;
		XnoiseItem* _tmp25_;
		gint _tmp25__length1;
		XnoiseItem* _tmp26_;
		XnoiseItem _tmp27_ = {0};
		_tmp13_ = stmt;
		_tmp14_ = sqlite3_step (_tmp13_);
		if (!(_tmp14_ == SQLITE_ROW)) {
			break;
		}
		_tmp15_ = stmt;
		_tmp16_ = sqlite3_column_int (_tmp15_, 0);
		_tmp17_ = stmt;
		_tmp18_ = sqlite3_column_text (_tmp17_, 1);
		_tmp19_ = stmt;
		_tmp20_ = sqlite3_column_int (_tmp19_, 2);
		xnoise_item_init (&_tmp21_, (XnoiseItemType) _tmp16_, _tmp18_, (gint32) _tmp20_);
		_tmp22_ = _tmp21_;
		_tmp23_ = _xnoise_item_dup0 (&_tmp22_);
		_tmp24_ = _tmp23_;
		xnoise_item_destroy (&_tmp22_);
		item = _tmp24_;
		_tmp25_ = val;
		_tmp25__length1 = val_length1;
		_tmp26_ = item;
		xnoise_item_copy (_tmp26_, &_tmp27_);
		_vala_array_add8 (&val, &val_length1, &_val_size_, &_tmp27_);
		_xnoise_item_free0 (item);
	}
	_tmp28_ = val;
	_tmp28__length1 = val_length1;
	val = NULL;
	_tmp29_ = _tmp28_;
	_tmp29__length1 = _tmp28__length1;
	if (result_length1) {
		*result_length1 = _tmp29__length1;
	}
	result = _tmp29_;
	_sqlite3_finalize0 (stmt);
	val = (_vala_XnoiseItem_array_free (val, val_length1), NULL);
	return result;
}


guint xnoise_database_reader_count_lastused_items (XnoiseDatabaseReader* self) {
	guint result = 0U;
	guint val;
	sqlite3_stmt* stmt = NULL;
	sqlite3* _tmp0_;
	sqlite3_stmt* _tmp1_ = NULL;
	sqlite3_stmt* _tmp2_;
	gint _tmp3_ = 0;
	g_return_val_if_fail (self != NULL, 0U);
	val = (guint) 0;
	_tmp0_ = self->priv->db;
	sqlite3_prepare_v2 (_tmp0_, XNOISE_DATABASE_READER_STMT_CNT_LASTUSED, -1, &_tmp1_, NULL);
	_sqlite3_finalize0 (stmt);
	stmt = _tmp1_;
	_tmp2_ = stmt;
	_tmp3_ = sqlite3_step (_tmp2_);
	if (_tmp3_ == SQLITE_ROW) {
		sqlite3_stmt* _tmp4_;
		gint _tmp5_ = 0;
		_tmp4_ = stmt;
		_tmp5_ = sqlite3_column_int (_tmp4_, 0);
		result = (guint) _tmp5_;
		_sqlite3_finalize0 (stmt);
		return result;
	}
	result = val;
	_sqlite3_finalize0 (stmt);
	return result;
}


static void _vala_array_add9 (XnoiseTrackData*** array, int* length, int* size, XnoiseTrackData* value) {
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (XnoiseTrackData*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}


XnoiseTrackData** xnoise_database_reader_get_stream_data (XnoiseDatabaseReader* self, const gchar* searchtext, int* result_length1) {
	XnoiseTrackData** result = NULL;
	XnoiseTrackData** _tmp0_ = NULL;
	XnoiseTrackData** val;
	gint val_length1;
	gint _val_size_;
	sqlite3_stmt* stmt = NULL;
	sqlite3* _tmp1_;
	sqlite3_stmt* _tmp2_ = NULL;
	sqlite3_stmt* _tmp3_;
	const gchar* _tmp4_;
	gchar* _tmp5_ = NULL;
	GDestroyNotify _tmp6_;
	gint _tmp7_ = 0;
	XnoiseTrackData** _tmp41_;
	gint _tmp41__length1;
	XnoiseTrackData** _tmp42_;
	gint _tmp42__length1;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (searchtext != NULL, NULL);
	_tmp0_ = g_new0 (XnoiseTrackData*, 0 + 1);
	val = _tmp0_;
	val_length1 = 0;
	_val_size_ = val_length1;
	_tmp1_ = self->priv->db;
	sqlite3_prepare_v2 (_tmp1_, XNOISE_DATABASE_READER_STMT_GET_STREAM_DATA, -1, &_tmp2_, NULL);
	_sqlite3_finalize0 (stmt);
	stmt = _tmp2_;
	_tmp3_ = stmt;
	_tmp4_ = searchtext;
	_tmp5_ = g_strdup_printf ("%%%s%%", _tmp4_);
	_tmp6_ = g_free;
	_tmp7_ = sqlite3_bind_text (_tmp3_, 1, _tmp5_, -1, _tmp6_);
	if (_tmp7_ != SQLITE_OK) {
		XnoiseTrackData** _tmp8_;
		gint _tmp8__length1;
		XnoiseTrackData** _tmp9_;
		gint _tmp9__length1;
		xnoise_database_reader_db_error (self);
		_tmp8_ = val;
		_tmp8__length1 = val_length1;
		val = NULL;
		_tmp9_ = _tmp8_;
		_tmp9__length1 = _tmp8__length1;
		if (result_length1) {
			*result_length1 = _tmp9__length1;
		}
		result = _tmp9_;
		_sqlite3_finalize0 (stmt);
		val = (_vala_array_free (val, val_length1, (GDestroyNotify) xnoise_track_data_unref), NULL);
		return result;
	}
	while (TRUE) {
		sqlite3_stmt* _tmp10_;
		gint _tmp11_ = 0;
		XnoiseTrackData* _tmp12_;
		XnoiseTrackData* td;
		XnoiseTrackData* _tmp13_;
		sqlite3_stmt* _tmp14_;
		const gchar* _tmp15_ = NULL;
		gchar* _tmp16_;
		XnoiseTrackData* _tmp17_;
		sqlite3_stmt* _tmp18_;
		const gchar* _tmp19_ = NULL;
		gchar* _tmp20_;
		XnoiseTrackData* _tmp21_;
		sqlite3_stmt* _tmp22_;
		const gchar* _tmp23_ = NULL;
		gchar* _tmp24_;
		XnoiseTrackData* _tmp25_;
		sqlite3_stmt* _tmp26_;
		const gchar* _tmp27_ = NULL;
		sqlite3_stmt* _tmp28_;
		gint _tmp29_ = 0;
		XnoiseItem _tmp30_ = {0};
		XnoiseItem _tmp31_;
		XnoiseItem* _tmp32_;
		XnoiseTrackData* _tmp33_;
		XnoiseItem* _tmp34_;
		sqlite3_stmt* _tmp35_;
		const gchar* _tmp36_ = NULL;
		gchar* _tmp37_;
		XnoiseTrackData** _tmp38_;
		gint _tmp38__length1;
		XnoiseTrackData* _tmp39_;
		XnoiseTrackData* _tmp40_;
		_tmp10_ = stmt;
		_tmp11_ = sqlite3_step (_tmp10_);
		if (!(_tmp11_ == SQLITE_ROW)) {
			break;
		}
		_tmp12_ = xnoise_track_data_new ();
		td = _tmp12_;
		_tmp13_ = td;
		_tmp14_ = stmt;
		_tmp15_ = sqlite3_column_text (_tmp14_, 2);
		_tmp16_ = g_strdup (_tmp15_);
		_g_free0 (_tmp13_->title);
		_tmp13_->title = _tmp16_;
		_tmp17_ = td;
		_tmp18_ = stmt;
		_tmp19_ = sqlite3_column_text (_tmp18_, 2);
		_tmp20_ = g_strdup (_tmp19_);
		_g_free0 (_tmp17_->name);
		_tmp17_->name = _tmp20_;
		_tmp21_ = td;
		_tmp22_ = stmt;
		_tmp23_ = sqlite3_column_text (_tmp22_, 1);
		_tmp24_ = g_strdup (_tmp23_);
		_g_free0 (_tmp21_->name);
		_tmp21_->name = _tmp24_;
		_tmp25_ = td;
		_tmp26_ = stmt;
		_tmp27_ = sqlite3_column_text (_tmp26_, 1);
		_tmp28_ = stmt;
		_tmp29_ = sqlite3_column_int (_tmp28_, 0);
		xnoise_item_init (&_tmp30_, XNOISE_ITEM_TYPE_STREAM, _tmp27_, (gint32) _tmp29_);
		_tmp31_ = _tmp30_;
		_tmp32_ = _xnoise_item_dup0 (&_tmp31_);
		_xnoise_item_free0 (_tmp25_->item);
		_tmp25_->item = _tmp32_;
		xnoise_item_destroy (&_tmp31_);
		_tmp33_ = td;
		_tmp34_ = _tmp33_->item;
		_tmp35_ = stmt;
		_tmp36_ = sqlite3_column_text (_tmp35_, 2);
		_tmp37_ = g_strdup (_tmp36_);
		_g_free0 ((*_tmp34_).text);
		(*_tmp34_).text = _tmp37_;
		_tmp38_ = val;
		_tmp38__length1 = val_length1;
		_tmp39_ = td;
		_tmp40_ = _xnoise_track_data_ref0 (_tmp39_);
		_vala_array_add9 (&val, &val_length1, &_val_size_, _tmp40_);
		_xnoise_track_data_unref0 (td);
	}
	_tmp41_ = val;
	_tmp41__length1 = val_length1;
	val = NULL;
	_tmp42_ = _tmp41_;
	_tmp42__length1 = _tmp41__length1;
	if (result_length1) {
		*result_length1 = _tmp42__length1;
	}
	result = _tmp42_;
	_sqlite3_finalize0 (stmt);
	val = (_vala_array_free (val, val_length1, (GDestroyNotify) xnoise_track_data_unref), NULL);
	return result;
}


static void _vala_array_add10 (XnoiseItem** array, int* length, int* size, const XnoiseItem* value) {
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (XnoiseItem, *array, *size);
	}
	(*array)[(*length)++] = *value;
}


XnoiseItem* xnoise_database_reader_get_video_items (XnoiseDatabaseReader* self, const gchar* searchtext, int* result_length1) {
	XnoiseItem* result = NULL;
	XnoiseItem* _tmp0_ = NULL;
	XnoiseItem* val;
	gint val_length1;
	gint _val_size_;
	sqlite3_stmt* stmt = NULL;
	sqlite3* _tmp1_;
	sqlite3_stmt* _tmp2_ = NULL;
	gboolean _tmp3_ = FALSE;
	sqlite3_stmt* _tmp4_;
	gint _tmp5_ = 0;
	gboolean _tmp11_;
	XnoiseItem* _tmp26_;
	gint _tmp26__length1;
	XnoiseItem* _tmp28_;
	gint _tmp28__length1;
	XnoiseItem* _tmp29_;
	gint _tmp29__length1;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (searchtext != NULL, NULL);
	_tmp0_ = g_new0 (XnoiseItem, 0);
	val = _tmp0_;
	val_length1 = 0;
	_val_size_ = val_length1;
	_tmp1_ = self->priv->db;
	sqlite3_prepare_v2 (_tmp1_, XNOISE_DATABASE_READER_STMT_GET_VIDEO_ITEMS, -1, &_tmp2_, NULL);
	_sqlite3_finalize0 (stmt);
	stmt = _tmp2_;
	_tmp4_ = stmt;
	_tmp5_ = sqlite3_bind_int (_tmp4_, 1, (gint) XNOISE_ITEM_TYPE_LOCAL_VIDEO_TRACK);
	if (_tmp5_ != SQLITE_OK) {
		_tmp3_ = TRUE;
	} else {
		sqlite3_stmt* _tmp6_;
		const gchar* _tmp7_;
		gchar* _tmp8_ = NULL;
		GDestroyNotify _tmp9_;
		gint _tmp10_ = 0;
		_tmp6_ = stmt;
		_tmp7_ = searchtext;
		_tmp8_ = g_strdup_printf ("%%%s%%", _tmp7_);
		_tmp9_ = g_free;
		_tmp10_ = sqlite3_bind_text (_tmp6_, 2, _tmp8_, -1, _tmp9_);
		_tmp3_ = _tmp10_ != SQLITE_OK;
	}
	_tmp11_ = _tmp3_;
	if (_tmp11_) {
		XnoiseItem* _tmp12_;
		gint _tmp12__length1;
		XnoiseItem* _tmp13_;
		gint _tmp13__length1;
		xnoise_database_reader_db_error (self);
		_tmp12_ = val;
		_tmp12__length1 = val_length1;
		val = NULL;
		_tmp13_ = _tmp12_;
		_tmp13__length1 = _tmp12__length1;
		if (result_length1) {
			*result_length1 = _tmp13__length1;
		}
		result = _tmp13_;
		_sqlite3_finalize0 (stmt);
		val = (_vala_XnoiseItem_array_free (val, val_length1), NULL);
		return result;
	}
	while (TRUE) {
		sqlite3_stmt* _tmp14_;
		gint _tmp15_ = 0;
		sqlite3_stmt* _tmp16_;
		const gchar* _tmp17_ = NULL;
		sqlite3_stmt* _tmp18_;
		gint _tmp19_ = 0;
		XnoiseItem i = {0};
		sqlite3_stmt* _tmp20_;
		const gchar* _tmp21_ = NULL;
		gchar* _tmp22_;
		XnoiseItem* _tmp23_;
		gint _tmp23__length1;
		XnoiseItem _tmp24_;
		XnoiseItem _tmp25_ = {0};
		_tmp14_ = stmt;
		_tmp15_ = sqlite3_step (_tmp14_);
		if (!(_tmp15_ == SQLITE_ROW)) {
			break;
		}
		_tmp16_ = stmt;
		_tmp17_ = sqlite3_column_text (_tmp16_, 2);
		_tmp18_ = stmt;
		_tmp19_ = sqlite3_column_int (_tmp18_, 1);
		xnoise_item_init (&i, XNOISE_ITEM_TYPE_LOCAL_VIDEO_TRACK, _tmp17_, (gint32) _tmp19_);
		_tmp20_ = stmt;
		_tmp21_ = sqlite3_column_text (_tmp20_, 0);
		_tmp22_ = g_strdup (_tmp21_);
		_g_free0 (i.text);
		i.text = _tmp22_;
		_tmp23_ = val;
		_tmp23__length1 = val_length1;
		_tmp24_ = i;
		xnoise_item_copy (&_tmp24_, &_tmp25_);
		_vala_array_add10 (&val, &val_length1, &_val_size_, &_tmp25_);
		xnoise_item_destroy (&i);
	}
	_tmp26_ = val;
	_tmp26__length1 = val_length1;
	if (_tmp26__length1 == 0) {
		XnoiseItem* _tmp27_;
		gint _tmp27__length1;
		_tmp27_ = NULL;
		_tmp27__length1 = 0;
		if (result_length1) {
			*result_length1 = _tmp27__length1;
		}
		result = _tmp27_;
		_sqlite3_finalize0 (stmt);
		val = (_vala_XnoiseItem_array_free (val, val_length1), NULL);
		return result;
	}
	_tmp28_ = val;
	_tmp28__length1 = val_length1;
	val = NULL;
	_tmp29_ = _tmp28_;
	_tmp29__length1 = _tmp28__length1;
	if (result_length1) {
		*result_length1 = _tmp29__length1;
	}
	result = _tmp29_;
	_sqlite3_finalize0 (stmt);
	val = (_vala_XnoiseItem_array_free (val, val_length1), NULL);
	return result;
}


static void _vala_array_add11 (XnoiseTrackData*** array, int* length, int* size, XnoiseTrackData* value) {
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (XnoiseTrackData*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}


XnoiseTrackData** xnoise_database_reader_get_video_data (XnoiseDatabaseReader* self, const gchar* searchtext, int* result_length1) {
	XnoiseTrackData** result = NULL;
	XnoiseTrackData** _tmp0_ = NULL;
	XnoiseTrackData** val;
	gint val_length1;
	gint _val_size_;
	sqlite3_stmt* stmt = NULL;
	sqlite3* _tmp1_;
	sqlite3_stmt* _tmp2_ = NULL;
	gboolean _tmp3_ = FALSE;
	sqlite3_stmt* _tmp4_;
	gint _tmp5_ = 0;
	gboolean _tmp11_;
	XnoiseTrackData** _tmp54_;
	gint _tmp54__length1;
	XnoiseTrackData** _tmp55_;
	gint _tmp55__length1;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (searchtext != NULL, NULL);
	_tmp0_ = g_new0 (XnoiseTrackData*, 0 + 1);
	val = _tmp0_;
	val_length1 = 0;
	_val_size_ = val_length1;
	_tmp1_ = self->priv->db;
	sqlite3_prepare_v2 (_tmp1_, XNOISE_DATABASE_READER_STMT_GET_VIDEO_DATA, -1, &_tmp2_, NULL);
	_sqlite3_finalize0 (stmt);
	stmt = _tmp2_;
	_tmp4_ = stmt;
	_tmp5_ = sqlite3_bind_int (_tmp4_, 1, (gint) XNOISE_ITEM_TYPE_LOCAL_VIDEO_TRACK);
	if (_tmp5_ != SQLITE_OK) {
		_tmp3_ = TRUE;
	} else {
		sqlite3_stmt* _tmp6_;
		const gchar* _tmp7_;
		gchar* _tmp8_ = NULL;
		GDestroyNotify _tmp9_;
		gint _tmp10_ = 0;
		_tmp6_ = stmt;
		_tmp7_ = searchtext;
		_tmp8_ = g_strdup_printf ("%%%s%%", _tmp7_);
		_tmp9_ = g_free;
		_tmp10_ = sqlite3_bind_text (_tmp6_, 2, _tmp8_, -1, _tmp9_);
		_tmp3_ = _tmp10_ != SQLITE_OK;
	}
	_tmp11_ = _tmp3_;
	if (_tmp11_) {
		XnoiseTrackData** _tmp12_;
		gint _tmp12__length1;
		XnoiseTrackData** _tmp13_;
		gint _tmp13__length1;
		xnoise_database_reader_db_error (self);
		_tmp12_ = val;
		_tmp12__length1 = val_length1;
		val = NULL;
		_tmp13_ = _tmp12_;
		_tmp13__length1 = _tmp12__length1;
		if (result_length1) {
			*result_length1 = _tmp13__length1;
		}
		result = _tmp13_;
		_sqlite3_finalize0 (stmt);
		val = (_vala_array_free (val, val_length1, (GDestroyNotify) xnoise_track_data_unref), NULL);
		return result;
	}
	while (TRUE) {
		sqlite3_stmt* _tmp14_;
		gint _tmp15_ = 0;
		XnoiseTrackData* _tmp16_;
		XnoiseTrackData* td;
		XnoiseTrackData* _tmp17_;
		sqlite3_stmt* _tmp18_;
		const gchar* _tmp19_ = NULL;
		gchar* _tmp20_;
		XnoiseTrackData* _tmp21_;
		sqlite3_stmt* _tmp22_;
		const gchar* _tmp23_ = NULL;
		gchar* _tmp24_;
		XnoiseTrackData* _tmp25_;
		sqlite3_stmt* _tmp26_;
		const gchar* _tmp27_ = NULL;
		gchar* _tmp28_;
		XnoiseTrackData* _tmp29_;
		sqlite3_stmt* _tmp30_;
		gint _tmp31_ = 0;
		XnoiseTrackData* _tmp32_;
		sqlite3_stmt* _tmp33_;
		gint _tmp34_ = 0;
		XnoiseTrackData* _tmp35_;
		sqlite3_stmt* _tmp36_;
		const gchar* _tmp37_ = NULL;
		gchar* _tmp38_;
		XnoiseTrackData* _tmp39_;
		sqlite3_stmt* _tmp40_;
		const gchar* _tmp41_ = NULL;
		gchar* _tmp42_;
		XnoiseTrackData* _tmp43_;
		sqlite3_stmt* _tmp44_;
		const gchar* _tmp45_ = NULL;
		sqlite3_stmt* _tmp46_;
		gint _tmp47_ = 0;
		XnoiseItem _tmp48_ = {0};
		XnoiseItem _tmp49_;
		XnoiseItem* _tmp50_;
		XnoiseTrackData** _tmp51_;
		gint _tmp51__length1;
		XnoiseTrackData* _tmp52_;
		XnoiseTrackData* _tmp53_;
		_tmp14_ = stmt;
		_tmp15_ = sqlite3_step (_tmp14_);
		if (!(_tmp15_ == SQLITE_ROW)) {
			break;
		}
		_tmp16_ = xnoise_track_data_new ();
		td = _tmp16_;
		_tmp17_ = td;
		_tmp18_ = stmt;
		_tmp19_ = sqlite3_column_text (_tmp18_, 4);
		_tmp20_ = g_strdup (_tmp19_);
		_g_free0 (_tmp17_->artist);
		_tmp17_->artist = _tmp20_;
		_tmp21_ = td;
		_tmp22_ = stmt;
		_tmp23_ = sqlite3_column_text (_tmp22_, 5);
		_tmp24_ = g_strdup (_tmp23_);
		_g_free0 (_tmp21_->album);
		_tmp21_->album = _tmp24_;
		_tmp25_ = td;
		_tmp26_ = stmt;
		_tmp27_ = sqlite3_column_text (_tmp26_, 0);
		_tmp28_ = g_strdup (_tmp27_);
		_g_free0 (_tmp25_->title);
		_tmp25_->title = _tmp28_;
		_tmp29_ = td;
		_tmp30_ = stmt;
		_tmp31_ = sqlite3_column_int (_tmp30_, 2);
		_tmp29_->tracknumber = (guint) _tmp31_;
		_tmp32_ = td;
		_tmp33_ = stmt;
		_tmp34_ = sqlite3_column_int (_tmp33_, 6);
		_tmp32_->length = (gint32) _tmp34_;
		_tmp35_ = td;
		_tmp36_ = stmt;
		_tmp37_ = sqlite3_column_text (_tmp36_, 7);
		_tmp38_ = g_strdup (_tmp37_);
		_g_free0 (_tmp35_->genre);
		_tmp35_->genre = _tmp38_;
		_tmp39_ = td;
		_tmp40_ = stmt;
		_tmp41_ = sqlite3_column_text (_tmp40_, 0);
		_tmp42_ = g_strdup (_tmp41_);
		_g_free0 (_tmp39_->name);
		_tmp39_->name = _tmp42_;
		_tmp43_ = td;
		_tmp44_ = stmt;
		_tmp45_ = sqlite3_column_text (_tmp44_, 3);
		_tmp46_ = stmt;
		_tmp47_ = sqlite3_column_int (_tmp46_, 1);
		xnoise_item_init (&_tmp48_, XNOISE_ITEM_TYPE_LOCAL_VIDEO_TRACK, _tmp45_, (gint32) _tmp47_);
		_tmp49_ = _tmp48_;
		_tmp50_ = _xnoise_item_dup0 (&_tmp49_);
		_xnoise_item_free0 (_tmp43_->item);
		_tmp43_->item = _tmp50_;
		xnoise_item_destroy (&_tmp49_);
		_tmp51_ = val;
		_tmp51__length1 = val_length1;
		_tmp52_ = td;
		_tmp53_ = _xnoise_track_data_ref0 (_tmp52_);
		_vala_array_add11 (&val, &val_length1, &_val_size_, _tmp53_);
		_xnoise_track_data_unref0 (td);
	}
	_tmp54_ = val;
	_tmp54__length1 = val_length1;
	val = NULL;
	_tmp55_ = _tmp54_;
	_tmp55__length1 = _tmp54__length1;
	if (result_length1) {
		*result_length1 = _tmp55__length1;
	}
	result = _tmp55_;
	_sqlite3_finalize0 (stmt);
	val = (_vala_array_free (val, val_length1, (GDestroyNotify) xnoise_track_data_unref), NULL);
	return result;
}


static void _vala_array_add12 (XnoiseTrackData*** array, int* length, int* size, XnoiseTrackData* value) {
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (XnoiseTrackData*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}


XnoiseTrackData** xnoise_database_reader_get_trackdata_for_video (XnoiseDatabaseReader* self, const gchar* searchtext, int* result_length1) {
	XnoiseTrackData** result = NULL;
	XnoiseTrackData** _tmp0_ = NULL;
	XnoiseTrackData** val;
	gint val_length1;
	gint _val_size_;
	sqlite3_stmt* stmt = NULL;
	sqlite3* _tmp1_;
	sqlite3_stmt* _tmp2_ = NULL;
	gboolean _tmp3_ = FALSE;
	sqlite3_stmt* _tmp4_;
	gint _tmp5_ = 0;
	gboolean _tmp11_;
	XnoiseTrackData** _tmp57_;
	gint _tmp57__length1;
	XnoiseTrackData** _tmp58_;
	gint _tmp58__length1;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (searchtext != NULL, NULL);
	_tmp0_ = g_new0 (XnoiseTrackData*, 0 + 1);
	val = _tmp0_;
	val_length1 = 0;
	_val_size_ = val_length1;
	_tmp1_ = self->priv->db;
	sqlite3_prepare_v2 (_tmp1_, XNOISE_DATABASE_READER_STMT_GET_TRACKDATA_FOR_VIDEO, -1, &_tmp2_, NULL);
	_sqlite3_finalize0 (stmt);
	stmt = _tmp2_;
	_tmp4_ = stmt;
	_tmp5_ = sqlite3_bind_int (_tmp4_, 1, (gint) XNOISE_ITEM_TYPE_LOCAL_VIDEO_TRACK);
	if (_tmp5_ != SQLITE_OK) {
		_tmp3_ = TRUE;
	} else {
		sqlite3_stmt* _tmp6_;
		const gchar* _tmp7_;
		gchar* _tmp8_ = NULL;
		GDestroyNotify _tmp9_;
		gint _tmp10_ = 0;
		_tmp6_ = stmt;
		_tmp7_ = searchtext;
		_tmp8_ = g_strdup_printf ("%%%s%%", _tmp7_);
		_tmp9_ = g_free;
		_tmp10_ = sqlite3_bind_text (_tmp6_, 2, _tmp8_, -1, _tmp9_);
		_tmp3_ = _tmp10_ != SQLITE_OK;
	}
	_tmp11_ = _tmp3_;
	if (_tmp11_) {
		XnoiseTrackData** _tmp12_;
		gint _tmp12__length1;
		XnoiseTrackData** _tmp13_;
		gint _tmp13__length1;
		xnoise_database_reader_db_error (self);
		_tmp12_ = val;
		_tmp12__length1 = val_length1;
		val = NULL;
		_tmp13_ = _tmp12_;
		_tmp13__length1 = _tmp12__length1;
		if (result_length1) {
			*result_length1 = _tmp13__length1;
		}
		result = _tmp13_;
		_sqlite3_finalize0 (stmt);
		val = (_vala_array_free (val, val_length1, (GDestroyNotify) xnoise_track_data_unref), NULL);
		return result;
	}
	while (TRUE) {
		sqlite3_stmt* _tmp14_;
		gint _tmp15_ = 0;
		XnoiseTrackData* _tmp16_;
		XnoiseTrackData* td;
		XnoiseTrackData* _tmp17_;
		sqlite3_stmt* _tmp18_;
		const gchar* _tmp19_ = NULL;
		gchar* _tmp20_;
		XnoiseTrackData* _tmp21_;
		sqlite3_stmt* _tmp22_;
		const gchar* _tmp23_ = NULL;
		gchar* _tmp24_;
		XnoiseTrackData* _tmp25_;
		sqlite3_stmt* _tmp26_;
		const gchar* _tmp27_ = NULL;
		gchar* _tmp28_;
		XnoiseTrackData* _tmp29_;
		sqlite3_stmt* _tmp30_;
		gint _tmp31_ = 0;
		XnoiseTrackData* _tmp32_;
		sqlite3_stmt* _tmp33_;
		gint _tmp34_ = 0;
		XnoiseTrackData* _tmp35_;
		sqlite3_stmt* _tmp36_;
		const gchar* _tmp37_ = NULL;
		gchar* _tmp38_;
		XnoiseTrackData* _tmp39_;
		sqlite3_stmt* _tmp40_;
		gint _tmp41_ = 0;
		XnoiseTrackData* _tmp42_;
		sqlite3_stmt* _tmp43_;
		const gchar* _tmp44_ = NULL;
		gchar* _tmp45_;
		XnoiseTrackData* _tmp46_;
		sqlite3_stmt* _tmp47_;
		const gchar* _tmp48_ = NULL;
		sqlite3_stmt* _tmp49_;
		gint _tmp50_ = 0;
		XnoiseItem _tmp51_ = {0};
		XnoiseItem _tmp52_;
		XnoiseItem* _tmp53_;
		XnoiseTrackData** _tmp54_;
		gint _tmp54__length1;
		XnoiseTrackData* _tmp55_;
		XnoiseTrackData* _tmp56_;
		_tmp14_ = stmt;
		_tmp15_ = sqlite3_step (_tmp14_);
		if (!(_tmp15_ == SQLITE_ROW)) {
			break;
		}
		_tmp16_ = xnoise_track_data_new ();
		td = _tmp16_;
		_tmp17_ = td;
		_tmp18_ = stmt;
		_tmp19_ = sqlite3_column_text (_tmp18_, 4);
		_tmp20_ = g_strdup (_tmp19_);
		_g_free0 (_tmp17_->artist);
		_tmp17_->artist = _tmp20_;
		_tmp21_ = td;
		_tmp22_ = stmt;
		_tmp23_ = sqlite3_column_text (_tmp22_, 5);
		_tmp24_ = g_strdup (_tmp23_);
		_g_free0 (_tmp21_->album);
		_tmp21_->album = _tmp24_;
		_tmp25_ = td;
		_tmp26_ = stmt;
		_tmp27_ = sqlite3_column_text (_tmp26_, 0);
		_tmp28_ = g_strdup (_tmp27_);
		_g_free0 (_tmp25_->title);
		_tmp25_->title = _tmp28_;
		_tmp29_ = td;
		_tmp30_ = stmt;
		_tmp31_ = sqlite3_column_int (_tmp30_, 2);
		_tmp29_->tracknumber = (guint) _tmp31_;
		_tmp32_ = td;
		_tmp33_ = stmt;
		_tmp34_ = sqlite3_column_int (_tmp33_, 6);
		_tmp32_->length = (gint32) _tmp34_;
		_tmp35_ = td;
		_tmp36_ = stmt;
		_tmp37_ = sqlite3_column_text (_tmp36_, 7);
		_tmp38_ = g_strdup (_tmp37_);
		_g_free0 (_tmp35_->genre);
		_tmp35_->genre = _tmp38_;
		_tmp39_ = td;
		_tmp40_ = stmt;
		_tmp41_ = sqlite3_column_int (_tmp40_, 8);
		_tmp39_->year = (guint) _tmp41_;
		_tmp42_ = td;
		_tmp43_ = stmt;
		_tmp44_ = sqlite3_column_text (_tmp43_, 0);
		_tmp45_ = g_strdup (_tmp44_);
		_g_free0 (_tmp42_->name);
		_tmp42_->name = _tmp45_;
		_tmp46_ = td;
		_tmp47_ = stmt;
		_tmp48_ = sqlite3_column_text (_tmp47_, 3);
		_tmp49_ = stmt;
		_tmp50_ = sqlite3_column_int (_tmp49_, 1);
		xnoise_item_init (&_tmp51_, XNOISE_ITEM_TYPE_LOCAL_VIDEO_TRACK, _tmp48_, (gint32) _tmp50_);
		_tmp52_ = _tmp51_;
		_tmp53_ = _xnoise_item_dup0 (&_tmp52_);
		_xnoise_item_free0 (_tmp46_->item);
		_tmp46_->item = _tmp53_;
		xnoise_item_destroy (&_tmp52_);
		_tmp54_ = val;
		_tmp54__length1 = val_length1;
		_tmp55_ = td;
		_tmp56_ = _xnoise_track_data_ref0 (_tmp55_);
		_vala_array_add12 (&val, &val_length1, &_val_size_, _tmp56_);
		_xnoise_track_data_unref0 (td);
	}
	_tmp57_ = val;
	_tmp57__length1 = val_length1;
	val = NULL;
	_tmp58_ = _tmp57_;
	_tmp58__length1 = _tmp57__length1;
	if (result_length1) {
		*result_length1 = _tmp58__length1;
	}
	result = _tmp58_;
	_sqlite3_finalize0 (stmt);
	val = (_vala_array_free (val, val_length1, (GDestroyNotify) xnoise_track_data_unref), NULL);
	return result;
}


static void _vala_array_add13 (XnoiseTrackData*** array, int* length, int* size, XnoiseTrackData* value) {
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (XnoiseTrackData*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}


XnoiseTrackData** xnoise_database_reader_get_trackdata_for_streams (XnoiseDatabaseReader* self, const gchar* searchtext, int* result_length1) {
	XnoiseTrackData** result = NULL;
	XnoiseTrackData** _tmp0_ = NULL;
	XnoiseTrackData** val;
	gint val_length1;
	gint _val_size_;
	sqlite3_stmt* stmt = NULL;
	const gchar* _tmp1_;
	gchar* _tmp2_ = NULL;
	gchar* st;
	sqlite3* _tmp3_;
	sqlite3_stmt* _tmp4_ = NULL;
	gboolean _tmp5_ = FALSE;
	sqlite3_stmt* _tmp6_;
	const gchar* _tmp7_;
	gchar* _tmp8_;
	GDestroyNotify _tmp9_;
	gint _tmp10_ = 0;
	gboolean _tmp16_;
	XnoiseTrackData** _tmp46_;
	gint _tmp46__length1;
	XnoiseTrackData** _tmp47_;
	gint _tmp47__length1;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (searchtext != NULL, NULL);
	_tmp0_ = g_new0 (XnoiseTrackData*, 0 + 1);
	val = _tmp0_;
	val_length1 = 0;
	_val_size_ = val_length1;
	_tmp1_ = searchtext;
	_tmp2_ = g_strdup_printf ("%%%s%%", _tmp1_);
	st = _tmp2_;
	_tmp3_ = self->priv->db;
	sqlite3_prepare_v2 (_tmp3_, XNOISE_DATABASE_READER_STMT_GET_TRACKDATA_FOR_STREAMS, -1, &_tmp4_, NULL);
	_sqlite3_finalize0 (stmt);
	stmt = _tmp4_;
	_tmp6_ = stmt;
	_tmp7_ = st;
	_tmp8_ = g_strdup (_tmp7_);
	_tmp9_ = g_free;
	_tmp10_ = sqlite3_bind_text (_tmp6_, 1, _tmp8_, -1, _tmp9_);
	if (_tmp10_ != SQLITE_OK) {
		_tmp5_ = TRUE;
	} else {
		sqlite3_stmt* _tmp11_;
		const gchar* _tmp12_;
		gchar* _tmp13_;
		GDestroyNotify _tmp14_;
		gint _tmp15_ = 0;
		_tmp11_ = stmt;
		_tmp12_ = st;
		_tmp13_ = g_strdup (_tmp12_);
		_tmp14_ = g_free;
		_tmp15_ = sqlite3_bind_text (_tmp11_, 2, _tmp13_, -1, _tmp14_);
		_tmp5_ = _tmp15_ != SQLITE_OK;
	}
	_tmp16_ = _tmp5_;
	if (_tmp16_) {
		XnoiseTrackData** _tmp17_;
		gint _tmp17__length1;
		XnoiseTrackData** _tmp18_;
		gint _tmp18__length1;
		xnoise_database_reader_db_error (self);
		_tmp17_ = val;
		_tmp17__length1 = val_length1;
		val = NULL;
		_tmp18_ = _tmp17_;
		_tmp18__length1 = _tmp17__length1;
		if (result_length1) {
			*result_length1 = _tmp18__length1;
		}
		result = _tmp18_;
		_g_free0 (st);
		_sqlite3_finalize0 (stmt);
		val = (_vala_array_free (val, val_length1, (GDestroyNotify) xnoise_track_data_unref), NULL);
		return result;
	}
	while (TRUE) {
		sqlite3_stmt* _tmp19_;
		gint _tmp20_ = 0;
		XnoiseTrackData* _tmp21_;
		XnoiseTrackData* td;
		XnoiseTrackData* _tmp22_;
		sqlite3_stmt* _tmp23_;
		const gchar* _tmp24_ = NULL;
		gchar* _tmp25_;
		XnoiseTrackData* _tmp26_;
		sqlite3_stmt* _tmp27_;
		const gchar* _tmp28_ = NULL;
		gchar* _tmp29_;
		XnoiseTrackData* _tmp30_;
		sqlite3_stmt* _tmp31_;
		const gchar* _tmp32_ = NULL;
		sqlite3_stmt* _tmp33_;
		gint _tmp34_ = 0;
		XnoiseItem _tmp35_ = {0};
		XnoiseItem _tmp36_;
		XnoiseItem* _tmp37_;
		XnoiseTrackData* _tmp38_;
		XnoiseItem* _tmp39_;
		sqlite3_stmt* _tmp40_;
		const gchar* _tmp41_ = NULL;
		gchar* _tmp42_;
		XnoiseTrackData** _tmp43_;
		gint _tmp43__length1;
		XnoiseTrackData* _tmp44_;
		XnoiseTrackData* _tmp45_;
		_tmp19_ = stmt;
		_tmp20_ = sqlite3_step (_tmp19_);
		if (!(_tmp20_ == SQLITE_ROW)) {
			break;
		}
		_tmp21_ = xnoise_track_data_new ();
		td = _tmp21_;
		_tmp22_ = td;
		_tmp23_ = stmt;
		_tmp24_ = sqlite3_column_text (_tmp23_, 2);
		_tmp25_ = g_strdup (_tmp24_);
		_g_free0 (_tmp22_->title);
		_tmp22_->title = _tmp25_;
		_tmp26_ = td;
		_tmp27_ = stmt;
		_tmp28_ = sqlite3_column_text (_tmp27_, 2);
		_tmp29_ = g_strdup (_tmp28_);
		_g_free0 (_tmp26_->name);
		_tmp26_->name = _tmp29_;
		_tmp30_ = td;
		_tmp31_ = stmt;
		_tmp32_ = sqlite3_column_text (_tmp31_, 1);
		_tmp33_ = stmt;
		_tmp34_ = sqlite3_column_int (_tmp33_, 0);
		xnoise_item_init (&_tmp35_, XNOISE_ITEM_TYPE_STREAM, _tmp32_, (gint32) _tmp34_);
		_tmp36_ = _tmp35_;
		_tmp37_ = _xnoise_item_dup0 (&_tmp36_);
		_xnoise_item_free0 (_tmp30_->item);
		_tmp30_->item = _tmp37_;
		xnoise_item_destroy (&_tmp36_);
		_tmp38_ = td;
		_tmp39_ = _tmp38_->item;
		_tmp40_ = stmt;
		_tmp41_ = sqlite3_column_text (_tmp40_, 2);
		_tmp42_ = g_strdup (_tmp41_);
		_g_free0 ((*_tmp39_).text);
		(*_tmp39_).text = _tmp42_;
		_tmp43_ = val;
		_tmp43__length1 = val_length1;
		_tmp44_ = td;
		_tmp45_ = _xnoise_track_data_ref0 (_tmp44_);
		_vala_array_add13 (&val, &val_length1, &_val_size_, _tmp45_);
		_xnoise_track_data_unref0 (td);
	}
	_tmp46_ = val;
	_tmp46__length1 = val_length1;
	val = NULL;
	_tmp47_ = _tmp46_;
	_tmp47__length1 = _tmp46__length1;
	if (result_length1) {
		*result_length1 = _tmp47__length1;
	}
	result = _tmp47_;
	_g_free0 (st);
	_sqlite3_finalize0 (stmt);
	val = (_vala_array_free (val, val_length1, (GDestroyNotify) xnoise_track_data_unref), NULL);
	return result;
}


static void _vala_array_add14 (XnoiseItem** array, int* length, int* size, const XnoiseItem* value) {
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (XnoiseItem, *array, *size);
	}
	(*array)[(*length)++] = *value;
}


static void _vala_array_add15 (XnoiseItem** array, int* length, int* size, const XnoiseItem* value) {
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (XnoiseItem, *array, *size);
	}
	(*array)[(*length)++] = *value;
}


XnoiseItem* xnoise_database_reader_get_artists_with_search (XnoiseDatabaseReader* self, const gchar* searchtext, int* result_length1) {
	XnoiseItem* result = NULL;
	XnoiseItem* _tmp0_ = NULL;
	XnoiseItem* val;
	gint val_length1;
	gint _val_size_;
	const gchar* _tmp1_;
	XnoiseItem* _tmp55_;
	gint _tmp55__length1;
	XnoiseItem* _tmp56_;
	gint _tmp56__length1;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (searchtext != NULL, NULL);
	_tmp0_ = g_new0 (XnoiseItem, 0);
	val = _tmp0_;
	val_length1 = 0;
	_val_size_ = val_length1;
	_tmp1_ = searchtext;
	if (g_strcmp0 (_tmp1_, XNOISE_SERVICES_EMPTYSTRING) != 0) {
		const gchar* _tmp2_;
		gchar* _tmp3_ = NULL;
		gchar* st;
		sqlite3_stmt* _tmp4_;
		gboolean _tmp5_ = FALSE;
		gboolean _tmp6_ = FALSE;
		gboolean _tmp7_ = FALSE;
		sqlite3_stmt* _tmp8_;
		const gchar* _tmp9_;
		gchar* _tmp10_;
		GDestroyNotify _tmp11_;
		gint _tmp12_ = 0;
		gboolean _tmp18_;
		gboolean _tmp24_;
		gboolean _tmp27_;
		_tmp2_ = searchtext;
		_tmp3_ = g_strdup_printf ("%%%s%%", _tmp2_);
		st = _tmp3_;
		_tmp4_ = self->priv->get_artists_with_search_stmt;
		sqlite3_reset (_tmp4_);
		_tmp8_ = self->priv->get_artists_with_search_stmt;
		_tmp9_ = st;
		_tmp10_ = g_strdup (_tmp9_);
		_tmp11_ = g_free;
		_tmp12_ = sqlite3_bind_text (_tmp8_, 1, _tmp10_, -1, _tmp11_);
		if (_tmp12_ != SQLITE_OK) {
			_tmp7_ = TRUE;
		} else {
			sqlite3_stmt* _tmp13_;
			const gchar* _tmp14_;
			gchar* _tmp15_;
			GDestroyNotify _tmp16_;
			gint _tmp17_ = 0;
			_tmp13_ = self->priv->get_artists_with_search_stmt;
			_tmp14_ = st;
			_tmp15_ = g_strdup (_tmp14_);
			_tmp16_ = g_free;
			_tmp17_ = sqlite3_bind_text (_tmp13_, 2, _tmp15_, -1, _tmp16_);
			_tmp7_ = _tmp17_ != SQLITE_OK;
		}
		_tmp18_ = _tmp7_;
		if (_tmp18_) {
			_tmp6_ = TRUE;
		} else {
			sqlite3_stmt* _tmp19_;
			const gchar* _tmp20_;
			gchar* _tmp21_;
			GDestroyNotify _tmp22_;
			gint _tmp23_ = 0;
			_tmp19_ = self->priv->get_artists_with_search_stmt;
			_tmp20_ = st;
			_tmp21_ = g_strdup (_tmp20_);
			_tmp22_ = g_free;
			_tmp23_ = sqlite3_bind_text (_tmp19_, 3, _tmp21_, -1, _tmp22_);
			_tmp6_ = _tmp23_ != SQLITE_OK;
		}
		_tmp24_ = _tmp6_;
		if (_tmp24_) {
			_tmp5_ = TRUE;
		} else {
			sqlite3_stmt* _tmp25_;
			gint _tmp26_ = 0;
			_tmp25_ = self->priv->get_artists_with_search_stmt;
			_tmp26_ = sqlite3_bind_int (_tmp25_, 4, (gint) XNOISE_ITEM_TYPE_LOCAL_AUDIO_TRACK);
			_tmp5_ = _tmp26_ != SQLITE_OK;
		}
		_tmp27_ = _tmp5_;
		if (_tmp27_) {
			XnoiseItem* _tmp28_;
			gint _tmp28__length1;
			XnoiseItem* _tmp29_;
			gint _tmp29__length1;
			xnoise_database_reader_db_error (self);
			_tmp28_ = val;
			_tmp28__length1 = val_length1;
			val = NULL;
			_tmp29_ = _tmp28_;
			_tmp29__length1 = _tmp28__length1;
			if (result_length1) {
				*result_length1 = _tmp29__length1;
			}
			result = _tmp29_;
			_g_free0 (st);
			val = (_vala_XnoiseItem_array_free (val, val_length1), NULL);
			return result;
		}
		while (TRUE) {
			sqlite3_stmt* _tmp30_;
			gint _tmp31_ = 0;
			sqlite3_stmt* _tmp32_;
			gint _tmp33_ = 0;
			XnoiseItem i = {0};
			sqlite3_stmt* _tmp34_;
			const gchar* _tmp35_ = NULL;
			gchar* _tmp36_;
			XnoiseItem* _tmp37_;
			gint _tmp37__length1;
			XnoiseItem _tmp38_;
			XnoiseItem _tmp39_ = {0};
			_tmp30_ = self->priv->get_artists_with_search_stmt;
			_tmp31_ = sqlite3_step (_tmp30_);
			if (!(_tmp31_ == SQLITE_ROW)) {
				break;
			}
			_tmp32_ = self->priv->get_artists_with_search_stmt;
			_tmp33_ = sqlite3_column_int (_tmp32_, 0);
			xnoise_item_init (&i, XNOISE_ITEM_TYPE_COLLECTION_CONTAINER_ARTIST, NULL, (gint32) _tmp33_);
			_tmp34_ = self->priv->get_artists_with_search_stmt;
			_tmp35_ = sqlite3_column_text (_tmp34_, 1);
			_tmp36_ = g_strdup (_tmp35_);
			_g_free0 (i.text);
			i.text = _tmp36_;
			_tmp37_ = val;
			_tmp37__length1 = val_length1;
			_tmp38_ = i;
			xnoise_item_copy (&_tmp38_, &_tmp39_);
			_vala_array_add14 (&val, &val_length1, &_val_size_, &_tmp39_);
			xnoise_item_destroy (&i);
		}
		_g_free0 (st);
	} else {
		sqlite3_stmt* _tmp40_;
		sqlite3_stmt* _tmp41_;
		gint _tmp42_ = 0;
		_tmp40_ = self->priv->get_artists_with_search2_stmt;
		sqlite3_reset (_tmp40_);
		_tmp41_ = self->priv->get_artists_with_search2_stmt;
		_tmp42_ = sqlite3_bind_int (_tmp41_, 1, (gint) XNOISE_ITEM_TYPE_LOCAL_AUDIO_TRACK);
		if (_tmp42_ != SQLITE_OK) {
			XnoiseItem* _tmp43_;
			gint _tmp43__length1;
			XnoiseItem* _tmp44_;
			gint _tmp44__length1;
			xnoise_database_reader_db_error (self);
			_tmp43_ = val;
			_tmp43__length1 = val_length1;
			val = NULL;
			_tmp44_ = _tmp43_;
			_tmp44__length1 = _tmp43__length1;
			if (result_length1) {
				*result_length1 = _tmp44__length1;
			}
			result = _tmp44_;
			val = (_vala_XnoiseItem_array_free (val, val_length1), NULL);
			return result;
		}
		while (TRUE) {
			sqlite3_stmt* _tmp45_;
			gint _tmp46_ = 0;
			sqlite3_stmt* _tmp47_;
			gint _tmp48_ = 0;
			XnoiseItem i = {0};
			sqlite3_stmt* _tmp49_;
			const gchar* _tmp50_ = NULL;
			gchar* _tmp51_;
			XnoiseItem* _tmp52_;
			gint _tmp52__length1;
			XnoiseItem _tmp53_;
			XnoiseItem _tmp54_ = {0};
			_tmp45_ = self->priv->get_artists_with_search2_stmt;
			_tmp46_ = sqlite3_step (_tmp45_);
			if (!(_tmp46_ == SQLITE_ROW)) {
				break;
			}
			_tmp47_ = self->priv->get_artists_with_search2_stmt;
			_tmp48_ = sqlite3_column_int (_tmp47_, 0);
			xnoise_item_init (&i, XNOISE_ITEM_TYPE_COLLECTION_CONTAINER_ARTIST, NULL, (gint32) _tmp48_);
			_tmp49_ = self->priv->get_artists_with_search2_stmt;
			_tmp50_ = sqlite3_column_text (_tmp49_, 1);
			_tmp51_ = g_strdup (_tmp50_);
			_g_free0 (i.text);
			i.text = _tmp51_;
			_tmp52_ = val;
			_tmp52__length1 = val_length1;
			_tmp53_ = i;
			xnoise_item_copy (&_tmp53_, &_tmp54_);
			_vala_array_add15 (&val, &val_length1, &_val_size_, &_tmp54_);
			xnoise_item_destroy (&i);
		}
	}
	_tmp55_ = val;
	_tmp55__length1 = val_length1;
	val = NULL;
	_tmp56_ = _tmp55_;
	_tmp56__length1 = _tmp55__length1;
	if (result_length1) {
		*result_length1 = _tmp56__length1;
	}
	result = _tmp56_;
	val = (_vala_XnoiseItem_array_free (val, val_length1), NULL);
	return result;
}


static void _vala_array_add16 (XnoiseTrackData*** array, int* length, int* size, XnoiseTrackData* value) {
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (XnoiseTrackData*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}


XnoiseTrackData** xnoise_database_reader_get_trackdata_by_albumid (XnoiseDatabaseReader* self, const gchar* searchtext, gint32 id, int* result_length1) {
	XnoiseTrackData** result = NULL;
	XnoiseTrackData** _tmp0_ = NULL;
	XnoiseTrackData** val;
	gint val_length1;
	gint _val_size_;
	sqlite3_stmt* stmt = NULL;
	const gchar* _tmp1_;
	XnoiseTrackData** _tmp82_;
	gint _tmp82__length1;
	XnoiseTrackData** _tmp83_;
	gint _tmp83__length1;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (searchtext != NULL, NULL);
	_tmp0_ = g_new0 (XnoiseTrackData*, 0 + 1);
	val = _tmp0_;
	val_length1 = 0;
	_val_size_ = val_length1;
	_tmp1_ = searchtext;
	if (g_strcmp0 (_tmp1_, XNOISE_SERVICES_EMPTYSTRING) != 0) {
		const gchar* _tmp2_;
		gchar* _tmp3_ = NULL;
		gchar* st;
		sqlite3* _tmp4_;
		sqlite3_stmt* _tmp5_ = NULL;
		gboolean _tmp6_ = FALSE;
		gboolean _tmp7_ = FALSE;
		gboolean _tmp8_ = FALSE;
		sqlite3_stmt* _tmp9_;
		gint32 _tmp10_;
		gint _tmp11_ = 0;
		gboolean _tmp17_;
		gboolean _tmp23_;
		gboolean _tmp29_;
		_tmp2_ = searchtext;
		_tmp3_ = g_strdup_printf ("%%%s%%", _tmp2_);
		st = _tmp3_;
		_tmp4_ = self->priv->db;
		sqlite3_prepare_v2 (_tmp4_, XNOISE_DATABASE_READER_STMT_GET_TRACKDATA_BY_ALBUMID_WITH_SEARCH, -1, &_tmp5_, NULL);
		_sqlite3_finalize0 (stmt);
		stmt = _tmp5_;
		_tmp9_ = stmt;
		_tmp10_ = id;
		_tmp11_ = sqlite3_bind_int (_tmp9_, 1, (gint) _tmp10_);
		if (_tmp11_ != SQLITE_OK) {
			_tmp8_ = TRUE;
		} else {
			sqlite3_stmt* _tmp12_;
			const gchar* _tmp13_;
			gchar* _tmp14_;
			GDestroyNotify _tmp15_;
			gint _tmp16_ = 0;
			_tmp12_ = stmt;
			_tmp13_ = st;
			_tmp14_ = g_strdup (_tmp13_);
			_tmp15_ = g_free;
			_tmp16_ = sqlite3_bind_text (_tmp12_, 2, _tmp14_, -1, _tmp15_);
			_tmp8_ = _tmp16_ != SQLITE_OK;
		}
		_tmp17_ = _tmp8_;
		if (_tmp17_) {
			_tmp7_ = TRUE;
		} else {
			sqlite3_stmt* _tmp18_;
			const gchar* _tmp19_;
			gchar* _tmp20_;
			GDestroyNotify _tmp21_;
			gint _tmp22_ = 0;
			_tmp18_ = stmt;
			_tmp19_ = st;
			_tmp20_ = g_strdup (_tmp19_);
			_tmp21_ = g_free;
			_tmp22_ = sqlite3_bind_text (_tmp18_, 3, _tmp20_, -1, _tmp21_);
			_tmp7_ = _tmp22_ != SQLITE_OK;
		}
		_tmp23_ = _tmp7_;
		if (_tmp23_) {
			_tmp6_ = TRUE;
		} else {
			sqlite3_stmt* _tmp24_;
			const gchar* _tmp25_;
			gchar* _tmp26_;
			GDestroyNotify _tmp27_;
			gint _tmp28_ = 0;
			_tmp24_ = stmt;
			_tmp25_ = st;
			_tmp26_ = g_strdup (_tmp25_);
			_tmp27_ = g_free;
			_tmp28_ = sqlite3_bind_text (_tmp24_, 4, _tmp26_, -1, _tmp27_);
			_tmp6_ = _tmp28_ != SQLITE_OK;
		}
		_tmp29_ = _tmp6_;
		if (_tmp29_) {
			XnoiseTrackData** _tmp30_;
			gint _tmp30__length1;
			XnoiseTrackData** _tmp31_;
			gint _tmp31__length1;
			xnoise_database_reader_db_error (self);
			_tmp30_ = val;
			_tmp30__length1 = val_length1;
			val = NULL;
			_tmp31_ = _tmp30_;
			_tmp31__length1 = _tmp30__length1;
			if (result_length1) {
				*result_length1 = _tmp31__length1;
			}
			result = _tmp31_;
			_g_free0 (st);
			_sqlite3_finalize0 (stmt);
			val = (_vala_array_free (val, val_length1, (GDestroyNotify) xnoise_track_data_unref), NULL);
			return result;
		}
		_g_free0 (st);
	} else {
		sqlite3* _tmp32_;
		sqlite3_stmt* _tmp33_ = NULL;
		sqlite3_stmt* _tmp34_;
		gint32 _tmp35_;
		gint _tmp36_ = 0;
		_tmp32_ = self->priv->db;
		sqlite3_prepare_v2 (_tmp32_, XNOISE_DATABASE_READER_STMT_GET_TRACKDATA_BY_ALBUMID, -1, &_tmp33_, NULL);
		_sqlite3_finalize0 (stmt);
		stmt = _tmp33_;
		_tmp34_ = stmt;
		_tmp35_ = id;
		_tmp36_ = sqlite3_bind_int (_tmp34_, 1, (gint) _tmp35_);
		if (_tmp36_ != SQLITE_OK) {
			XnoiseTrackData** _tmp37_;
			gint _tmp37__length1;
			xnoise_database_reader_db_error (self);
			_tmp37_ = NULL;
			_tmp37__length1 = 0;
			if (result_length1) {
				*result_length1 = _tmp37__length1;
			}
			result = _tmp37_;
			_sqlite3_finalize0 (stmt);
			val = (_vala_array_free (val, val_length1, (GDestroyNotify) xnoise_track_data_unref), NULL);
			return result;
		}
	}
	while (TRUE) {
		sqlite3_stmt* _tmp38_;
		gint _tmp39_ = 0;
		XnoiseTrackData* _tmp40_;
		XnoiseTrackData* td;
		sqlite3_stmt* _tmp41_;
		gint _tmp42_ = 0;
		sqlite3_stmt* _tmp43_;
		const gchar* _tmp44_ = NULL;
		sqlite3_stmt* _tmp45_;
		gint _tmp46_ = 0;
		XnoiseItem _tmp47_ = {0};
		XnoiseItem _tmp48_;
		XnoiseItem* _tmp49_;
		XnoiseItem* _tmp50_;
		XnoiseItem* i;
		XnoiseTrackData* _tmp51_;
		sqlite3_stmt* _tmp52_;
		const gchar* _tmp53_ = NULL;
		gchar* _tmp54_;
		XnoiseTrackData* _tmp55_;
		sqlite3_stmt* _tmp56_;
		const gchar* _tmp57_ = NULL;
		gchar* _tmp58_;
		XnoiseTrackData* _tmp59_;
		sqlite3_stmt* _tmp60_;
		const gchar* _tmp61_ = NULL;
		gchar* _tmp62_;
		XnoiseTrackData* _tmp63_;
		XnoiseItem* _tmp64_;
		XnoiseItem* _tmp65_;
		XnoiseTrackData* _tmp66_;
		sqlite3_stmt* _tmp67_;
		gint _tmp68_ = 0;
		XnoiseTrackData* _tmp69_;
		sqlite3_stmt* _tmp70_;
		gint _tmp71_ = 0;
		XnoiseTrackData* _tmp72_;
		sqlite3_stmt* _tmp73_;
		const gchar* _tmp74_ = NULL;
		gchar* _tmp75_;
		XnoiseTrackData* _tmp76_;
		sqlite3_stmt* _tmp77_;
		gint _tmp78_ = 0;
		XnoiseTrackData** _tmp79_;
		gint _tmp79__length1;
		XnoiseTrackData* _tmp80_;
		XnoiseTrackData* _tmp81_;
		_tmp38_ = stmt;
		_tmp39_ = sqlite3_step (_tmp38_);
		if (!(_tmp39_ == SQLITE_ROW)) {
			break;
		}
		_tmp40_ = xnoise_track_data_new ();
		td = _tmp40_;
		_tmp41_ = stmt;
		_tmp42_ = sqlite3_column_int (_tmp41_, 1);
		_tmp43_ = stmt;
		_tmp44_ = sqlite3_column_text (_tmp43_, 4);
		_tmp45_ = stmt;
		_tmp46_ = sqlite3_column_int (_tmp45_, 2);
		xnoise_item_init (&_tmp47_, (XnoiseItemType) _tmp42_, _tmp44_, (gint32) _tmp46_);
		_tmp48_ = _tmp47_;
		_tmp49_ = _xnoise_item_dup0 (&_tmp48_);
		_tmp50_ = _tmp49_;
		xnoise_item_destroy (&_tmp48_);
		i = _tmp50_;
		_tmp51_ = td;
		_tmp52_ = stmt;
		_tmp53_ = sqlite3_column_text (_tmp52_, 5);
		_tmp54_ = g_strdup (_tmp53_);
		_g_free0 (_tmp51_->artist);
		_tmp51_->artist = _tmp54_;
		_tmp55_ = td;
		_tmp56_ = stmt;
		_tmp57_ = sqlite3_column_text (_tmp56_, 6);
		_tmp58_ = g_strdup (_tmp57_);
		_g_free0 (_tmp55_->album);
		_tmp55_->album = _tmp58_;
		_tmp59_ = td;
		_tmp60_ = stmt;
		_tmp61_ = sqlite3_column_text (_tmp60_, 0);
		_tmp62_ = g_strdup (_tmp61_);
		_g_free0 (_tmp59_->title);
		_tmp59_->title = _tmp62_;
		_tmp63_ = td;
		_tmp64_ = i;
		_tmp65_ = _xnoise_item_dup0 (_tmp64_);
		_xnoise_item_free0 (_tmp63_->item);
		_tmp63_->item = _tmp65_;
		_tmp66_ = td;
		_tmp67_ = stmt;
		_tmp68_ = sqlite3_column_int (_tmp67_, 3);
		_tmp66_->tracknumber = (guint) _tmp68_;
		_tmp69_ = td;
		_tmp70_ = stmt;
		_tmp71_ = sqlite3_column_int (_tmp70_, 7);
		_tmp69_->length = (gint32) _tmp71_;
		_tmp72_ = td;
		_tmp73_ = stmt;
		_tmp74_ = sqlite3_column_text (_tmp73_, 8);
		_tmp75_ = g_strdup (_tmp74_);
		_g_free0 (_tmp72_->genre);
		_tmp72_->genre = _tmp75_;
		_tmp76_ = td;
		_tmp77_ = stmt;
		_tmp78_ = sqlite3_column_int (_tmp77_, 9);
		_tmp76_->year = (guint) _tmp78_;
		_tmp79_ = val;
		_tmp79__length1 = val_length1;
		_tmp80_ = td;
		_tmp81_ = _xnoise_track_data_ref0 (_tmp80_);
		_vala_array_add16 (&val, &val_length1, &_val_size_, _tmp81_);
		_xnoise_item_free0 (i);
		_xnoise_track_data_unref0 (td);
	}
	_tmp82_ = val;
	_tmp82__length1 = val_length1;
	val = NULL;
	_tmp83_ = _tmp82_;
	_tmp83__length1 = _tmp82__length1;
	if (result_length1) {
		*result_length1 = _tmp83__length1;
	}
	result = _tmp83_;
	_sqlite3_finalize0 (stmt);
	val = (_vala_array_free (val, val_length1, (GDestroyNotify) xnoise_track_data_unref), NULL);
	return result;
}


static void _vala_array_add17 (XnoiseTrackData*** array, int* length, int* size, XnoiseTrackData* value) {
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (XnoiseTrackData*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}


XnoiseTrackData** xnoise_database_reader_get_trackdata_by_artistid (XnoiseDatabaseReader* self, const gchar* searchtext, gint32 id, int* result_length1) {
	XnoiseTrackData** result = NULL;
	XnoiseTrackData** _tmp0_ = NULL;
	XnoiseTrackData** val;
	gint val_length1;
	gint _val_size_;
	sqlite3_stmt* stmt = NULL;
	const gchar* _tmp1_;
	XnoiseTrackData** _tmp82_;
	gint _tmp82__length1;
	XnoiseTrackData** _tmp83_;
	gint _tmp83__length1;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (searchtext != NULL, NULL);
	_tmp0_ = g_new0 (XnoiseTrackData*, 0 + 1);
	val = _tmp0_;
	val_length1 = 0;
	_val_size_ = val_length1;
	_tmp1_ = searchtext;
	if (g_strcmp0 (_tmp1_, XNOISE_SERVICES_EMPTYSTRING) != 0) {
		const gchar* _tmp2_;
		gchar* _tmp3_ = NULL;
		gchar* st;
		sqlite3* _tmp4_;
		sqlite3_stmt* _tmp5_ = NULL;
		gboolean _tmp6_ = FALSE;
		gboolean _tmp7_ = FALSE;
		gboolean _tmp8_ = FALSE;
		sqlite3_stmt* _tmp9_;
		gint32 _tmp10_;
		gint _tmp11_ = 0;
		gboolean _tmp17_;
		gboolean _tmp23_;
		gboolean _tmp29_;
		_tmp2_ = searchtext;
		_tmp3_ = g_strdup_printf ("%%%s%%", _tmp2_);
		st = _tmp3_;
		_tmp4_ = self->priv->db;
		sqlite3_prepare_v2 (_tmp4_, XNOISE_DATABASE_READER_STMT_GET_TRACKDATA_BY_ARTISTID_WITH_SEARCH, -1, &_tmp5_, NULL);
		_sqlite3_finalize0 (stmt);
		stmt = _tmp5_;
		_tmp9_ = stmt;
		_tmp10_ = id;
		_tmp11_ = sqlite3_bind_int (_tmp9_, 1, (gint) _tmp10_);
		if (_tmp11_ != SQLITE_OK) {
			_tmp8_ = TRUE;
		} else {
			sqlite3_stmt* _tmp12_;
			const gchar* _tmp13_;
			gchar* _tmp14_;
			GDestroyNotify _tmp15_;
			gint _tmp16_ = 0;
			_tmp12_ = stmt;
			_tmp13_ = st;
			_tmp14_ = g_strdup (_tmp13_);
			_tmp15_ = g_free;
			_tmp16_ = sqlite3_bind_text (_tmp12_, 2, _tmp14_, -1, _tmp15_);
			_tmp8_ = _tmp16_ != SQLITE_OK;
		}
		_tmp17_ = _tmp8_;
		if (_tmp17_) {
			_tmp7_ = TRUE;
		} else {
			sqlite3_stmt* _tmp18_;
			const gchar* _tmp19_;
			gchar* _tmp20_;
			GDestroyNotify _tmp21_;
			gint _tmp22_ = 0;
			_tmp18_ = stmt;
			_tmp19_ = st;
			_tmp20_ = g_strdup (_tmp19_);
			_tmp21_ = g_free;
			_tmp22_ = sqlite3_bind_text (_tmp18_, 3, _tmp20_, -1, _tmp21_);
			_tmp7_ = _tmp22_ != SQLITE_OK;
		}
		_tmp23_ = _tmp7_;
		if (_tmp23_) {
			_tmp6_ = TRUE;
		} else {
			sqlite3_stmt* _tmp24_;
			const gchar* _tmp25_;
			gchar* _tmp26_;
			GDestroyNotify _tmp27_;
			gint _tmp28_ = 0;
			_tmp24_ = stmt;
			_tmp25_ = st;
			_tmp26_ = g_strdup (_tmp25_);
			_tmp27_ = g_free;
			_tmp28_ = sqlite3_bind_text (_tmp24_, 4, _tmp26_, -1, _tmp27_);
			_tmp6_ = _tmp28_ != SQLITE_OK;
		}
		_tmp29_ = _tmp6_;
		if (_tmp29_) {
			XnoiseTrackData** _tmp30_;
			gint _tmp30__length1;
			XnoiseTrackData** _tmp31_;
			gint _tmp31__length1;
			xnoise_database_reader_db_error (self);
			_tmp30_ = val;
			_tmp30__length1 = val_length1;
			val = NULL;
			_tmp31_ = _tmp30_;
			_tmp31__length1 = _tmp30__length1;
			if (result_length1) {
				*result_length1 = _tmp31__length1;
			}
			result = _tmp31_;
			_g_free0 (st);
			_sqlite3_finalize0 (stmt);
			val = (_vala_array_free (val, val_length1, (GDestroyNotify) xnoise_track_data_unref), NULL);
			return result;
		}
		_g_free0 (st);
	} else {
		sqlite3* _tmp32_;
		sqlite3_stmt* _tmp33_ = NULL;
		sqlite3_stmt* _tmp34_;
		gint32 _tmp35_;
		gint _tmp36_ = 0;
		_tmp32_ = self->priv->db;
		sqlite3_prepare_v2 (_tmp32_, XNOISE_DATABASE_READER_STMT_GET_TRACKDATA_BY_ARTISTID, -1, &_tmp33_, NULL);
		_sqlite3_finalize0 (stmt);
		stmt = _tmp33_;
		_tmp34_ = stmt;
		_tmp35_ = id;
		_tmp36_ = sqlite3_bind_int (_tmp34_, 1, (gint) _tmp35_);
		if (_tmp36_ != SQLITE_OK) {
			XnoiseTrackData** _tmp37_;
			gint _tmp37__length1;
			xnoise_database_reader_db_error (self);
			_tmp37_ = NULL;
			_tmp37__length1 = 0;
			if (result_length1) {
				*result_length1 = _tmp37__length1;
			}
			result = _tmp37_;
			_sqlite3_finalize0 (stmt);
			val = (_vala_array_free (val, val_length1, (GDestroyNotify) xnoise_track_data_unref), NULL);
			return result;
		}
	}
	while (TRUE) {
		sqlite3_stmt* _tmp38_;
		gint _tmp39_ = 0;
		XnoiseTrackData* _tmp40_;
		XnoiseTrackData* td;
		sqlite3_stmt* _tmp41_;
		gint _tmp42_ = 0;
		sqlite3_stmt* _tmp43_;
		const gchar* _tmp44_ = NULL;
		sqlite3_stmt* _tmp45_;
		gint _tmp46_ = 0;
		XnoiseItem _tmp47_ = {0};
		XnoiseItem _tmp48_;
		XnoiseItem* _tmp49_;
		XnoiseItem* _tmp50_;
		XnoiseItem* i;
		XnoiseTrackData* _tmp51_;
		sqlite3_stmt* _tmp52_;
		const gchar* _tmp53_ = NULL;
		gchar* _tmp54_;
		XnoiseTrackData* _tmp55_;
		sqlite3_stmt* _tmp56_;
		const gchar* _tmp57_ = NULL;
		gchar* _tmp58_;
		XnoiseTrackData* _tmp59_;
		sqlite3_stmt* _tmp60_;
		const gchar* _tmp61_ = NULL;
		gchar* _tmp62_;
		XnoiseTrackData* _tmp63_;
		XnoiseItem* _tmp64_;
		XnoiseItem* _tmp65_;
		XnoiseTrackData* _tmp66_;
		sqlite3_stmt* _tmp67_;
		gint _tmp68_ = 0;
		XnoiseTrackData* _tmp69_;
		sqlite3_stmt* _tmp70_;
		gint _tmp71_ = 0;
		XnoiseTrackData* _tmp72_;
		sqlite3_stmt* _tmp73_;
		const gchar* _tmp74_ = NULL;
		gchar* _tmp75_;
		XnoiseTrackData* _tmp76_;
		sqlite3_stmt* _tmp77_;
		gint _tmp78_ = 0;
		XnoiseTrackData** _tmp79_;
		gint _tmp79__length1;
		XnoiseTrackData* _tmp80_;
		XnoiseTrackData* _tmp81_;
		_tmp38_ = stmt;
		_tmp39_ = sqlite3_step (_tmp38_);
		if (!(_tmp39_ == SQLITE_ROW)) {
			break;
		}
		_tmp40_ = xnoise_track_data_new ();
		td = _tmp40_;
		_tmp41_ = stmt;
		_tmp42_ = sqlite3_column_int (_tmp41_, 1);
		_tmp43_ = stmt;
		_tmp44_ = sqlite3_column_text (_tmp43_, 4);
		_tmp45_ = stmt;
		_tmp46_ = sqlite3_column_int (_tmp45_, 2);
		xnoise_item_init (&_tmp47_, (XnoiseItemType) _tmp42_, _tmp44_, (gint32) _tmp46_);
		_tmp48_ = _tmp47_;
		_tmp49_ = _xnoise_item_dup0 (&_tmp48_);
		_tmp50_ = _tmp49_;
		xnoise_item_destroy (&_tmp48_);
		i = _tmp50_;
		_tmp51_ = td;
		_tmp52_ = stmt;
		_tmp53_ = sqlite3_column_text (_tmp52_, 5);
		_tmp54_ = g_strdup (_tmp53_);
		_g_free0 (_tmp51_->artist);
		_tmp51_->artist = _tmp54_;
		_tmp55_ = td;
		_tmp56_ = stmt;
		_tmp57_ = sqlite3_column_text (_tmp56_, 6);
		_tmp58_ = g_strdup (_tmp57_);
		_g_free0 (_tmp55_->album);
		_tmp55_->album = _tmp58_;
		_tmp59_ = td;
		_tmp60_ = stmt;
		_tmp61_ = sqlite3_column_text (_tmp60_, 0);
		_tmp62_ = g_strdup (_tmp61_);
		_g_free0 (_tmp59_->title);
		_tmp59_->title = _tmp62_;
		_tmp63_ = td;
		_tmp64_ = i;
		_tmp65_ = _xnoise_item_dup0 (_tmp64_);
		_xnoise_item_free0 (_tmp63_->item);
		_tmp63_->item = _tmp65_;
		_tmp66_ = td;
		_tmp67_ = stmt;
		_tmp68_ = sqlite3_column_int (_tmp67_, 3);
		_tmp66_->tracknumber = (guint) _tmp68_;
		_tmp69_ = td;
		_tmp70_ = stmt;
		_tmp71_ = sqlite3_column_int (_tmp70_, 7);
		_tmp69_->length = (gint32) _tmp71_;
		_tmp72_ = td;
		_tmp73_ = stmt;
		_tmp74_ = sqlite3_column_text (_tmp73_, 8);
		_tmp75_ = g_strdup (_tmp74_);
		_g_free0 (_tmp72_->genre);
		_tmp72_->genre = _tmp75_;
		_tmp76_ = td;
		_tmp77_ = stmt;
		_tmp78_ = sqlite3_column_int (_tmp77_, 9);
		_tmp76_->year = (guint) _tmp78_;
		_tmp79_ = val;
		_tmp79__length1 = val_length1;
		_tmp80_ = td;
		_tmp81_ = _xnoise_track_data_ref0 (_tmp80_);
		_vala_array_add17 (&val, &val_length1, &_val_size_, _tmp81_);
		_xnoise_item_free0 (i);
		_xnoise_track_data_unref0 (td);
	}
	_tmp82_ = val;
	_tmp82__length1 = val_length1;
	val = NULL;
	_tmp83_ = _tmp82_;
	_tmp83__length1 = _tmp82__length1;
	if (result_length1) {
		*result_length1 = _tmp83__length1;
	}
	result = _tmp83_;
	_sqlite3_finalize0 (stmt);
	val = (_vala_array_free (val, val_length1, (GDestroyNotify) xnoise_track_data_unref), NULL);
	return result;
}


XnoiseItem* xnoise_database_reader_get_videoitem_by_id (XnoiseDatabaseReader* self, gint32 id) {
	XnoiseItem* result = NULL;
	sqlite3_stmt* stmt = NULL;
	XnoiseItem _tmp0_ = {0};
	XnoiseItem _tmp1_;
	XnoiseItem* _tmp2_;
	XnoiseItem* _tmp3_;
	XnoiseItem* i;
	sqlite3* _tmp4_;
	sqlite3_stmt* _tmp5_ = NULL;
	sqlite3_stmt* _tmp6_;
	gint32 _tmp7_;
	gint _tmp8_ = 0;
	sqlite3_stmt* _tmp10_;
	gint _tmp11_ = 0;
	XnoiseItem* _tmp25_;
	g_return_val_if_fail (self != NULL, NULL);
	xnoise_item_init (&_tmp0_, XNOISE_ITEM_TYPE_UNKNOWN, NULL, (gint32) (-1));
	_tmp1_ = _tmp0_;
	_tmp2_ = _xnoise_item_dup0 (&_tmp1_);
	_tmp3_ = _tmp2_;
	xnoise_item_destroy (&_tmp1_);
	i = _tmp3_;
	_tmp4_ = self->priv->db;
	sqlite3_prepare_v2 (_tmp4_, XNOISE_DATABASE_READER_STMT_GET_VIDEOITEM_BY_ID, -1, &_tmp5_, NULL);
	_sqlite3_finalize0 (stmt);
	stmt = _tmp5_;
	_tmp6_ = stmt;
	_tmp7_ = id;
	_tmp8_ = sqlite3_bind_int (_tmp6_, 1, (gint) _tmp7_);
	if (_tmp8_ != SQLITE_OK) {
		XnoiseItem* _tmp9_;
		xnoise_database_reader_db_error (self);
		_tmp9_ = i;
		i = NULL;
		result = _tmp9_;
		_xnoise_item_free0 (i);
		_sqlite3_finalize0 (stmt);
		return result;
	}
	_tmp10_ = stmt;
	_tmp11_ = sqlite3_step (_tmp10_);
	if (_tmp11_ == SQLITE_ROW) {
		sqlite3_stmt* _tmp12_;
		gint _tmp13_ = 0;
		sqlite3_stmt* _tmp14_;
		const gchar* _tmp15_ = NULL;
		sqlite3_stmt* _tmp16_;
		gint _tmp17_ = 0;
		XnoiseItem _tmp18_ = {0};
		XnoiseItem _tmp19_;
		XnoiseItem* _tmp20_;
		XnoiseItem* _tmp21_;
		sqlite3_stmt* _tmp22_;
		const gchar* _tmp23_ = NULL;
		gchar* _tmp24_;
		_tmp12_ = stmt;
		_tmp13_ = sqlite3_column_int (_tmp12_, 3);
		_tmp14_ = stmt;
		_tmp15_ = sqlite3_column_text (_tmp14_, 2);
		_tmp16_ = stmt;
		_tmp17_ = sqlite3_column_int (_tmp16_, 0);
		xnoise_item_init (&_tmp18_, (XnoiseItemType) _tmp13_, _tmp15_, (gint32) _tmp17_);
		_tmp19_ = _tmp18_;
		_tmp20_ = _xnoise_item_dup0 (&_tmp19_);
		_xnoise_item_free0 (i);
		i = _tmp20_;
		xnoise_item_destroy (&_tmp19_);
		_tmp21_ = i;
		_tmp22_ = stmt;
		_tmp23_ = sqlite3_column_text (_tmp22_, 1);
		_tmp24_ = g_strdup (_tmp23_);
		_g_free0 ((*_tmp21_).text);
		(*_tmp21_).text = _tmp24_;
	}
	_tmp25_ = i;
	i = NULL;
	result = _tmp25_;
	_xnoise_item_free0 (i);
	_sqlite3_finalize0 (stmt);
	return result;
}


XnoiseItem* xnoise_database_reader_get_artistitem_by_artistid (XnoiseDatabaseReader* self, const gchar* searchtext, gint32 id) {
	XnoiseItem* result = NULL;
	sqlite3_stmt* stmt = NULL;
	XnoiseItem _tmp0_ = {0};
	XnoiseItem _tmp1_;
	XnoiseItem* _tmp2_;
	XnoiseItem* _tmp3_;
	XnoiseItem* i;
	const gchar* _tmp4_;
	sqlite3_stmt* _tmp40_;
	gint _tmp41_ = 0;
	XnoiseItem* _tmp50_;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (searchtext != NULL, NULL);
	xnoise_item_init (&_tmp0_, XNOISE_ITEM_TYPE_UNKNOWN, NULL, (gint32) (-1));
	_tmp1_ = _tmp0_;
	_tmp2_ = _xnoise_item_dup0 (&_tmp1_);
	_tmp3_ = _tmp2_;
	xnoise_item_destroy (&_tmp1_);
	i = _tmp3_;
	_tmp4_ = searchtext;
	if (g_strcmp0 (_tmp4_, XNOISE_SERVICES_EMPTYSTRING) != 0) {
		const gchar* _tmp5_;
		gchar* _tmp6_ = NULL;
		gchar* st;
		sqlite3* _tmp7_;
		sqlite3_stmt* _tmp8_ = NULL;
		gboolean _tmp9_ = FALSE;
		gboolean _tmp10_ = FALSE;
		gboolean _tmp11_ = FALSE;
		sqlite3_stmt* _tmp12_;
		gint32 _tmp13_;
		gint _tmp14_ = 0;
		gboolean _tmp20_;
		gboolean _tmp26_;
		gboolean _tmp32_;
		_tmp5_ = searchtext;
		_tmp6_ = g_strdup_printf ("%%%s%%", _tmp5_);
		st = _tmp6_;
		_tmp7_ = self->priv->db;
		sqlite3_prepare_v2 (_tmp7_, XNOISE_DATABASE_READER_STMT_GET_ARTISTITEM_BY_ARTISTID_WITH_SEARCH, -1, &_tmp8_, NULL);
		_sqlite3_finalize0 (stmt);
		stmt = _tmp8_;
		_tmp12_ = stmt;
		_tmp13_ = id;
		_tmp14_ = sqlite3_bind_int (_tmp12_, 1, (gint) _tmp13_);
		if (_tmp14_ != SQLITE_OK) {
			_tmp11_ = TRUE;
		} else {
			sqlite3_stmt* _tmp15_;
			const gchar* _tmp16_;
			gchar* _tmp17_;
			GDestroyNotify _tmp18_;
			gint _tmp19_ = 0;
			_tmp15_ = stmt;
			_tmp16_ = st;
			_tmp17_ = g_strdup (_tmp16_);
			_tmp18_ = g_free;
			_tmp19_ = sqlite3_bind_text (_tmp15_, 2, _tmp17_, -1, _tmp18_);
			_tmp11_ = _tmp19_ != SQLITE_OK;
		}
		_tmp20_ = _tmp11_;
		if (_tmp20_) {
			_tmp10_ = TRUE;
		} else {
			sqlite3_stmt* _tmp21_;
			const gchar* _tmp22_;
			gchar* _tmp23_;
			GDestroyNotify _tmp24_;
			gint _tmp25_ = 0;
			_tmp21_ = stmt;
			_tmp22_ = st;
			_tmp23_ = g_strdup (_tmp22_);
			_tmp24_ = g_free;
			_tmp25_ = sqlite3_bind_text (_tmp21_, 3, _tmp23_, -1, _tmp24_);
			_tmp10_ = _tmp25_ != SQLITE_OK;
		}
		_tmp26_ = _tmp10_;
		if (_tmp26_) {
			_tmp9_ = TRUE;
		} else {
			sqlite3_stmt* _tmp27_;
			const gchar* _tmp28_;
			gchar* _tmp29_;
			GDestroyNotify _tmp30_;
			gint _tmp31_ = 0;
			_tmp27_ = stmt;
			_tmp28_ = st;
			_tmp29_ = g_strdup (_tmp28_);
			_tmp30_ = g_free;
			_tmp31_ = sqlite3_bind_text (_tmp27_, 4, _tmp29_, -1, _tmp30_);
			_tmp9_ = _tmp31_ != SQLITE_OK;
		}
		_tmp32_ = _tmp9_;
		if (_tmp32_) {
			XnoiseItem* _tmp33_;
			xnoise_database_reader_db_error (self);
			_tmp33_ = i;
			i = NULL;
			result = _tmp33_;
			_g_free0 (st);
			_xnoise_item_free0 (i);
			_sqlite3_finalize0 (stmt);
			return result;
		}
		_g_free0 (st);
	} else {
		sqlite3* _tmp34_;
		sqlite3_stmt* _tmp35_ = NULL;
		sqlite3_stmt* _tmp36_;
		gint32 _tmp37_;
		gint _tmp38_ = 0;
		_tmp34_ = self->priv->db;
		sqlite3_prepare_v2 (_tmp34_, XNOISE_DATABASE_READER_STMT_GET_ARTISTITEM_BY_ARTISTID, -1, &_tmp35_, NULL);
		_sqlite3_finalize0 (stmt);
		stmt = _tmp35_;
		_tmp36_ = stmt;
		_tmp37_ = id;
		_tmp38_ = sqlite3_bind_int (_tmp36_, 1, (gint) _tmp37_);
		if (_tmp38_ != SQLITE_OK) {
			XnoiseItem* _tmp39_;
			xnoise_database_reader_db_error (self);
			_tmp39_ = i;
			i = NULL;
			result = _tmp39_;
			_xnoise_item_free0 (i);
			_sqlite3_finalize0 (stmt);
			return result;
		}
	}
	_tmp40_ = stmt;
	_tmp41_ = sqlite3_step (_tmp40_);
	if (_tmp41_ == SQLITE_ROW) {
		gint32 _tmp42_;
		XnoiseItem _tmp43_ = {0};
		XnoiseItem _tmp44_;
		XnoiseItem* _tmp45_;
		XnoiseItem* _tmp46_;
		sqlite3_stmt* _tmp47_;
		const gchar* _tmp48_ = NULL;
		gchar* _tmp49_;
		_tmp42_ = id;
		xnoise_item_init (&_tmp43_, XNOISE_ITEM_TYPE_COLLECTION_CONTAINER_ARTIST, NULL, _tmp42_);
		_tmp44_ = _tmp43_;
		_tmp45_ = _xnoise_item_dup0 (&_tmp44_);
		_xnoise_item_free0 (i);
		i = _tmp45_;
		xnoise_item_destroy (&_tmp44_);
		_tmp46_ = i;
		_tmp47_ = stmt;
		_tmp48_ = sqlite3_column_text (_tmp47_, 0);
		_tmp49_ = g_strdup (_tmp48_);
		_g_free0 ((*_tmp46_).text);
		(*_tmp46_).text = _tmp49_;
	}
	_tmp50_ = i;
	i = NULL;
	result = _tmp50_;
	_xnoise_item_free0 (i);
	_sqlite3_finalize0 (stmt);
	return result;
}


XnoiseTrackData* xnoise_database_reader_get_trackdata_by_titleid (XnoiseDatabaseReader* self, const gchar* searchtext, gint32 id) {
	XnoiseTrackData* result = NULL;
	sqlite3_stmt* stmt = NULL;
	sqlite3* _tmp0_;
	sqlite3_stmt* _tmp1_ = NULL;
	sqlite3_stmt* _tmp2_;
	gint32 _tmp3_;
	gint _tmp4_ = 0;
	XnoiseTrackData* td;
	sqlite3_stmt* _tmp5_;
	gint _tmp6_ = 0;
	XnoiseTrackData* _tmp46_;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (searchtext != NULL, NULL);
	_tmp0_ = self->priv->db;
	sqlite3_prepare_v2 (_tmp0_, XNOISE_DATABASE_READER_STMT_GET_TRACKDATA_BY_TITLEID, -1, &_tmp1_, NULL);
	_sqlite3_finalize0 (stmt);
	stmt = _tmp1_;
	_tmp2_ = stmt;
	_tmp3_ = id;
	_tmp4_ = sqlite3_bind_int (_tmp2_, 1, (gint) _tmp3_);
	if (_tmp4_ != SQLITE_OK) {
		xnoise_database_reader_db_error (self);
		result = NULL;
		_sqlite3_finalize0 (stmt);
		return result;
	}
	td = NULL;
	_tmp5_ = stmt;
	_tmp6_ = sqlite3_step (_tmp5_);
	if (_tmp6_ == SQLITE_ROW) {
		XnoiseTrackData* _tmp7_;
		sqlite3_stmt* _tmp8_;
		gint _tmp9_ = 0;
		sqlite3_stmt* _tmp10_;
		const gchar* _tmp11_ = NULL;
		sqlite3_stmt* _tmp12_;
		gint _tmp13_ = 0;
		XnoiseItem _tmp14_ = {0};
		XnoiseItem _tmp15_;
		XnoiseItem* _tmp16_;
		XnoiseItem* _tmp17_;
		XnoiseItem* i;
		XnoiseTrackData* _tmp18_;
		sqlite3_stmt* _tmp19_;
		const gchar* _tmp20_ = NULL;
		gchar* _tmp21_;
		XnoiseTrackData* _tmp22_;
		sqlite3_stmt* _tmp23_;
		const gchar* _tmp24_ = NULL;
		gchar* _tmp25_;
		XnoiseTrackData* _tmp26_;
		sqlite3_stmt* _tmp27_;
		const gchar* _tmp28_ = NULL;
		gchar* _tmp29_;
		XnoiseTrackData* _tmp30_;
		XnoiseItem* _tmp31_;
		XnoiseItem* _tmp32_;
		XnoiseTrackData* _tmp33_;
		sqlite3_stmt* _tmp34_;
		gint _tmp35_ = 0;
		XnoiseTrackData* _tmp36_;
		sqlite3_stmt* _tmp37_;
		gint _tmp38_ = 0;
		XnoiseTrackData* _tmp39_;
		sqlite3_stmt* _tmp40_;
		const gchar* _tmp41_ = NULL;
		gchar* _tmp42_;
		XnoiseTrackData* _tmp43_;
		sqlite3_stmt* _tmp44_;
		gint _tmp45_ = 0;
		_tmp7_ = xnoise_track_data_new ();
		_xnoise_track_data_unref0 (td);
		td = _tmp7_;
		_tmp8_ = stmt;
		_tmp9_ = sqlite3_column_int (_tmp8_, 1);
		_tmp10_ = stmt;
		_tmp11_ = sqlite3_column_text (_tmp10_, 4);
		_tmp12_ = stmt;
		_tmp13_ = sqlite3_column_int (_tmp12_, 2);
		xnoise_item_init (&_tmp14_, (XnoiseItemType) _tmp9_, _tmp11_, (gint32) _tmp13_);
		_tmp15_ = _tmp14_;
		_tmp16_ = _xnoise_item_dup0 (&_tmp15_);
		_tmp17_ = _tmp16_;
		xnoise_item_destroy (&_tmp15_);
		i = _tmp17_;
		_tmp18_ = td;
		_tmp19_ = stmt;
		_tmp20_ = sqlite3_column_text (_tmp19_, 5);
		_tmp21_ = g_strdup (_tmp20_);
		_g_free0 (_tmp18_->artist);
		_tmp18_->artist = _tmp21_;
		_tmp22_ = td;
		_tmp23_ = stmt;
		_tmp24_ = sqlite3_column_text (_tmp23_, 6);
		_tmp25_ = g_strdup (_tmp24_);
		_g_free0 (_tmp22_->album);
		_tmp22_->album = _tmp25_;
		_tmp26_ = td;
		_tmp27_ = stmt;
		_tmp28_ = sqlite3_column_text (_tmp27_, 0);
		_tmp29_ = g_strdup (_tmp28_);
		_g_free0 (_tmp26_->title);
		_tmp26_->title = _tmp29_;
		_tmp30_ = td;
		_tmp31_ = i;
		_tmp32_ = _xnoise_item_dup0 (_tmp31_);
		_xnoise_item_free0 (_tmp30_->item);
		_tmp30_->item = _tmp32_;
		_tmp33_ = td;
		_tmp34_ = stmt;
		_tmp35_ = sqlite3_column_int (_tmp34_, 3);
		_tmp33_->tracknumber = (guint) _tmp35_;
		_tmp36_ = td;
		_tmp37_ = stmt;
		_tmp38_ = sqlite3_column_int (_tmp37_, 7);
		_tmp36_->length = (gint32) _tmp38_;
		_tmp39_ = td;
		_tmp40_ = stmt;
		_tmp41_ = sqlite3_column_text (_tmp40_, 8);
		_tmp42_ = g_strdup (_tmp41_);
		_g_free0 (_tmp39_->genre);
		_tmp39_->genre = _tmp42_;
		_tmp43_ = td;
		_tmp44_ = stmt;
		_tmp45_ = sqlite3_column_int (_tmp44_, 9);
		_tmp43_->year = (guint) _tmp45_;
		_xnoise_item_free0 (i);
	}
	_tmp46_ = td;
	td = NULL;
	result = _tmp46_;
	_xnoise_track_data_unref0 (td);
	_sqlite3_finalize0 (stmt);
	return result;
}


static void _vala_array_add18 (XnoiseItem** array, int* length, int* size, const XnoiseItem* value) {
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (XnoiseItem, *array, *size);
	}
	(*array)[(*length)++] = *value;
}


XnoiseItem* xnoise_database_reader_get_albums_with_search (XnoiseDatabaseReader* self, const gchar* searchtext, gint32 id, int* result_length1) {
	XnoiseItem* result = NULL;
	XnoiseItem* _tmp0_ = NULL;
	XnoiseItem* val;
	gint val_length1;
	gint _val_size_;
	sqlite3_stmt* stmt = NULL;
	const gchar* _tmp1_;
	XnoiseItem* _tmp49_;
	gint _tmp49__length1;
	XnoiseItem* _tmp50_;
	gint _tmp50__length1;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (searchtext != NULL, NULL);
	_tmp0_ = g_new0 (XnoiseItem, 0);
	val = _tmp0_;
	val_length1 = 0;
	_val_size_ = val_length1;
	_tmp1_ = searchtext;
	if (g_strcmp0 (_tmp1_, XNOISE_SERVICES_EMPTYSTRING) != 0) {
		const gchar* _tmp2_;
		gchar* _tmp3_ = NULL;
		gchar* st;
		sqlite3* _tmp4_;
		sqlite3_stmt* _tmp5_ = NULL;
		gboolean _tmp6_ = FALSE;
		gboolean _tmp7_ = FALSE;
		gboolean _tmp8_ = FALSE;
		sqlite3_stmt* _tmp9_;
		gint32 _tmp10_;
		gint _tmp11_ = 0;
		gboolean _tmp17_;
		gboolean _tmp23_;
		gboolean _tmp29_;
		_tmp2_ = searchtext;
		_tmp3_ = g_strdup_printf ("%%%s%%", _tmp2_);
		st = _tmp3_;
		_tmp4_ = self->priv->db;
		sqlite3_prepare_v2 (_tmp4_, XNOISE_DATABASE_READER_STMT_GET_ALBUMS_WITH_SEARCH, -1, &_tmp5_, NULL);
		_sqlite3_finalize0 (stmt);
		stmt = _tmp5_;
		_tmp9_ = stmt;
		_tmp10_ = id;
		_tmp11_ = sqlite3_bind_int (_tmp9_, 1, (gint) _tmp10_);
		if (_tmp11_ != SQLITE_OK) {
			_tmp8_ = TRUE;
		} else {
			sqlite3_stmt* _tmp12_;
			const gchar* _tmp13_;
			gchar* _tmp14_;
			GDestroyNotify _tmp15_;
			gint _tmp16_ = 0;
			_tmp12_ = stmt;
			_tmp13_ = st;
			_tmp14_ = g_strdup (_tmp13_);
			_tmp15_ = g_free;
			_tmp16_ = sqlite3_bind_text (_tmp12_, 2, _tmp14_, -1, _tmp15_);
			_tmp8_ = _tmp16_ != SQLITE_OK;
		}
		_tmp17_ = _tmp8_;
		if (_tmp17_) {
			_tmp7_ = TRUE;
		} else {
			sqlite3_stmt* _tmp18_;
			const gchar* _tmp19_;
			gchar* _tmp20_;
			GDestroyNotify _tmp21_;
			gint _tmp22_ = 0;
			_tmp18_ = stmt;
			_tmp19_ = st;
			_tmp20_ = g_strdup (_tmp19_);
			_tmp21_ = g_free;
			_tmp22_ = sqlite3_bind_text (_tmp18_, 3, _tmp20_, -1, _tmp21_);
			_tmp7_ = _tmp22_ != SQLITE_OK;
		}
		_tmp23_ = _tmp7_;
		if (_tmp23_) {
			_tmp6_ = TRUE;
		} else {
			sqlite3_stmt* _tmp24_;
			const gchar* _tmp25_;
			gchar* _tmp26_;
			GDestroyNotify _tmp27_;
			gint _tmp28_ = 0;
			_tmp24_ = stmt;
			_tmp25_ = st;
			_tmp26_ = g_strdup (_tmp25_);
			_tmp27_ = g_free;
			_tmp28_ = sqlite3_bind_text (_tmp24_, 4, _tmp26_, -1, _tmp27_);
			_tmp6_ = _tmp28_ != SQLITE_OK;
		}
		_tmp29_ = _tmp6_;
		if (_tmp29_) {
			XnoiseItem* _tmp30_;
			gint _tmp30__length1;
			XnoiseItem* _tmp31_;
			gint _tmp31__length1;
			xnoise_database_reader_db_error (self);
			_tmp30_ = val;
			_tmp30__length1 = val_length1;
			val = NULL;
			_tmp31_ = _tmp30_;
			_tmp31__length1 = _tmp30__length1;
			if (result_length1) {
				*result_length1 = _tmp31__length1;
			}
			result = _tmp31_;
			_g_free0 (st);
			_sqlite3_finalize0 (stmt);
			val = (_vala_XnoiseItem_array_free (val, val_length1), NULL);
			return result;
		}
		_g_free0 (st);
	} else {
		sqlite3* _tmp32_;
		sqlite3_stmt* _tmp33_ = NULL;
		sqlite3_stmt* _tmp34_;
		gint32 _tmp35_;
		gint _tmp36_ = 0;
		_tmp32_ = self->priv->db;
		sqlite3_prepare_v2 (_tmp32_, XNOISE_DATABASE_READER_STMT_GET_ALBUMS, -1, &_tmp33_, NULL);
		_sqlite3_finalize0 (stmt);
		stmt = _tmp33_;
		_tmp34_ = stmt;
		_tmp35_ = id;
		_tmp36_ = sqlite3_bind_int (_tmp34_, 1, (gint) _tmp35_);
		if (_tmp36_ != SQLITE_OK) {
			XnoiseItem* _tmp37_;
			gint _tmp37__length1;
			XnoiseItem* _tmp38_;
			gint _tmp38__length1;
			xnoise_database_reader_db_error (self);
			_tmp37_ = val;
			_tmp37__length1 = val_length1;
			val = NULL;
			_tmp38_ = _tmp37_;
			_tmp38__length1 = _tmp37__length1;
			if (result_length1) {
				*result_length1 = _tmp38__length1;
			}
			result = _tmp38_;
			_sqlite3_finalize0 (stmt);
			val = (_vala_XnoiseItem_array_free (val, val_length1), NULL);
			return result;
		}
	}
	while (TRUE) {
		sqlite3_stmt* _tmp39_;
		gint _tmp40_ = 0;
		sqlite3_stmt* _tmp41_;
		gint _tmp42_ = 0;
		XnoiseItem i = {0};
		sqlite3_stmt* _tmp43_;
		const gchar* _tmp44_ = NULL;
		gchar* _tmp45_;
		XnoiseItem* _tmp46_;
		gint _tmp46__length1;
		XnoiseItem _tmp47_;
		XnoiseItem _tmp48_ = {0};
		_tmp39_ = stmt;
		_tmp40_ = sqlite3_step (_tmp39_);
		if (!(_tmp40_ == SQLITE_ROW)) {
			break;
		}
		_tmp41_ = stmt;
		_tmp42_ = sqlite3_column_int (_tmp41_, 1);
		xnoise_item_init (&i, XNOISE_ITEM_TYPE_COLLECTION_CONTAINER_ALBUM, NULL, (gint32) _tmp42_);
		_tmp43_ = stmt;
		_tmp44_ = sqlite3_column_text (_tmp43_, 0);
		_tmp45_ = g_strdup (_tmp44_);
		_g_free0 (i.text);
		i.text = _tmp45_;
		_tmp46_ = val;
		_tmp46__length1 = val_length1;
		_tmp47_ = i;
		xnoise_item_copy (&_tmp47_, &_tmp48_);
		_vala_array_add18 (&val, &val_length1, &_val_size_, &_tmp48_);
		xnoise_item_destroy (&i);
	}
	_tmp49_ = val;
	_tmp49__length1 = val_length1;
	val = NULL;
	_tmp50_ = _tmp49_;
	_tmp50__length1 = _tmp49__length1;
	if (result_length1) {
		*result_length1 = _tmp50__length1;
	}
	result = _tmp50_;
	_sqlite3_finalize0 (stmt);
	val = (_vala_XnoiseItem_array_free (val, val_length1), NULL);
	return result;
}


static void xnoise_database_value_reader_init (GValue* value) {
	value->data[0].v_pointer = NULL;
}


static void xnoise_database_value_reader_free_value (GValue* value) {
	if (value->data[0].v_pointer) {
		xnoise_database_reader_unref (value->data[0].v_pointer);
	}
}


static void xnoise_database_value_reader_copy_value (const GValue* src_value, GValue* dest_value) {
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = xnoise_database_reader_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}


static gpointer xnoise_database_value_reader_peek_pointer (const GValue* value) {
	return value->data[0].v_pointer;
}


static gchar* xnoise_database_value_reader_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	if (collect_values[0].v_pointer) {
		XnoiseDatabaseReader* object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = xnoise_database_reader_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}


static gchar* xnoise_database_value_reader_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	XnoiseDatabaseReader** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = xnoise_database_reader_ref (value->data[0].v_pointer);
	}
	return NULL;
}


GParamSpec* xnoise_database_param_spec_reader (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	XnoiseDatabaseParamSpecReader* spec;
	g_return_val_if_fail (g_type_is_a (object_type, XNOISE_DATABASE_TYPE_READER), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}


gpointer xnoise_database_value_get_reader (const GValue* value) {
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, XNOISE_DATABASE_TYPE_READER), NULL);
	return value->data[0].v_pointer;
}


void xnoise_database_value_set_reader (GValue* value, gpointer v_object) {
	XnoiseDatabaseReader* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, XNOISE_DATABASE_TYPE_READER));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, XNOISE_DATABASE_TYPE_READER));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		xnoise_database_reader_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		xnoise_database_reader_unref (old);
	}
}


void xnoise_database_value_take_reader (GValue* value, gpointer v_object) {
	XnoiseDatabaseReader* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, XNOISE_DATABASE_TYPE_READER));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, XNOISE_DATABASE_TYPE_READER));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		xnoise_database_reader_unref (old);
	}
}


static void xnoise_database_reader_class_init (XnoiseDatabaseReaderClass * klass) {
	xnoise_database_reader_parent_class = g_type_class_peek_parent (klass);
	XNOISE_DATABASE_READER_CLASS (klass)->finalize = xnoise_database_reader_finalize;
	g_type_class_add_private (klass, sizeof (XnoiseDatabaseReaderPrivate));
}


static void xnoise_database_reader_instance_init (XnoiseDatabaseReader * self) {
	self->priv = XNOISE_DATABASE_READER_GET_PRIVATE (self);
	self->priv->abort = FALSE;
	self->ref_count = 1;
}


static void xnoise_database_reader_finalize (XnoiseDatabaseReader* obj) {
	XnoiseDatabaseReader * self;
	self = XNOISE_DATABASE_READER (obj);
	_g_free0 (self->priv->DATABASE);
	_sqlite3_close0 (self->priv->db);
	_sqlite3_finalize0 (self->priv->get_artists_with_search_stmt);
	_sqlite3_finalize0 (self->priv->get_artists_with_search2_stmt);
}


GType xnoise_database_reader_get_type (void) {
	static volatile gsize xnoise_database_reader_type_id__volatile = 0;
	if (g_once_init_enter (&xnoise_database_reader_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { xnoise_database_value_reader_init, xnoise_database_value_reader_free_value, xnoise_database_value_reader_copy_value, xnoise_database_value_reader_peek_pointer, "p", xnoise_database_value_reader_collect_value, "p", xnoise_database_value_reader_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (XnoiseDatabaseReaderClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) xnoise_database_reader_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (XnoiseDatabaseReader), 0, (GInstanceInitFunc) xnoise_database_reader_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType xnoise_database_reader_type_id;
		xnoise_database_reader_type_id = g_type_register_fundamental (g_type_fundamental_next (), "XnoiseDatabaseReader", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&xnoise_database_reader_type_id__volatile, xnoise_database_reader_type_id);
	}
	return xnoise_database_reader_type_id__volatile;
}


gpointer xnoise_database_reader_ref (gpointer instance) {
	XnoiseDatabaseReader* self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}


void xnoise_database_reader_unref (gpointer instance) {
	XnoiseDatabaseReader* self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		XNOISE_DATABASE_READER_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}



